--*****************************************************************************
--                Deathmatch 4
--Both teams start with lots of buildings but with no weapons. There
--are a few neutral weapons factories positioned on the map that each
--team needs to tke control of. Added difficulty comes in the positioning
--of the strongholds which will force each team to perform lob shots with 
--anything they can use. Strike weapons will be rare but powerful if collected.
--*****************************************************************************

function InitialiseLevel()
    LoadLevel("landscapes/DM/DM04.xom",true) 

	scheme = GetCurrentSchemeData()

	scheme.OverrideInventory = false
	scheme.WormSelectMode = false
    
    scheme.SuddenDeathMode = "kWeaponSuperBazooka"

	scheme.HealthInCrates = 50
	scheme.CrateProbability = 75

	scheme.TurnTime = 6000
	scheme.SuddenDeathTime = 180000
	scheme.RetreatTime = 500
	scheme.HotSeatTime = 500

	scheme.WeaponProbability   = 90
	scheme.BuildingProbability = 10
	scheme.UtilityProbability   = 10
	scheme.HealthProbability   = 10

	scheme.Bazooka.Crate = 1
	scheme.Bazooka.Delay    = 0

	scheme.Mortar.Crate    = 1
	scheme.Mortar.Delay    = 0

	scheme.FireWeapon.Crate    = 1
	scheme.FireWeapon.Delay    = 0

	scheme.HomingPigeon.Crate    = 0
	scheme.HomingPigeon.Delay    = 0

	scheme.RocketLauncher.Crate    = 1
	scheme.RocketLauncher.Delay    = 0

	scheme.Grenade.Crate    = 1
	scheme.Grenade.Delay    = 0

	scheme.ClusterLauncher.Crate    = 1
	scheme.ClusterLauncher.Delay    = 0

	scheme.FireGrenadeLauncher.Crate    = 1
	scheme.FireGrenadeLauncher.Delay    = 0

	scheme.BananaBombLauncher.Crate     = 1
	scheme.BananaBombLauncher.Delay     = 0

	scheme.Trebuchet.Crate     = 0
	scheme.Trebuchet.Delay     = 0

	scheme.Canary.Crate     = 0
	scheme.Canary.Delay     = 0

	scheme.OldLady.Crate     = 1
	scheme.OldLady.Delay     = 0

	scheme.BatteringRam.Crate     = 1
	scheme.BatteringRam.Delay     = 0

	scheme.SuperHippo.Crate     = 1
	scheme.SuperHippo.Delay     = 0

	scheme.MonkeyHerd.Crate     = 1
	scheme.MonkeyHerd.Delay     = 0

	scheme.AirStrike.Crate     = 1
	scheme.AirStrike.Delay     = 0

	scheme.NapalmStrike.Crate     = 0
	scheme.NapalmStrike.Delay     = 0

	scheme.MineStrike.Crate     = 1
	scheme.MineStrike.Delay     = 0

	scheme.AnimalStrike.Ammo      = 0
	scheme.AnimalStrike.Crate     = 0

	scheme.TrojanDonkey.Crate     = 0
	scheme.TrojanDonkey.Delay     = 0

	scheme.ElectricalStorm.Crate	= 1
	scheme.ElectricalStorm.Delay	= 0

	scheme.Earthquake.Crate     = 0
	scheme.Earthquake.Delay     = 0

	scheme.Flood.Crate     = 1
	scheme.Flood.Delay     = 0

	scheme.NuclearStrike.Crate     = 0
	scheme.NuclearStrike.Delay     = 0

	scheme.Armageddon.Crate     = 0
	scheme.Armageddon.Delay     = 0

	scheme.FirePunch.Crate     = 0
	scheme.FirePunch.Delay     = 0

	scheme.Ballista.Crate     = 1
	scheme.Ballista.Delay     = 0

	scheme.MiniGun.Crate     = 0
	scheme.MiniGun.Delay     = 0

	scheme.GiantCrossbow.Crate     = 1
	scheme.GiantCrossbow.Delay     = 0

	scheme.GiantLaser.Crate     = 0
	scheme.GiantLaser.Delay     = 0

	scheme.Tower.Crate = 0
	scheme.Tower.Delay  = 0

	scheme.Keep.Crate   = 0
	scheme.Keep.Delay  = 0

	scheme.Castle.Crate   = 0
	scheme.Castle.Delay  = 0

	scheme.Citadel.Crate   = 0
	scheme.Citadel.Delay  = 0

	scheme.Hospital.Crate   = 0
	scheme.Hospital.Delay  = 0

	scheme.Refinery.Crate   = 1
	scheme.Refinery.Delay  = 0

	scheme.ScienceLab.Crate   = 0
	scheme.ScienceLab.Delay  = 0

	scheme.Wonder.Crate   = 0
	scheme.Wonder.Delay  = 0

	scheme.Jetpack.Crate     = 0
	scheme.Jetpack.Delay     = 0

	scheme.Freeze.Crate     = 0
	scheme.Freeze.Delay     = 0

	scheme.WormSelect.Crate     = 0
	scheme.WormSelect.Delay     = 0

	scheme.Parachute.Crate     = 0
	scheme.Parachute.Delay     = 0

	scheme.Girder.Crate     = 1
	scheme.Girder.Delay     = 0

	scheme.RepairBuilding.Crate     = 1
	scheme.RepairBuilding.Delay     = 0

	scheme.SpawnWorm.Crate     = 0
	scheme.SpawnWorm.Delay     = 0

	scheme.SkipGo.Crate     = 0
	scheme.SkipGo.Delay     = 0

	scheme.Suicide.Crate     = 0
	scheme.Suicide.Delay     = 0

	scheme.Surrender.Crate     = 0
	scheme.Surrender.Delay     = 0

	scheme.DoubleDamageCrate	= 0
	scheme.DoubleTimeCrate		= 0
	scheme.CrateShowerCrate		= 1
	scheme.CrateSpyCrate		= 1

	scheme.NumRandomOilDrums = 0
	scheme.NumRandomMines = 0
	
	
end

function HideWormsNow()

	--Create Player Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0018", false )


	--Create Enemy Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0053", false )
	
	--Create Enemy Refinery--
	CreateBuilding( kWF_BUILDING_REFINERY, 1, "buildHere0045" )
	
	--Create Neutral Refineries--
	CreateBuilding( kWF_BUILDING_REFINERY, 4, "buildHere0068" )
	CreateBuilding( kWF_BUILDING_REFINERY, 4, "buildHere0056" )	
	CreateBuilding( kWF_BUILDING_REFINERY, 4, "buildHere0083" )
	CreateBuilding( kWF_BUILDING_REFINERY, 4, "buildHere0034" )

	
	FlushCommentaryText()
	
	
	--DetailObject Birdy01 code--
	PlayDetailObjectAnimation("orientalbird01", "path1", true)
 	PlayDetailObjectAnimation("orientalbird01", "flap", true)
	
	--DetailObject Birdy02 code--
	PlayDetailObjectAnimation("orientalbird02", "path1", true)
 	PlayDetailObjectAnimation("orientalbird02", "flap", true)
	
end




function CreatePlayers()

	-- Team 0, Player controlled worms
	SetupHumanPlayer(3,100)


	GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRefPlayerWorm1"
	GetWormData(player.PlayerIndex,1).SpawnPointName ="wfRefPlayerWorm2"
	GetWormData(player.PlayerIndex,2).SpawnPointName ="wfRefPlayerWorm3"



	
	player = CreatePlayer("AI")
	player.NumberOfWorms = 5
	player.Name = "Gardeners"
	player.ResourcePoints = 16
	player.Handicap = 1
	player.WormStartingHealth = 100
	player.VoiceBank = "Profssr"
	player.Flag = 63
    
    player = GetPlayerData(1)
    player.TeamTombstone = 13
    
	CreatePlayersTeam(player.PlayerIndex)
	StandardWorm(GetWormData(player.PlayerIndex,0),"Hangetsu","wfRefEnemyWorm1")
	StandardWorm(GetWormData(player.PlayerIndex,1),"Sanseru","wfRefEnemyWorm2")
	StandardWorm(GetWormData(player.PlayerIndex,2),"Sepai","wfRefEnemyWorm3")
	StandardWorm(GetWormData(player.PlayerIndex,3),"Saifa","wfRefEnemyWorm4")
	StandardWorm(GetWormData(player.PlayerIndex,4),"Seiunchin","wfRefEnemyWorm5")
	
	CopyContainer( GetAIParamsCPU3(), GetAIParamsWorm(3) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(4) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(5) )
	GetAIParamsWorm(6).WeightingAttackBuildingTypeStrongHold = 100
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(6) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(7) )	
    
	--Change Hats--
	Worm = GetWormData(3) 
	Worm.HatOverride = "Hat.Oriental1" 
	Worm = GetWormData(4) 
	Worm.HatOverride = "Hat.Oriental1" 
	Worm = GetWormData(5) 
	Worm.HatOverride = "Hat.Oriental1"     
	Worm = GetWormData(6) 
	Worm.HatOverride = "Hat.Oriental1"  
	Worm = GetWormData(7) 
	Worm.HatOverride = "Hat.Oriental1"  


	---------------------------
	--Sets up the inventories--
	---------------------------
    
	--Player Inventory
    
	EmptyInventory(0)
	inventory = GetPlayerInventory(0)
    
	inventory.Tower = 15
	inventory.Keep = 8
	inventory.Castle = 4
	inventory.Citadel = 2
	inventory.Hospital = 1

    
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.WormSelect = 3
	inventory.RepairBuilding = 1
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
  

	--AI inventory
	EmptyInventory(1)
	inventory = GetPlayerInventory(1)
   
	inventory.Tower = 15
	inventory.Keep = 8
	inventory.Castle = 4
	inventory.Citadel = 2
	inventory.Hospital = 1
    
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.RepairBuilding = 1
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
 
    
	

	referee = GetRefereeData()
	referee.TurnCounter = 0
	referee.WindDirection = 0
	referee.WindDirectionVariance = 180.0
	referee.WindStrengthMinimum = 0.0
	referee.WindStrengthVariance = 10.0
--	referee.SuspendTimer = true;

end

function RoundIsComingToAnEnd()

	referee = GetRefereeData()

	if referee.WinningPlayer == 0 then

		EndRound(0)
		Unlock("LOCK.Deathmatch.05")
		Unlock("LOCK.Fortapedia.PointandClick")  
	else
                
		EndRound(1)

    end
end


