--*******************************************************************************
--                           Deathmatch 5
--Enemy AI has been tweaked so that it builds and then attack
--worms. Player has got to keep his two worms alive or use the hospital 
--and spawn worm utility to stay in the game.
--Crate drops are hospitals, spawn worms and girders however they drop sparingly.
--Weapons can only be replenished through a weapons factory so the protection
--of this building is also key.
--*******************************************************************************

function InitialiseLevel()
	LoadLevel("landscapes/DM/DM05.xom",true) 

	scheme = GetCurrentSchemeData()

	scheme.OverrideInventory = false
	scheme.WormSelectMode = false
    
    scheme.SuddenDeathMode = "kWeaponSuperBazooka"

	scheme.HealthInCrates = 50
	scheme.CrateProbability = 50

	scheme.TurnTime = 6000
	scheme.SuddenDeathTime = 180000
	scheme.RetreatTime = 500
	scheme.HotSeatTime = 500

	scheme.WeaponProbability   = 0
	scheme.BuildingProbability = 25
	scheme.UtilityProbability   = 25
	scheme.HealthProbability   = 25

	scheme.Bazooka.Crate = 0
	scheme.Bazooka.Delay    = 0

	scheme.Mortar.Crate    = 1
	scheme.Mortar.Delay    = 0

	scheme.FireWeapon.Crate    = 0
	scheme.FireWeapon.Delay    = 0

	scheme.HomingPigeon.Crate    = 0
	scheme.HomingPigeon.Delay    = 0

	scheme.RocketLauncher.Crate    = 0
	scheme.RocketLauncher.Delay    = 0

	scheme.Grenade.Crate    = 0
	scheme.Grenade.Delay    = 0

	scheme.ClusterLauncher.Crate    = 1
	scheme.ClusterLauncher.Delay    = 0

	scheme.FireGrenadeLauncher.Crate    = 1
	scheme.FireGrenadeLauncher.Delay    = 0

	scheme.BananaBombLauncher.Crate     = 0
	scheme.BananaBombLauncher.Delay     = 0

	scheme.Trebuchet.Crate     = 0
	scheme.Trebuchet.Delay     = 0

	scheme.Canary.Crate     = 0
	scheme.Canary.Delay     = 0

	scheme.OldLady.Crate     = 0
	scheme.OldLady.Delay     = 0

	scheme.BatteringRam.Crate     = 0
	scheme.BatteringRam.Delay     = 0

	scheme.SuperHippo.Crate     = 0
	scheme.SuperHippo.Delay     = 0

	scheme.MonkeyHerd.Crate     = 0
	scheme.MonkeyHerd.Delay     = 0

	scheme.AirStrike.Crate     = 0
	scheme.AirStrike.Delay     = 0

	scheme.NapalmStrike.Crate     = 0
	scheme.NapalmStrike.Delay     = 0

	scheme.MineStrike.Crate     = 1
	scheme.MineStrike.Delay     = 0

	scheme.AnimalStrike.Crate     = 1
	scheme.AnimalStrike.Delay     = 0

	scheme.TrojanDonkey.Crate     = 0
	scheme.TrojanDonkey.Delay     = 0

	scheme.ElectricalStorm.Crate	= 1
	scheme.ElectricalStorm.Delay	= 0

	scheme.Earthquake.Crate     = 0
	scheme.Earthquake.Delay     = 0

	scheme.Flood.Crate     = 0
	scheme.Flood.Delay     = 0

	scheme.NuclearStrike.Crate     = 0
	scheme.NuclearStrike.Delay     = 0

	scheme.Armageddon.Crate     = 0
	scheme.Armageddon.Delay     = 0

	scheme.FirePunch.Crate     = 0
	scheme.FirePunch.Delay     = 0

	scheme.Ballista.Crate     = 1
	scheme.Ballista.Delay     = 0

	scheme.MiniGun.Crate     = 0
	scheme.MiniGun.Delay     = 0

	scheme.GiantCrossbow.Crate     = 1
	scheme.GiantCrossbow.Delay     = 0

	scheme.GiantLaser.Crate     = 0
	scheme.GiantLaser.Delay     = 0

	scheme.Tower.Crate = 0
	scheme.Tower.Delay  = 0

	scheme.Keep.Crate   = 0
	scheme.Keep.Delay  = 0

	scheme.Castle.Crate   = 0
	scheme.Castle.Delay  = 0

	scheme.Citadel.Crate   = 0
	scheme.Citadel.Delay  = 0
	
	scheme.Hospital.Crate   = 1
	scheme.Hospital.Delay  = 0

	scheme.Refinery.Crate   = 0
	scheme.Refinery.Delay  = 0

	scheme.ScienceLab.Crate   = 0
	scheme.ScienceLab.Delay  = 0

	scheme.Jetpack.Crate     = 0
	scheme.Jetpack.Delay     = 0

	scheme.Freeze.Crate     = 0
	scheme.Freeze.Delay     = 0

	scheme.WormSelect.Crate     = 0
	scheme.WormSelect.Delay     = 0

	scheme.Parachute.Crate     = 0
	scheme.Parachute.Delay     = 0

	scheme.Girder.Crate     = 1
	scheme.Girder.Delay     = 0

	scheme.RepairBuilding.Crate     = 0
	scheme.RepairBuilding.Delay     = 0

	scheme.SpawnWorm.Crate     = 1
	scheme.SpawnWorm.Delay     = 0

	scheme.SkipGo.Crate     = 0
	scheme.SkipGo.Delay     = 0

	scheme.Suicide.Crate     = 0
	scheme.Suicide.Delay     = 0

	scheme.Surrender.Crate     = 0
	scheme.Surrender.Delay     = 0

	scheme.DoubleDamageCrate	= 0
	scheme.DoubleTimeCrate		= 0
	scheme.CrateShowerCrate		= 0
	scheme.CrateSpyCrate		= 0	
	
	
	scheme.NumRandomOilDrums = 0
	scheme.NumRandomMines = 0
end

function HideWormsNow()

	--Create Player Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0051", false )


	--Create Enemy Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0059", false )

	
	--Create Enemy Buildings--
	CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0064" )
	CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0081" )
	CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0074" )
	CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0076" )
	CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0060" )
	CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0078" )
	CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0075" )
	CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0077" )
	
	FlushCommentaryText()
	
end


function CreatePlayers()
	
	-- Team 0, Player controlled worms
	SetupHumanPlayer(2,100)



	GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRefPlayerWorm1"
	GetWormData(player.PlayerIndex,1).SpawnPointName ="wfRefPlayerWorm2"
	



	
	player = CreatePlayer("AI")
	player.NumberOfWorms = 4
	player.Name = "Samurai"
	player.ResourcePoints = 16
	player.Handicap = 1
	player.WormStartingHealth = 100
	player.VoiceBank = "Classic"
    
    
    player = GetPlayerData(1)
    player.TeamTombstone = 13
    
	CreatePlayersTeam(player.PlayerIndex)
	StandardWorm(GetWormData(player.PlayerIndex,0),"Teisho","wfRefEnemyWorm1")
	StandardWorm(GetWormData(player.PlayerIndex,1),"Dachi","wfRefEnemyWorm2")
	StandardWorm(GetWormData(player.PlayerIndex,2),"Zenkutsu","wfRefEnemyWorm3")
	StandardWorm(GetWormData(player.PlayerIndex,3),"Gedan","wfRefEnemyWorm4")

	
	CopyContainer( GetAIParamsCPU4(), GetAIParamsWorm(2) )
	GetAIParamsWorm(4).WeightingAttackWorm = 300
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(3) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(4) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(5) )
	
	--Change hats
	Worm = GetWormData(2) 
	Worm.HatOverride = "Hat.Oriental3" 
	Worm = GetWormData(3) 
	Worm.HatOverride = "Hat.Oriental3" 
	Worm = GetWormData(4) 
	Worm.HatOverride = "Hat.Oriental3" 
	Worm = GetWormData(5) 
	Worm.HatOverride = "Hat.Oriental3" 




	---------------------------
	--Sets up the inventories--
	---------------------------
    
	--Player Inventory
    
	EmptyInventory(0)
	inventory = GetPlayerInventory(0)
	inventory.Bazooka = kWF_INFINITE_AMOUNT    
	inventory.Grenade = kWF_INFINITE_AMOUNT    
	inventory.FirePunch = kWF_INFINITE_AMOUNT 
	inventory.AirStrike = 1 
    
  
	inventory.Mortar = 6   
	inventory.ClusterLauncher = 6
	inventory.Ballista = 4
    
	inventory.FireWeapon = 2
	inventory.FireGrenadeLauncher = 1
	inventory.MiniGun = 1
    
	inventory.BananaBombLauncher = 1
	inventory.GiantCrossbow = 1
    
	inventory.RocketLauncher = 1    
    
	inventory.Tower = 8
	inventory.Keep = 4
	inventory.Castle = 2
	inventory.Citadel = 1
	inventory.Hospital = 1
	inventory.Refinery = 1
    
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
    
 
	--Delays
	inventory.AirStrikeDelay = 3
 
  

	--AI inventory
	EmptyInventory(1)
	inventory = GetPlayerInventory(1)
	inventory.Bazooka = kWF_INFINITE_AMOUNT    
	inventory.Grenade = kWF_INFINITE_AMOUNT    
	inventory.FirePunch = kWF_INFINITE_AMOUNT 
	inventory.ElectricalStorm = 1 
  
	inventory.ClusterLauncher = 4
	inventory.Ballista = 4

	inventory.FireGrenadeLauncher = 2
	inventory.MiniGun = 1
    
	inventory.NuclearStrike = 1
    
	inventory.RocketLauncher = 1
   
	inventory.Tower = 8
	inventory.Keep = 4
	inventory.Hospital = 1
	inventory.Refinery = 2
    
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
    
	--Delays
	inventory.NuclearStrikeDelay = 8
	inventory.RocketLauncherDelay = 7

	
	

	referee = GetRefereeData()
	referee.TurnCounter = 0
	referee.WindDirection = 0
	referee.WindDirectionVariance = 180.0
	referee.WindStrengthMinimum = 0.0
	referee.WindStrengthVariance = 10.0
--	referee.SuspendTimer = true;

end

function RoundIsComingToAnEnd()

	referee = GetRefereeData()

	if referee.WinningPlayer == 0 then

		EndRound(0)
        Unlock("LOCK.Deathmatch.06")
        Unlock("LOCK.Flag.Custom1")    
	else
                
		EndRound(1)

	end
end

