--***********************************************************
--                Deathmatch 10 (description here)
--Hardcore Deathmatch. Player starts with cluster launchers and a decent base
--however it is weakly linked to his stronghold. He must use crate drops to strengthen the link before the enemy 
--wipes it out. Meanwhile he must also seek to destroy one of the enemy strongholds as doing this will stop them from being able
--to build a citadel and therefore pull out the big weapons. They do however have a back up of a neutral citadel near there base 
--that the player must also plan to destroy if they want any chance. 
--***********************************************************

function InitialiseLevel()
	LoadLevel("landscapes/DM/DM10.xom",true) 

	scheme = GetCurrentSchemeData()

	scheme.OverrideInventory = false
	scheme.WormSelectMode = false
    
    scheme.SuddenDeathMode = "kWeaponSuperBazooka"

	scheme.HealthInCrates = 50
	scheme.CrateProbability = 50

	scheme.TurnTime = 6000
	scheme.SuddenDeathTime = 180000
	scheme.RetreatTime = 500
	scheme.HotSeatTime = 500

	scheme.WeaponProbability   = 0
	scheme.BuildingProbability = 75
	scheme.UtilityProbability   = 25
	scheme.HealthProbability   = 0

	scheme.Bazooka.Crate = 0
	scheme.Bazooka.Delay    = 0

	scheme.Mortar.Crate    = 1
	scheme.Mortar.Delay    = 0

	scheme.FireWeapon.Crate    = 1
	scheme.FireWeapon.Delay    = 0

	scheme.HomingPigeon.Crate    = 0
	scheme.HomingPigeon.Delay    = 0

	scheme.RocketLauncher.Crate    = 0
	scheme.RocketLauncher.Delay    = 0

	scheme.Grenade.Crate    = 0
	scheme.Grenade.Delay    = 0

	scheme.ClusterLauncher.Crate    = 0
	scheme.ClusterLauncher.Delay    = 0

	scheme.FireGrenadeLauncher.Crate    = 1
	scheme.FireGrenadeLauncher.Delay    = 0

	scheme.BananaBombLauncher.Crate     = 1
	scheme.BananaBombLauncher.Delay     = 0

	scheme.Trebuchet.Crate     = 0
	scheme.Trebuchet.Delay     = 0

	scheme.Canary.Crate     = 1
	scheme.Canary.Delay     = 0

	scheme.OldLady.Crate     = 1
	scheme.OldLady.Delay     = 0

	scheme.BatteringRam.Crate     = 1
	scheme.BatteringRam.Delay     = 0

	scheme.SuperHippo.Crate     = 0
	scheme.SuperHippo.Delay     = 0

	scheme.MonkeyHerd.Crate     = 0
	scheme.MonkeyHerd.Delay     = 0

	scheme.AirStrike.Crate     = 0
	scheme.AirStrike.Delay     = 0

	scheme.NapalmStrike.Crate     = 1
	scheme.NapalmStrike.Delay     = 0

	scheme.MineStrike.Crate     = 1
	scheme.MineStrike.Delay     = 0

	scheme.AnimalStrike.Crate     = 1
	scheme.AnimalStrike.Delay     = 0

	scheme.TrojanDonkey.Crate     = 0
	scheme.TrojanDonkey.Delay     = 0

	scheme.ElectricalStorm.Crate	= 1
	scheme.ElectricalStorm.Delay	= 0

	scheme.Earthquake.Crate     = 0
	scheme.Earthquake.Delay     = 0

	scheme.Flood.Crate     = 0
	scheme.Flood.Delay     = 0

	scheme.NuclearStrike.Crate     = 0
	scheme.NuclearStrike.Delay     = 0

	scheme.Armageddon.Crate     = 0
	scheme.Armageddon.Delay     = 0

	scheme.FirePunch.Crate     = 0
	scheme.FirePunch.Delay     = 0

	scheme.Ballista.Crate     = 1
	scheme.Ballista.Delay     = 0

	scheme.MiniGun.Crate     = 1
	scheme.MiniGun.Delay     = 0

	scheme.GiantCrossbow.Crate     = 1
	scheme.GiantCrossbow.Delay     = 0

	scheme.GiantLaser.Crate     = 0
	scheme.GiantLaser.Delay     = 0

	scheme.Tower.Crate = 1
	scheme.Tower.Delay  = 0

	scheme.Keep.Crate   = 1
	scheme.Keep.Delay  = 0

	scheme.Castle.Crate   = 0
	scheme.Castle.Delay  = 0

	scheme.Citadel.Crate   = 0
	scheme.Citadel.Delay  = 0
	
	scheme.Hospital.Crate   = 0
	scheme.Hospital.Delay  = 0

	scheme.Refinery.Crate   = 1
	scheme.Refinery.Delay  = 0

	scheme.ScienceLab.Crate   = 0
	scheme.ScienceLab.Delay  = 0

	scheme.Jetpack.Crate     = 0
	scheme.Jetpack.Delay     = 0

	scheme.Freeze.Crate     = 0
	scheme.Freeze.Delay     = 0

	scheme.WormSelect.Crate     = 0
	scheme.WormSelect.Delay     = 0

	scheme.Parachute.Crate     = 0
	scheme.Parachute.Delay     = 0

	scheme.Girder.Crate     = 1
	scheme.Girder.Delay     = 0

	scheme.RepairBuilding.Crate     = 1
	scheme.RepairBuilding.Delay     = 0

	scheme.SpawnWorm.Crate     = 0
	scheme.SpawnWorm.Delay     = 0

	scheme.SkipGo.Crate     = 0
	scheme.SkipGo.Delay     = 0

	scheme.Suicide.Crate     = 0
	scheme.Suicide.Delay     = 0

	scheme.Surrender.Crate     = 0
	scheme.Surrender.Delay     = 0

	scheme.DoubleDamageCrate	= 0
	scheme.DoubleTimeCrate		= 1
	scheme.CrateShowerCrate		= 0
	scheme.CrateSpyCrate		= 0
	
	scheme.NumRandomOilDrums = 0
	scheme.NumRandomMines = 0	
	

end

function HideWormsNow()

	--Create Player Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0014", false )

	CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0012" )
	CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0010" )
	CreateBuilding( kWF_BUILDING_CASTLE, 0, "buildHere009" )
	CreateBuilding( kWF_BUILDING_KEEP, 0, "buildHere003" )
	CreateBuilding( kWF_BUILDING_REFINERY, 0, "buildHere008" )
	CreateBuilding( kWF_BUILDING_HOSPITAL, 0, "buildHere0044" )
	CreateBuilding( kWF_BUILDING_KEEP, 0, "buildHere0017" )
	CreateBuilding( kWF_BUILDING_CASTLE, 0, "buildHere007" )
	CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere004" )
	CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0013" )
	
	--Create Enemy Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0023", false )
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0033", false )
	
	--The Science Lab--
	CreateBuilding( kWF_BUILDING_SCIENCE_LAB, 4, "buildHere0046" )
	
	--The Citadel--
	CreateBuilding( kWF_BUILDING_CITADEL, 4, "buildHere0040" )


	stronghold = GetBuildingData( "buildHere0023" )

	stronghold.VitalBuilding = false

	stronghold = GetBuildingData( "buildHere0033" )

	stronghold.VitalBuilding = false
    
	FlushCommentaryText()
end


function CreatePlayers()
	
	-- Team 0, Player controlled worms
	SetupHumanPlayer(3,100)



	GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRefPlayerWorm1"
	GetWormData(player.PlayerIndex,1).SpawnPointName ="wfRefPlayerWorm2"
	GetWormData(player.PlayerIndex,2).SpawnPointName ="wfRefPlayerWorm3"
	


	
	player = CreatePlayer("AI")
	player.NumberOfWorms = 5
	player.Name = "Legion"
	player.WormStartingHealth = 100
	player.VoiceBank = "Classic"
    
    player = GetPlayerData(1)
    player.TeamTombstone = 6
    
	CreatePlayersTeam(player.PlayerIndex)
	StandardWorm(GetWormData(player.PlayerIndex,0),"Kronos","wfRefEnemyWorm1")
	StandardWorm(GetWormData(player.PlayerIndex,1),"Artemis","wfRefEnemyWorm2")
	StandardWorm(GetWormData(player.PlayerIndex,2),"Furiae","wfRefEnemyWorm3")
	StandardWorm(GetWormData(player.PlayerIndex,3),"Vesta","wfRefEnemyWorm4")
	StandardWorm(GetWormData(player.PlayerIndex,4),"Scipio","wfRefEnemyWorm5")

	
        CopyContainer( GetAIParamsCPU4(), GetAIParamsWorm(3) )
        CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(4) )
        CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(5) )
        CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(6) )
        CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(7) )
	
	--Change Hats--
	Worm = GetWormData(3) 
	Worm.HatOverride = "Hat.Roman3"
	Worm = GetWormData(4) 
	Worm.HatOverride = "Hat.Roman3"
	Worm = GetWormData(5) 
	Worm.HatOverride = "Hat.Roman3"
	Worm = GetWormData(6) 
	Worm.HatOverride = "Hat.Roman3"
	Worm = GetWormData(7) 
	Worm.HatOverride = "Hat.Roman3"
	
	---------------------------
	--Sets up the inventories--
	---------------------------
    
	--Player Inventory
    
	EmptyInventory(0)
	inventory = GetPlayerInventory(0)
	inventory.Bazooka = kWF_INFINITE_AMOUNT    
	inventory.Grenade = kWF_INFINITE_AMOUNT    
	inventory.FirePunch = kWF_INFINITE_AMOUNT 
	inventory.AirStrike = 1 
    
	inventory.ClusterLauncher = 6
     
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
    
 
	--Delays
	inventory.AirStrikeDelay = 3
	inventory.NapalmStrikeDelay = 4
	inventory.AnimalStrikeDelay = 6
	inventory.BananaBombLauncherDelay = 6
        inventory.MineStrikeDelay = 4
	inventory.GiantCrossbowDelay = 6
  

	--AI inventory
	EmptyInventory(1)
	inventory = GetPlayerInventory(1)
	inventory.Bazooka = kWF_INFINITE_AMOUNT    
	inventory.Grenade = kWF_INFINITE_AMOUNT    
	inventory.FirePunch = kWF_INFINITE_AMOUNT 
	inventory.ElectricalStorm = 1 
  
	inventory.Mortar = 2
	inventory.ClusterLauncher = 4
	inventory.OldLady = 1
	inventory.NapalmStrike = 1
	
	inventory.FireWeapon = 2
	inventory.FireGrenadeLauncher = 2
	inventory.BatteringRam = 1
	inventory.MineStrike = 1
	
	inventory.BananaBombLauncher = 1
	inventory.GiantCrossbow = 1
	
	inventory.MonkeyHerd = 1
	inventory.Armageddon = 1	
   
	inventory.Tower = 8
	inventory.Keep = 4
	inventory.Castle = 2
	inventory.Citadel = 1
	inventory.Hospital = 1
	inventory.Refinery = 2
	inventory.ScienceLab = 1
    
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
    
	--Delays

	
	
      
	referee = GetRefereeData()
	referee.TurnCounter = 0
	referee.WindDirection = 0
	referee.WindDirectionVariance = 180.0
	referee.WindStrengthMinimum = 0.0
	referee.WindStrengthVariance = 10.0
--	referee.SuspendTimer = true;

end

function RoundIsComingToAnEnd()

	referee = GetRefereeData()

	if referee.WinningPlayer == 0 then

		EndRound(0)
		Unlock("LOCK.Weapon.Armageddon")
		Unlock("LOCK.Fortapedia.Armageddon") 
	else
                
		EndRound(1)

	end
end
