--***********************************************************
--                Attract mode level
-- need to put /SEED:TIME in the command line to generate random number
--***********************************************************

function InitialiseLevel()
    LoadLevel("landscapes/E3/E3Demo.xom",true) 

	scheme = GetCurrentSchemeData()

    scheme.OverrideInventory = false
    scheme.WormSelectMode = false

    scheme.HealthInCrates = 50
    scheme.CrateProbability = 50

    scheme.TurnTime = 6000
    scheme.SuddenDeathTime = 180000
    scheme.RetreatTime = 500
    scheme.HotSeatTime = 500

    scheme.WeaponProbability   = 25
    scheme.UtilityProbability   = 25
    scheme.HealthProbability   = 25

    scheme.Bazooka.Crate = 0
    scheme.Bazooka.Delay    = 0

    scheme.Mortar.Crate    = 1
    scheme.Mortar.Delay    = 0

    scheme.FireWeapon.Crate    = 1
    scheme.FireWeapon.Delay    = 0

    scheme.RocketLauncher.Crate    = 1
    scheme.RocketLauncher.Delay    = 0

    scheme.Grenade.Crate    = 0
    scheme.Grenade.Delay    = 0

    scheme.Trebuchet.Crate     = 1
    scheme.Trebuchet.Delay     = 0

    scheme.BatteringRam.Crate     = 1
    scheme.BatteringRam.Delay     = 0

    scheme.MonkeyHerd.Crate     = 1
    scheme.MonkeyHerd.Delay     = 0

    scheme.MineStrike.Crate     = 1
    scheme.MineStrike.Delay     = 0

    scheme.Armageddon.Crate     = 1
    scheme.Armageddon.Delay     = 0

    scheme.FirePunch.Crate     = 0
    scheme.FirePunch.Delay     = 0

    scheme.Ballista.Crate     = 1
    scheme.Ballista.Delay     = 0

    scheme.GiantLaser.Crate     = 1
    scheme.GiantLaser.Delay     = 0

    scheme.Tower.Crate = 1
    scheme.Tower.Delay  = 0

    scheme.Keep.Crate   = 1
    scheme.Keep.Delay  = 0

    scheme.Castle.Crate   = 1
    scheme.Castle.Delay  = 0

    scheme.Citadel.Crate   = 0
    scheme.Citadel.Delay  = 0

    scheme.Jetpack.Crate     = 1
    scheme.Jetpack.Delay     = 0

    scheme.Freeze.Crate     = 1
    scheme.Freeze.Delay     = 0

    scheme.SkipGo.Crate     = 0
    scheme.SkipGo.Delay     = 0

    scheme.DoubleDamageCrate	= 1
    scheme.DoubleTimeCrate		= 0
    scheme.CrateShowerCrate		= 0
    scheme.CrateSpyCrate		= 0
	
end

function HideWormsNow()
	Watch("MyRandomNumber")
end

function CreatePlayers()
	--CREATE PLAYER 1 WORMS--

	player = CreatePlayer("AI")
	player.NumberOfWorms = 3
	player.Name = "E3 Team 1"
	player.ResourcePoints = 16
	player.Handicap = 1
	player.WormStartingHealth = 100
        player.VoiceBank = "DrillSrg"
	CreatePlayersTeam(player.PlayerIndex)
	StandardWorm(GetWormData(player.PlayerIndex,0),"Worm 1", "buildHere000")
	StandardWorm(GetWormData(player.PlayerIndex,1),"Worm 2", "buildHere004")
	StandardWorm(GetWormData(player.PlayerIndex,2),"Worm 3", "buildHere002")

	
	--SET PLAYER 1 AI LEVEL--
	
	CopyContainer( GetAIParamsCPU5(), GetAIParamsWorm(0) )
        CopyContainer( GetAIParamsWorm(0), GetAIParamsWorm(1) )
        CopyContainer( GetAIParamsWorm(0), GetAIParamsWorm(2) )

	
	--CREATE PLAYER 1 BUILDINGS--
	
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0014", false )
	CreateBuilding( kWF_BUILDING_CITADEL, 0, "buildHere002", false )
	CreateBuilding( kWF_BUILDING_KEEP, 0, "buildHere004", false )
	CreateBuilding( kWF_BUILDING_CASTLE, 0, "buildHere000", false )
	
	--CREATE PLAYER 2 WORMS--
	
	player = CreatePlayer("AI")
	player.NumberOfWorms = 3
	player.Name = "E3 Team 2"
	player.ResourcePoints = 16
	player.Handicap = 1
	player.WormStartingHealth = 100
	player.VoiceBank = "Classic"
	CreatePlayersTeam(player.PlayerIndex)
	StandardWorm(GetWormData(player.PlayerIndex,0),"Worm 5", "buildHere0011")
	StandardWorm(GetWormData(player.PlayerIndex,1),"Worm 6", "buildHere009")
	StandardWorm(GetWormData(player.PlayerIndex,2),"Worm 7", "buildHere008")

	
	--SET PLAYER 2 AI LEVEL--
	
        CopyContainer( GetAIParamsCPU3(), GetAIParamsWorm(4) )
        CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(5) )
        CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(6) )

	
	--CREATE PLAYER 2 BUILDINGS--
	
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0011", false )
	CreateBuilding( kWF_BUILDING_CITADEL, 1, "buildHere009", false )
	CreateBuilding( kWF_BUILDING_CASTLE, 1, "buildHere008", false )
	CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere007", false )
	
	--PLAYER 1 INVENTORY--
	EmptyInventory(0)
        inventory = GetPlayerInventory(0)
        inventory.Bazooka = kWF_INFINITE_AMOUNT
	inventory.Mortar = 8
	inventory.FireWeapon = 5
	inventory.RocketLauncher = 2
	inventory.Grenade = kWF_INFINITE_AMOUNT
	inventory.Trebuchet = 2
	inventory.BatteringRam = 1
	inventory.MonkeyHerd = 2
	inventory.MineStrike = 1
	inventory.Armageddon = 1
	inventory.FirePunch = kWF_INFINITE_AMOUNT
	inventory.Ballista = 6
	inventory.GiantLaser = 2
	inventory.Tower = 5
	inventory.Keep = 2
	inventory.Castle = 1
	inventory.Citadel = 1
	inventory.Jetpack = 2
	inventory.Freeze = 2
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	
	--PLAYER 2 INVENTORY--
	EmptyInventory(1)
        inventory = GetPlayerInventory(1)
        inventory.Bazooka = kWF_INFINITE_AMOUNT
	inventory.Mortar = 8
	inventory.FireWeapon = 5
	inventory.RocketLauncher = 2
	inventory.Grenade = kWF_INFINITE_AMOUNT
	inventory.Trebuchet = 2
	inventory.BatteringRam = 1
	inventory.MonkeyHerd = 2
	inventory.MineStrike = 1
	inventory.Armageddon = 1
	inventory.FirePunch = kWF_INFINITE_AMOUNT
	inventory.Ballista = 6
	inventory.GiantLaser = 2
	inventory.Tower = 5
	inventory.Keep = 2
	inventory.Castle = 1
	inventory.Citadel = 1
	inventory.Jetpack = 2
	inventory.Freeze = 2
	inventory.SkipGo = kWF_INFINITE_AMOUNT	
	
	referee = GetRefereeData()
	referee.TurnCounter = 0
	referee.WindDirection = 0
	referee.WindDirectionVariance = 180.0
	referee.WindStrengthMinimum = 0.0
	referee.WindStrengthVariance = 10.0
--	referee.SuspendTimer = true;

	DecideWhichWeaponToUse()

end



function DecideWhichWeaponToUse()

        MyRandomNumber = RandomRange(3.4, true)
	
	if MyRandomNumber == 0 then
		GetAIParamsWorm(0).StrategicValueStrongHold = 60
		EmptyInventory(0)
		inventory = GetPlayerInventory(0)
        	inventory.RocketLauncher = 2
		inventory.SkipGo = kWF_INFINITE_AMOUNT
	elseif MyRandomNumber == 1 then
		GetAIParamsWorm(0).StrategicValueStrongHold = 60
		EmptyInventory(0)
		inventory = GetPlayerInventory(0)
        	inventory.Trebuchet= 2
		inventory.SkipGo = kWF_INFINITE_AMOUNT	
	elseif MyRandomNumber == 2 then
		GetAIParamsWorm(0).StrategicValueStrongHold = 60
		EmptyInventory(0)
		inventory = GetPlayerInventory(0)
		inventory.GiantLaser = 2
		inventory.SkipGo = kWF_INFINITE_AMOUNT	
	elseif MyRandomNumber == 3 then
		GetAIParamsWorm(0).StrategicValueStrongHold = 60
		EmptyInventory(0)
		inventory = GetPlayerInventory(0)
        	inventory.Armageddon = 2
		inventory.SkipGo = kWF_INFINITE_AMOUNT	
	end
	
end
