--***********************************************************
--~ E3 Demo EFMV Sequence
--***********************************************************

function InitialiseLevel()
    LoadLevel("landscapes/E3/E3Demo.xom", true)

    -- global variables
    bQuitable = true
    bUserQuit = 0
    Num = 1
    CameraArrayNumber = 0
   -- EFMVHasBeenSkipped = false
    
	    E3TextLabelsArray = { "E3.text1", "E3.text2", "E3.text3", "E3.text4", "E3.text5", "E3.text6",
				  "E3.text7", "E3.text8", "E3.text9", "E3.text10", "E3.text11", "E3.text12",
				  "E3.text13", "E3.text14", "E3.text15" }
			  
	    EFMVArray = { "E3Intro1", "E3Intro2", "E3Intro3", "E3Intro7", "E3Intro8", "E3Intro9", "E3Intro10", 
				    "E3Intro11", "E3Intro14", "E3Intro12", "E3Intro13" } -- Put all EFMV paths in here (array is indexed from 1)
			
                          

    --scheme stuff
    scheme = GetCurrentSchemeData()

    scheme.OverrideInventory = true
    scheme.WormSelectMode = false

    scheme.HealthInCrates = 50
    scheme.CrateProbability = 50

    scheme.TurnTime = 6000
    scheme.SuddenDeathTime = 180000
    scheme.RetreatTime = 500
    scheme.HotSeatTime = 500

    scheme.WeaponProbability   = 25
    scheme.UtilityProbability   = 25
    scheme.HealthProbability   = 25

    scheme.Bazooka.Crate = 0
    scheme.Bazooka.Delay    = 0

    scheme.Mortar.Crate    = 1
    scheme.Mortar.Delay    = 0

    scheme.FireWeapon.Crate    = 1
    scheme.FireWeapon.Delay    = 0

    scheme.RocketLauncher.Crate    = 1
    scheme.RocketLauncher.Delay    = 0

    scheme.Grenade.Crate    = 0
    scheme.Grenade.Delay    = 0

    scheme.Trebuchet.Crate     = 1
    scheme.Trebuchet.Delay     = 0

    scheme.BatteringRam.Crate     = 1
    scheme.BatteringRam.Delay     = 0

    scheme.MonkeyHerd.Crate     = 1
    scheme.MonkeyHerd.Delay     = 0

    scheme.MineStrike.Crate     = 1
    scheme.MineStrike.Delay     = 0

    scheme.Armageddon.Crate     = 1
    scheme.Armageddon.Delay     = 0

    scheme.FirePunch.Crate     = 0
    scheme.FirePunch.Delay     = 0

    scheme.Ballista.Crate     = 1
    scheme.Ballista.Delay     = 0

    scheme.GiantLaser.Crate     = 1
    scheme.GiantLaser.Delay     = 0

    scheme.Tower.Crate = 1
    scheme.Tower.Delay  = 0

    scheme.Keep.Crate   = 1
    scheme.Keep.Delay  = 0

    scheme.Castle.Crate   = 1
    scheme.Castle.Delay  = 0

    scheme.Citadel.Crate   = 0
    scheme.Citadel.Delay  = 0

    scheme.Jetpack.Crate     = 1
    scheme.Jetpack.Delay     = 0

    scheme.Freeze.Crate     = 0
    scheme.Freeze.Delay     = 0

    scheme.SkipGo.Crate     = 0
    scheme.SkipGo.Delay     = 0

    scheme.DoubleDamageCrate	= 1
    scheme.DoubleTimeCrate		= 0
    scheme.CrateShowerCrate		= 0
    scheme.CrateSpyCrate		= 0
    

    
    
end


function CreatePlayers()
    
    CreateStandardPlayer("HUMAN",3,"E3Team1","Classic")
    StandardWorm(GetWormData(0),"Worm1", "wfRefWorm1")  
    StandardWorm(GetWormData(1),"Worm2", "wfRefWorm2")  
    StandardWorm(GetWormData(2),"Worm3", "wfRefWorm3")
   
  
    CreateStandardPlayer("HUMAN",12,"E3Team2","Classic")
    StandardWorm(GetWormData(3),"Worm4", "wfRefWorm4")  
    StandardWorm(GetWormData(4),"Worm5", "wfRefWorm5")
    StandardWorm(GetWormData(5),"Worm6", "wfRefWorm6")  
    StandardWorm(GetWormData(6),"Worm7", "wfRefWorm7")  
    StandardWorm(GetWormData(7),"Worm8", "wfRefWorm8")  
    StandardWorm(GetWormData(8),"Worm9", "wfRefWorm9")  
    StandardWorm(GetWormData(9),"Worm10", "wfRefWorm10")
    StandardWorm(GetWormData(10),"Worm11", "wfRefWorm11")
    StandardWorm(GetWormData(11),"Worm12", "wfRefWorm12")  
    StandardWorm(GetWormData(12),"Worm13", "wfRefWorm13")  
    StandardWorm(GetWormData(13),"Worm14", "wfRefWorm14")  
    StandardWorm(GetWormData(14),"Worm15", "wfRefWorm15")  
    
    --ShowOnlyScriptCommentary(true)
    
end


function HideWormsNow()
	
        HideWorm(0)
        HideWorm(1)
        HideWorm(2)
        HideWorm(3)
        HideWorm(4)
        HideWorm(5)
        HideWorm(6)
        HideWorm(7)
        HideWorm(8)
        HideWorm(9)
        HideWorm(10)
        HideWorm(11)
        HideWorm(12)
        HideWorm(13)
        HideWorm(14)
        
        ShowOnlyScriptCommentary(true)
	
	Fade(false, 0.2, false)
        EFMVFlyby()
	StartAllEFMVTimers()
        
	  ------------------------------------
    ------Animated Detail Objects-------
    ------------------------------------
	
	----Window Bat 1-------
	PlayDetailObjectAnimation("windowbat1", "path2", false)
	PlayDetailObjectAnimation("windowbat1", "flap", true)
	
	----Window Bat 2-------
	PlayDetailObjectAnimation("windowbat2", "path2", false)
	PlayDetailObjectAnimation("windowbat2", "flap", true)
	
	----Window Bat 3-------
	PlayDetailObjectAnimation("windowbat3", "path2", false)
	PlayDetailObjectAnimation("windowbat3", "flap", true)
	
	----Window Bat 4-------
	PlayDetailObjectAnimation("windowbat4", "path2", false)
	PlayDetailObjectAnimation("windowbat4", "flap", true)
    
	----coffinsnake1-------
	PlayDetailObjectAnimation("coffinsnake1", "path1", true)
	PlayDetailObjectAnimation("coffinsnake1", "crawl", true)
	
	----coffinsnake2-------
	PlayDetailObjectAnimation("coffinsnake2", "path1", true)
	PlayDetailObjectAnimation("coffinsnake2", "crawl", true)
        
	----circlecrow1-------
	PlayDetailObjectAnimation("circlecrow1", "path1", true)
	PlayDetailObjectAnimation("circlecrow1", "flap", true)
	
 	----circlecrow2-------
	PlayDetailObjectAnimation("circlecrow2", "path1", true)
 	PlayDetailObjectAnimation("circlecrow2", "flap", true)
    
 	----circlecrow3-------
	PlayDetailObjectAnimation("circlecrow3", "path1", true)
 	PlayDetailObjectAnimation("circlecrow3", "flap", true)
    

	----Circle Bat 1-------
	PlayDetailObjectAnimation("circlebat1", "path1", true)
	PlayDetailObjectAnimation("circlebat1", "flap", true)
    
	----Circle Bat 2-------
    PlayDetailObjectAnimation("circlebat2", "path1", true)
	PlayDetailObjectAnimation("circlebat2", "flap", true)

	----Circle Bat 3-------
    PlayDetailObjectAnimation("circlebat3", "path1", true)
	PlayDetailObjectAnimation("circlebat3", "flap", true)
    
	----Circle Bat 4-------
    PlayDetailObjectAnimation("circlebat4", "path1", true)
	PlayDetailObjectAnimation("circlebat4", "flap", true)
	
	
end


----------------------------------------------------------- Camera flyby things bellow this line

function EFMVFlyby()

	CameraArrayNumber = CameraArrayNumber + 1
	StartEFMV(EFMVArray[CameraArrayNumber], bQuitable)

end


function OnEndEFMV(szSeqName, bUserQuit)
		
	if bUserQuit == 1 then
		SetGameUpAndCancelEverything()
	end
	
	if bUserQuit == 0 and CameraArrayNumber < 11 then
			EFMVFlyby()
	
	elseif CameraArrayNumber == 11 then  -- Just change the number variable to the amount of flyby cams.
		--Fade(false, 3, false)
		SetGameUpAndCancelEverything()
	end
end


function SetGameUpAndCancelEverything()
		
		--if EFMV has been skipped cancel the stuff on timers below
		--INTRO 3
		CancelDelayCall("SpawnFirstLotOfWorms")
		CancelDelayCall("SpawnLastWormInFirstLot")
		CancelDelayCall("AnimateWorm3")
		
		--INTRO 7
		CancelDelayCall("SpawnStronghold1AndWorm")
		CancelDelayCall("AnimateWorm13")
		
		--INTRO 8
		--CancelDelayCall("SpawnBuildPoint")
		CancelDelayCall("SpawnTower1")
		CancelDelayCall("DestroyBuilding")
		--CancelDelayCall("CreateFakeExplosion")
		CancelDelayCall("SpawnKeep1")
		CancelDelayCall("DestroyBuilding")
		--CancelDelayCall("CreateFakeExplosion")
		CancelDelayCall("SpawnCastle1")
		CancelDelayCall("DestroyBuilding")
		--CancelDelayCall("CreateFakeExplosion")
		CancelDelayCall("SpawnCitadel1")
		
		--INTRO 9
		CancelDelayCall("SpawnRowOfBuildings")
		CancelDelayCall("Explosion1")
		CancelDelayCall("Explosion2")
		CancelDelayCall("Explosion3")
		CancelDelayCall("Explosion4")
		CancelDelayCall("Explosion5")
		
		--INTRO 10-
		CancelDelayCall("SpawnCastleWeaponWorm")
		CancelDelayCall("CreateSuperHippo")
		--CancelDelayCall("DeleteCurrentWeapon")
		CancelDelayCall("CreateFridgeLauncher")
		--CancelDelayCall("DeleteCurrentWeapon")
		CancelDelayCall("CreateOldLady")
		--CancelDelayCall("DeleteCurrentWeapon")
		CancelDelayCall("CreateMortar")
		CancelDelayCall("AimMortar")
		CancelDelayCall("ShootMortar")
		CancelDelayCall("DeleteMortar")
		
		--INTRO 11
		CancelDelayCall("SpawnCastle4") 
	--~ 	DelayCall("ExplosionCastle4", 66)
		
		----INTRO 12
		CancelDelayCall("GetRidOfAllBuildings")
		CancelDelayCall("SpawnAllRemainingStrongholdsAndWorms")
		CancelDelayCall("SpawnStronghold2")
		CancelDelayCall("SpawnStronghold3")
		CancelDelayCall("SpawnStronghold4")
		CancelDelayCall("SpawnLastTowerAndWorm")
		
		--INTRO 13
		CancelDelayCall("CreateBallista")
		CancelDelayCall("AimBallista")
		CancelDelayCall("FireBallista")
		
		CancelDelayCall("DeleteCurrentWeapon")
		CancelDelayCall("WhiteTheScreenOut")
	
		
		--Spawn all worms and then hide them again so that they have reset
		--and the game doesn't try to hide worms that are already hidden (causes serious problems)
		SpawnWorm(0,"wfRefWorm1")  
		SpawnWorm(1, "wfRefWorm2")  
		SpawnWorm(2,"wfRefWorm3")  
		SpawnWorm(3, "wfRefWorm4")  
		SpawnWorm(4, "wfRefWorm5")
		SpawnWorm(5, "wfRefWorm6")  
		SpawnWorm(6,"wfRefWorm7")  
		SpawnWorm(7, "wfRefWorm8")  
		SpawnWorm(8,"wfRefWorm9")  
		SpawnWorm(9, "wfRefWorm10")
		SpawnWorm(10, "wfRefWorm11")
		SpawnWorm(11, "wfRefWorm12")  
		SpawnWorm(12, "wfRefWorm13")  
		SpawnWorm(13,"wfRefWorm14")  
		SpawnWorm(14, "wfRefWorm15")  
			
		HideWorm(0)
		HideWorm(1)
		HideWorm(2)
		HideWorm(3)
		HideWorm(4)
		HideWorm(5)
		HideWorm(6)
		HideWorm(7)
		HideWorm(8)
		HideWorm(9)
		HideWorm(10)
		HideWorm(11)
		HideWorm(12)
		HideWorm(13)
		HideWorm(14)
		
		AddVictoryLocation ("buildHere002")
		AddVictoryLocation ("buildHere005")
		AddVictoryLocation ("buildHere007")
		AddVictoryLocation ("buildHere008")
		AddVictoryLocation ("buildHere0011")
		AddVictoryLocation ("buildHere0014")
		
		FlushCommentaryText()
		HideCurrentText(0)
		RemoveAllBuildings()
		Fade(false, 0.5, false)
		-- Send it off to start the 2 player game
		Start2PlayerGame()

		return 0;
	
end



function StartAllEFMVTimers() 
	-- Set up all timers (buildings and Worm Spawns) been used for the EFMV here.
	
	--INTRO 3
	DelayCall("SpawnFirstLotOfWorms", 31.3)
	DelayCall("SpawnLastWormInFirstLot", 32)
	DelayCall("AnimateWorm3", 39)
	
	--INTRO 7
	DelayCall("SpawnStronghold1AndWorm", 40)
	DelayCall("AnimateWorm13", 41)
	--DelayCall("ShakeCamera", 40.2)
	
	--INTRO 8
	--DelayCall("SpawnBuildPoint", 50)
	DelayCall("SpawnTower1", 45)
	--DelayCall("ShakeCamera", 45.2)
	DelayCall("DestroyBuilding", 47)
	--DelayCall("CreateFakeExplosion", 47.01)
	DelayCall("SpawnKeep1", 47.5)
	--DelayCall("ShakeCamera", 47.7)
	DelayCall("DestroyBuilding", 49.5)
	--DelayCall("CreateFakeExplosion", 49.51)
	DelayCall("SpawnCastle1", 50)
	--DelayCall("ShakeCamera", 50.2)
	DelayCall("DestroyBuilding", 52)
	--DelayCall("CreateFakeExplosion", 52.01)
	DelayCall("SpawnCitadel1", 52.5)
	--DelayCall("ShakeCamera", 52.4)
	
	--INTRO 9
	DelayCall("SpawnRowOfBuildings", 52.5)
	DelayCall("Explosion1", 58)
	DelayCall("Explosion2", 59)
	DelayCall("Explosion3", 60)
	DelayCall("Explosion4", 61)
	DelayCall("Explosion5", 62)
	
	--INTRO 10
	DelayCall("SpawnCastleWeaponWorm", 64)
	DelayCall("CreateSuperHippo", 64.5)
	--DelayCall("DeleteCurrentWeapon", 67)
	DelayCall("CreateFridgeLauncher", 67)
	--DelayCall("DeleteCurrentWeapon", 70)
	DelayCall("CreateOldLady", 69.5)
	--DelayCall("DeleteCurrentWeapon", 73)
	DelayCall("CreateMortar", 72)
	DelayCall("AimMortar", 74)
	DelayCall("ShootMortar", 75)
	DelayCall("DeleteMortar", 80)
	
	--INTRO 11
	DelayCall("SpawnCastle4", 66) 
--~ 	DelayCall("ExplosionCastle4", 66)
	
	--INTRO 12
	DelayCall("GetRidOfAllBuildings", 97.6)
	DelayCall("SpawnAllRemainingStrongholdsAndWorms", 97.6)
	DelayCall("SpawnStronghold2", 99.6)
	DelayCall("SpawnStronghold3", 101.7)
	DelayCall("SpawnStronghold4", 103)
	DelayCall("SpawnLastTowerAndWorm", 104)
	
	--INTRO13
	DelayCall("CreateBallista", 107)
	DelayCall("AimBallista", 107.5)
	DelayCall("FireBallista", 111.126)
	DelayCall("DeleteCurrentWeapon", 113.5)
	
	DelayCall("WhiteTheScreenOut", 114.55)
end


------------INTRO 3: SPAWN ANIMATED WORMS-------------------

function SpawnFirstLotOfWorms()

	SpawnWorm(0, "wfRefWorm1")
	OrientateWorm(0, 0) 
	WormResetAnim(0)
	WormQueueAnim(0, "worm_shakefist")
	
	
	SpawnWorm(1, "wfRefWorm2")
	OrientateWorm(1, 160)
	WormResetAnim(1)
	WormQueueAnim(1, "worm_comeon2")


	SpawnWorm(2, "wfRefWorm3")
	OrientateWorm(2, 150)
	WormResetAnim(2)
	WormQueueAnim(2, "worm_surveying")
	
end

function SpawnLastWormInFirstLot()
	SpawnWorm(3, "wfRefWorm4")
end

function AnimateWorm3()
	WormResetAnim(3)
	WormQueueAnim(3, "worm_comeon1")
	
end
----------------INTRO 7: SPAWN STRONGHOLD AND ANGRY WORM----------------

function SpawnStronghold1AndWorm()
	CreateBuilding(kWF_BUILDING_STRONGHOLD, 1, "buildHere009")
	SpawnWorm(13, "wfRefWorm14")
	OrientateWorm(13, 293) 
end

function AnimateWorm13()
	WormResetAnim(13)
	WormQueueAnim(13, "worm_shakefist")
end


--------------INTRO 8: SEQUENTIAL DESTRUCTION OF BUILDINGS----------

function SpawnBuildPoint()
	AddVictoryLocation ("buildHere007")
end

function DestroyBuilding()
	--CreateExplosion("buildHere007", 15, 10, 20, 0, 5)
--~ 	CreateParticleEffect("Explosion Smoke", "wfRefBuildingExplosion") 
	PlaySound("Weapon.RoundExplode", "wfRefBuildingExplosion") 
	CreateParticleEffect("Explosion Smoke", "wfRefBuildingExplosion") 
	RemoveBuilding("buildHere007")
	--CreateExplosionEffects("wfRefBuildingExplosion", kWF_EXPLOSION_LARGE, false)
end

--~ function CreateFakeExplosion()
--~ 	CreateExplosionEffects("wfRefBuildingExplosion", kWF_EXPLOSION_MEDIUM, true)
--~ 	CreateParticleEffect("Explosion Smoke", "wfRefBuildingExplosion") 
--~ 	PlaySound("Weapon.RoundExplode", "wfRefBuildingExplosion") 
--~ end

function ShakeCamera()
	SetCameraShake(2, 25, 1, 1, 1, 1, false)
end

function SpawnTower1()
	CreateBuilding(kWF_BUILDING_TOWER, 1, "buildHere007")
end

function SpawnKeep1()
	CreateBuilding(kWF_BUILDING_KEEP, 1, "buildHere007")
	
end

function SpawnCastle1()
	CreateBuilding(kWF_BUILDING_CASTLE, 1, "buildHere007")
	
end

function SpawnCitadel1()
	CreateBuilding(kWF_BUILDING_CITADEL, 1, "buildHere007")
end


---------------INTRO 9: SPAWN ROW OF BUILDINGS AND DESTROY THEM--------

function SpawnRowOfBuildings()
	CreateBuilding(kWF_BUILDING_TOWER, 1, "buildHere000")
	CreateBuilding(kWF_BUILDING_SCIENCE_LAB, 1, "buildHere001")
	CreateBuilding(kWF_BUILDING_CASTLE, 1, "buildHere002")
	CreateBuilding(kWF_BUILDING_CITADEL, 1, "buildHere003")
	CreateBuilding(kWF_BUILDING_SCIENCE_LAB, 1, "buildHere004")
	CreateBuilding(kWF_BUILDING_KEEP, 1, "buildHere005")
	CreateBuilding(kWF_BUILDING_CASTLE, 1, "buildHere006")
	CreateBuilding(kWF_BUILDING_CITADEL, 1, "buildHere0014")
end


--function BlowUpRowOfBuildings()

function Explosion1()	
	CreateExplosion("wfRefExplosion1", 15, 10, 20, 0, 5)
--~ 	CreateParticleEffect("Explosion Smoke", "wfRefExplosion1") 
--~ 	PlaySound("Weapon.RoundExplode", "wfRefExplosion1") 
	CreateExplosionEffects("wfRefExplosion1", kWF_EXPLOSION_MEDIUM, false)

end

function Explosion2()
	CreateExplosion("wfRefExplosion2", 10, 10, 15, 0, 5)
--~ 	CreateParticleEffect("Explosion Smoke", "wfRefExplosion2") 
--~ 	PlaySound("Weapon.RoundExplode", "wfRefExplosion2") 
	CreateExplosionEffects("wfRefExplosion2", kWF_EXPLOSION_MEDIUM, false)
end

function Explosion3()
	CreateExplosion("wfRefExplosion3", 10, 10, 15, 0, 5)
--~ 	CreateParticleEffect("Explosion Smoke", "wfRefExplosion3") 
--~ 	PlaySound("Weapon.RoundExplode", "wfRefExplosion3") 
	CreateExplosionEffects("wfRefExplosion3", kWF_EXPLOSION_MEDIUM, false)
end

function Explosion4()
	CreateExplosion("wfRefExplosion4", 10, 10, 15, 0, 5)
--~ 	CreateParticleEffect("Explosion Smoke", "wfRefExplosion4") 
--~ 	PlaySound("Weapon.RoundExplode", "wfRefExplosion4") 
	CreateExplosionEffects("wfRefExplosion4", kWF_EXPLOSION_MEDIUM, false)
end

function Explosion5()
	CreateExplosion("wfRefExplosion5", 10, 10, 15, 0, 5)
--~ 	CreateParticleEffect("Explosion Smoke", "wfRefExplosion5") 
--~ 	PlaySound("Weapon.RoundExplode", "wfRefExplosion5") 
	CreateExplosionEffects("wfRefExplosion5", kWF_EXPLOSION_MEDIUM, false)
end


----------INTRO 10: CASTLE WEAPONS AND MISSILE LAUNCH-------------------

function SpawnCastleWeaponWorm()
	SpawnWorm(14, "wfRefWorm15")
	OrientateWorm(14, 225)
end


function CreateSuperHippo() 
	CreateWeapon(14, kWF_WEAPON_SUPER_HIPPO)
end

function CreateFridgeLauncher() 
	CreateWeapon(14, kWF_WEAPON_BANANA_BOMB_LAUNCHER)
end

function CreateOldLady() 
	CreateWeapon(14, kWF_WEAPON_GIANT_LASER)
end
	
function CreateMortar() 
	CreateWeapon(14, kWF_WEAPON_MORTAR)
end

function AimMortar()
	-- worm index, rotation, pitch
	AimWeapon(14, 225, -8)
end

function ShootMortar()
	FireWeapon(14, 1)
end

function DeleteMortar()
	RemoveWeapon(14)
end

--CreateWeapon(uWormId, uWeaponId)
--~ RemoveWeapon(uWormId)
--~ AimWeapon(uWormId, fHeading, fPitch)
--~ FireWeapon(uWormId, fShotPower)

--~ fHeading and fPitch are angles in degrees.
--~ fShotPower is a value between 0 and 1 and represents the interval between
--~ that weapon's minimum  and maximum shot power.



-----------------------------------------------------------------------------------------------


------------INTRO 11: TARGET DESTROYED BY CASTLE WEAPON--------------------

function SpawnCastle4()

	CreateBuilding(kWF_BUILDING_CASTLE, 1, "buildHere0014")
end

--~ function ExplosionCastle4()
--~ 	
--~ 	CreateExplosion("buildHere0014", 5, 2, 10, 0, 5)
--~ end
--~ 	

--------INTRO12: SPAWN REMAINING S/HOLDS AND WORMS-----------------------

function GetRidOfAllBuildings() 
	RemoveAllBuildings()
end


function SpawnAllRemainingStrongholdsAndWorms()

	CreateBuilding(kWF_BUILDING_STRONGHOLD, 0, "buildHere009")
	SpawnWorm(4, "wfRefWorm5")
	SpawnWorm(5, "wfRefWorm6")
	SpawnWorm(6, "wfRefWorm7")
	SpawnWorm(7, "wfRefWorm8")
	SpawnWorm(8, "wfRefWorm9")
	SpawnWorm(9, "wfRefWorm10")
	SpawnWorm(10, "wfRefWorm11")
	SpawnWorm(11, "wfRefWorm12")
end

function SpawnStronghold2()
	CreateBuilding(kWF_BUILDING_STRONGHOLD, 1, "buildHereStrong1")
end

function SpawnStronghold3()
	CreateBuilding(kWF_BUILDING_STRONGHOLD, 2, "buildHereStrong2")
end

function SpawnStronghold4()
	CreateBuilding(kWF_BUILDING_STRONGHOLD, 3, "buildHereStrong3")
end


---------INTRO13: FIRE BALLISTA AT CAMERA-----------------------------------

function SpawnLastTowerAndWorm()
	CreateBuilding(kWF_BUILDING_TOWER, 1, "buildHere0013")
	SpawnWorm(12, "wfRefWorm13")
	OrientateWorm(12, 218)
	WormQueueAnim(12, "worm_comeon1") 
end

function CreateBallista()
	CreateWeapon(12, kWF_WEAPON_BALLISTA)
end

function AimBallista()
	AimWeapon(12, 218, -9.625)
end

function FireBallista()
	FireWeapon(12, 1)
end

function DeleteCurrentWeapon()
	RemoveWeapon(12)
end

function WhiteTheScreenOut()
	Fade(false, 3, false)
end



---trigger text code ---
function EFMV_TextTrigger()

	if Num == 2 then
		ShowWFLogo()
		Num = 3

	elseif Num < 16 and Num ~= 2 then 
	
		Text = E3TextLabelsArray[Num]
		
		-- (-1) is infinite, (0) is default to 2000 (2 secs)
		SetCommentaryText(Text, -1)
		
		Num = Num + 1
	end
end 


function EFMV_TextTriggerEnd() 
	
	if Num == 3 then
	
		HideWFLogo()
	 end
	 	-- Do something to turn the current text thingy off.
	
	--put in as a parameter the delay in miliseconds
	-- (0) means no delay, it will hide it straight away
		HideCurrentText(0)
	
end 

function GetRidOfAllBuildings() 
	RemoveAllBuildings()
end


--***********************************************************
--~ E3 Demo 2 Player Script
--***********************************************************

function Start2PlayerGame()

	HideWFLogo()

	RemoveWormFromMemory(14)
	RemoveWormFromMemory(13)
	RemoveWormFromMemory(12)
	RemoveWormFromMemory(11)
	RemoveWormFromMemory(10)
	RemoveWormFromMemory(9)
	RemoveWormFromMemory(8)
	RemoveWormFromMemory(7)
	RemoveWormFromMemory(6)

	-- RESPAWN PLAYER 1 WORMS--
	SpawnWorm(0, "buildHere002")
	SpawnWorm(1, "buildHere004")
	SpawnWorm(2, "buildHere000") 
	
	--CREATE PLAYER 1 BUILDINGS--
	
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0014", false )
	CreateBuilding( kWF_BUILDING_CITADEL, 0, "buildHere002", false )
	CreateBuilding( kWF_BUILDING_KEEP, 0, "buildHere004", false )
	CreateBuilding( kWF_BUILDING_CASTLE, 0, "buildHere000", false )
	
	--RESAPWN PLAYER 2 WORMS--
	SpawnWorm(3, "buildHere009")
	SpawnWorm(4, "buildHere008")
	SpawnWorm(5, "buildHere007")
	
	--CREATE PLAYER 2 BUILDINGS--
	
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0011", false )
	CreateBuilding( kWF_BUILDING_CITADEL, 1, "buildHere009", false )
	CreateBuilding( kWF_BUILDING_CASTLE, 1, "buildHere008", false )
	CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere007", false )
	
	--PLAYER 1 INVENTORY--
	EmptyInventory(0)
        inventory = GetPlayerInventory(0)
        inventory.Bazooka = kWF_INFINITE_AMOUNT
	inventory.Mortar = 8
	inventory.FireWeapon = 5
	inventory.RocketLauncher = 2
	inventory.Grenade = kWF_INFINITE_AMOUNT
	inventory.Trebuchet = 2
	inventory.BatteringRam = 1
	inventory.MonkeyHerd = 2
	inventory.MineStrike = 1
	inventory.Armageddon = 1
	inventory.FirePunch = kWF_INFINITE_AMOUNT
	inventory.Ballista = 6
	inventory.GiantLaser = 2
	inventory.Tower = 5
	inventory.Keep = 2
	inventory.Castle = 1
	inventory.Citadel = 1
	inventory.Jetpack = 2
	inventory.Freeze = 0
	inventory.SkipGo = kWF_INFINITE_AMOUNT

	player = GetPlayerData(0)
	player.SpecialWeapon = kWF_NO_SPECIAL_WEAPON

	--PLAYER 2 INVENTORY--
	EmptyInventory(1)
        inventory = GetPlayerInventory(1)
        inventory.Bazooka = kWF_INFINITE_AMOUNT
	inventory.Mortar = 8
	inventory.FireWeapon = 5
	inventory.RocketLauncher = 2
	inventory.Grenade = kWF_INFINITE_AMOUNT
	inventory.Trebuchet = 2
	inventory.BatteringRam = 1
	inventory.MonkeyHerd = 2
	inventory.MineStrike = 1
	inventory.Armageddon = 1
	inventory.FirePunch = kWF_INFINITE_AMOUNT
	inventory.Ballista = 6
	inventory.GiantLaser = 2
	inventory.Tower = 5
	inventory.Keep = 2
	inventory.Castle = 1
	inventory.Citadel = 1
	inventory.Jetpack = 2
	inventory.Freeze = 0
	inventory.SkipGo = kWF_INFINITE_AMOUNT	
	
	player = GetPlayerData(1)
	player.SpecialWeapon = kWF_NO_SPECIAL_WEAPON
	
	referee = GetRefereeData()
	referee.TurnCounter = 0
	referee.WindDirection = 0
	referee.WindDirectionVariance = 180.0
	referee.WindStrengthMinimum = 0.0
	referee.WindStrengthVariance = 10.0
--	referee.SuspendTimer = true;

	-- turn commentary panel messages back on
        ShowOnlyScriptCommentary(false)


end




