-- Egyptian 2, Chapter 2
--
-- To complete this mission successfully:
--
-- * Player must find priest worm Menst, who will give them the flood weapon and advise them on how to use it.
-- * All enemy worms must be killed by using the flood weapon.

-- scratch:
-- You must travel across to Menst.
-- Menst will instruct you that you must first build a Keep before you can use the power of the flood..
-- Player must collect Keep crate.. and then build the Keep

function InitialiseLevel()
    LoadLevel("landscapes/E/E2.xom", true)
    SetupDefaultScheme()
    
    SetObjectives("Miss.Egypt2-Objectives", 2)
    
    wlevel = 140
    
    	--efmv ONLY cut names, ARRAYS and variables
	bQuitable = true
	bUserQuit = 0
	CameraArrayNumber = 0
	GameHasFinished = 0
	Num = 1
	GameIsMidSequence = false
    PlayersWormsDead = 0
    
    Human1Dead = false
    Human2Dead = false
    Human3Dead = false
    Human4Dead = false
	
	-- stops the victory sequence from playing
	referee = GetRefereeData()
    referee.ShowVictorySequence = false
    
    worm5fell = false
    worm6fell = false
    worm7fell = false
    worm8fell = false
    
	--switch to false to disable cameras
	EFMVCamerasAreActive = true
	
    
    
    
	
	TextLabelsArray = { "Miss.Egypt2-EFMV.Intro1", "Miss.Egypt2-EFMV.Intro2", "Miss.Egypt2-EFMV.Intro3",	
					"Miss.Egypt2-EFMV.Intro4", "Miss.Egypt2-EFMV.Intro5", "Miss.Egypt2-EFMV.Intro6",	
					"Miss.Egypt2-EFMV.Intro7", "Miss.Egypt2-EFMV.Intro8", "Miss.Egypt2-EFMV.Intro9",	
					"Miss.Egypt2-EFMV.Intro10", "Miss.Egypt2-EFMV.Intro11", "Miss.Egypt2-EFMV.Intro12",	
					"Miss.Egypt2-EFMV.Intro13", "Miss.Egypt2-EFMV.Intro14", "Miss.Egypt2-EFMV.Intro15",	
					"Miss.Egypt2-EFMV.Intro16", "Miss.Egypt2-EFMV.Intro17", "Miss.Egypt2-EFMV.Intro18",	
					"Miss.Egypt2-EFMV.Intro19", "Miss.Egypt2-EFMV.Intro20", "Miss.Egypt2-EFMV.Intro21",
					"Miss.Egypt2-EFMV.Intro22", "Miss.Generic.Game13", "Miss.Egypt2-EFMV.Intro24",
					"Miss.Egypt2-EFMV.Intro25", "Miss.Egypt2-EFMV.Intro26", "Miss.Egypt2-EFMV.Intro27",
					"Miss.Egypt2-EFMV.Intro28", "Miss.Egypt2-EFMV.Intro29" } 

					   
	EFMVArray = { "intro", "cut1", "cut2", "cut3", "cut4", "cut11", 
				"cut5", "cut6", "cut7", "cut8", "cut9", "cut10" } -- cut3 is reused at start of mid game seq.
    
    
end

function CreatePlayers()
    WhichCrate = 0      -- used to set the crate INDEX, not the crate ID
    SetUpLandscape()
    

    -- Team 0, Player controlled worms

    
--    player = CreatePlayer("HUMAN")
--	player.NumberOfWorms = 5
--	player.Name = "Horus and Pals"
--	player.WormStartingHealth = 100
--    player.VoiceBank = "Classic"
--	CreatePlayersTeam(player.PlayerIndex)
--    

--    StandardWorm(GetWormData(0),"Horus","wfRefC2_Horus")   
--    StandardWorm(GetWormData(1),"Seth","wfRefEFMVSeth")
--    StandardWorm(GetWormData(2),"Mummy 2","wfRefC2_Mummy2")
--    StandardWorm(GetWormData(3),"Mummy 3","wfRefC2_Mummy3")
--    StandardWorm(GetWormData(4),"Mummy 4","wfRefC2_Mummy4")
  
  
    SetupHumanPlayer(5,100)
	player = GetPlayerData(0)
    player.SpecialWeapon =  "kNoSpecialWeapon"

    
    GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRefC2_Horus"
	GetWormData(player.PlayerIndex,1).SpawnPointName ="wfRefEFMVSeth"
	GetWormData(player.PlayerIndex,2).SpawnPointName ="wfRefC2_Mummy2"
	GetWormData(player.PlayerIndex,3).SpawnPointName ="wfRefC2_Mummy3"
    GetWormData(player.PlayerIndex,4).SpawnPointName ="wfRefC2_Mummy4"
    GetWormData(4).Name = "Cuckoo's Egg"
    
    
    EmptyInventory(0)
    inventory = GetPlayerInventory(0)
    inventory.FirePunch = kWF_INFINITE_AMOUNT
    inventory.Flood = kWF_INFINITE_AMOUNT
    inventory.WormSelect = kWF_INFINITE_AMOUNT
    inventory.RepairBuilding = kWF_INFINITE_AMOUNT
    inventory.Surrender = 0

    -- Team 1, CPU Enemy worms
    
    player = CreatePlayer("AI")
	player.NumberOfWorms = 4
	player.Name = "Soldiers"
	player.WormStartingHealth = 200
    player.VoiceBank = "Classic"
        player.Flag = 57
	CreatePlayersTeam(player.PlayerIndex)
    


    StandardWorm(GetWormData(5),"Soldier Kel","wfRefC2_Enemy1")
    StandardWorm(GetWormData(6),"Soldier Bruce","wfRefC2_Enemy2")
    StandardWorm(GetWormData(7),"Soldier Jegg","wfRefC2_Enemy3")
    StandardWorm(GetWormData(8),"Soldier Chesh","wfRefC2_Enemy4")
--    StandardWorm(GetWormData(9),"Resistance Fighter 5","wfRefC2_Enemy5")
--    StandardWorm(GetWormData(10),"Resistance Fighter 6","wfRefC2_Enemy6")
--    StandardWorm(GetWormData(11),"Resistance Fighter 7","wfRefC2_Enemy7")
--    StandardWorm(GetWormData(12),"Resistance Fighter 8","wfRefC2_Enemy8")
    CopyContainer(GetAIParamsCPU3(), GetAIParamsWorm(5))
--    
--    
    CopyContainer(GetAIParamsWorm(5), GetAIParamsWorm(6))
    CopyContainer(GetAIParamsWorm(5), GetAIParamsWorm(7))
    CopyContainer(GetAIParamsWorm(5), GetAIParamsWorm(8))
--    CopyContainer(GetAIParamsWorm(5), GetAIParamsWorm(9))
--    CopyContainer(GetAIParamsWorm(5), GetAIParamsWorm(10))
--    CopyContainer(GetAIParamsWorm(5), GetAIParamsWorm(11))
--    CopyContainer(GetAIParamsWorm(5), GetAIParamsWorm(12))
    
    worm = GetWormData(5)
    worm.Pushable = true
    worm.ArtilleryMode = true
    worm = GetWormData(6)
    worm.Pushable = true
    worm.ArtilleryMode = true
    worm = GetWormData(7)
    worm.Pushable = true
    worm.ArtilleryMode = true
    worm = GetWormData(8)
    worm.Pushable = true
    worm.ArtilleryMode = true
--    worm = GetWormData(9)
--    worm.Pushable = true
--    worm.ArtilleryMode = true
--    worm = GetWormData(10)
--    worm.Pushable = true
--    worm.ArtilleryMode = true
--    worm = GetWormData(11)
--    worm.Pushable = true
--    worm.ArtilleryMode = true
--    worm = GetWormData(12)
--    worm.Pushable = true
--    worm.ArtilleryMode = true
    
    
         --Mummy Worms
--        Worm = GetWormData(0)
--        Worm.HatOverride = "NoHat" 
--	 
--        Worm = GetWormData(1)
--        Worm.HatOverride = "Hat.Egyptian3"

--        Worm = GetWormData(2)
--        Worm.HatOverride = "Hat.Egyptian4"

--        Worm = GetWormData(3)
--        Worm.HatOverride = "Hat.Egyptian4"

--        Worm = GetWormData(4)
--        Worm.HatOverride = "Hat.Egyptian4"


    --Enemy Worms
        Worm = GetWormData(5)
        Worm.HatOverride = "Hat.Egyptian2"

        Worm = GetWormData(6)
        Worm.HatOverride = "Hat.Egyptian2"

        Worm = GetWormData(7)
        Worm.HatOverride = "Hat.Egyptian2"

        Worm = GetWormData(8)
        Worm.HatOverride = "Hat.Egyptian2"
    
    
    
    -- Sets up Team 2 inventory
    EmptyInventory(1)
    inventory = GetPlayerInventory(1)
    inventory.Bazooka = kWF_INFINITE_AMOUNT
    inventory.Grenade = kWF_INFINITE_AMOUNT
    inventory.FirePunch = kWF_INFINITE_AMOUNT 
    
    
    
--~     player = CreatePlayer("AI")
--~ 	player.NumberOfWorms = 1
--~ 	player.Name = "The Priest"
--~ 	player.WormStartingHealth = 100
--~     player.VoiceBank = "Viking"
--~ 	CreatePlayersTeam(player.PlayerIndex)
    


--~     StandardWorm(GetWormData(9),"Menst","wfRefC2_Menst")
--~     worm = GetWormData(9)
--~     worm.Pushable = false
--~     worm.ArtilleryMode = true
    
    HaveSpawnedOpeningCrate = false
    
    EmptyInventory(2)
    inventory = GetPlayerInventory(2)

    scheme = GetCurrentSchemeData()
    scheme.TurnTime = 4000
    scheme.SuddenDeathTime = 180000
    scheme.RetreatTime = 500
    scheme.HotSeatTime = 500
        
    scheme.CrateProbability = 0
    
    StandardRefereeSettings()
end

function HideWormsNow()

Watch ("PlayersWormsDead")

SetInstantReplaysOn(false)
	
        EffectId1 = CreateParticleEffect("largefire", "wfRefFire")
        EffectId2 = CreateParticleEffect("smallfire", "wfRefSmallFire1")
        EffectId3 = CreateParticleEffect("smallfire", "wfRefSmallFire2")
        EffectId4 = CreateParticleEffect("smallfire", "wfRefSmallFire3")
        EffectId5 = CreateParticleEffect("smallfire", "wfRefSmallFire4")
        EffectId6 = CreateParticleEffect("smallfire", "wfRefSmallFire5")
        EffectId7 = CreateParticleEffect("smallfire", "wfRefSmallFire6")
        EffectId8 = CreateParticleEffect("smallfire", "wfRefSmallFire7")
        EffectId9 = CreateParticleEffect("smallfire", "wfRefSmallFire8")
        EffectId10 = CreateParticleEffect("smallfire", "wfRefSmallFire9")
        EffectId11 = CreateParticleEffect("smallfire", "wfRefSmallFire10") 
	
	
  CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0028", true ) 

	HideWorm( 0 )
	HideWorm( 1 )
	HideWorm( 2 )
	HideWorm( 3 )
	HideWorm( 4 )
	HideWorm( 5 )
	HideWorm( 6 )
	HideWorm( 7 )
	HideWorm( 8 )

	SetEFMVCameraShakeRatio(0.0) 

	Fade(false, 0.2, false)
	ShowOnlyScriptCommentary(true)
	StartAllEFMVTimers()   
	EFMVFlyby()
	--all functions within EFMV
	
end

function SetNextPlayerToGo( playerIndex )
    if playerIndex == 2 then
        return 0
    end

    return playerIndex
end

function TurnEnded(playerTaskId)
    FloodInUse = false

    if CheckAreAllWormsDead(1) == true then
        SetCommentaryText("Miss.Generic.Game")
	
	--outro sequence
	CameraArrayNumber = 10
	--when mission has finished set to 1
	GameHasFinished = 1
	Num = 24
    
    KillParticleEffect(EffectId1)
    KillParticleEffect(EffectId2)
    KillParticleEffect(EffectId3)
    KillParticleEffect(EffectId4)
    KillParticleEffect(EffectId5)
    KillParticleEffect(EffectId6)
    KillParticleEffect(EffectId7)
    KillParticleEffect(EffectId8)
    KillParticleEffect(EffectId9)
    KillParticleEffect(EffectId10)
    KillParticleEffect(EffectId11)
    
	FlushCommentaryText()
	StartAllEFMVTimers()
	EFMVFlyby()
	
    end
    collectgarbage()
end

function OnCreateWeapon(WeaponType) 
    if WeaponType == kWF_WEAPON_FLOOD then 
        FloodInUse = true
    else
        FloodInUse = false
    end 
end 


function CrateCollected()
       
	CameraArrayNumber = 5  
	Num = 16
	GameIsMidSequence = true
	FlushCommentaryText()
	StartAllEFMVTimers()
	EFMVFlyby() -- Starts the EFMV sequence (mid game)

end

  

function WormDied( WormIndex )
    WhatWormJustDied = WormIndex
    
    Human1 = GetWormData( 0 )
    Human2 = GetWormData( 2 )
    Human3 = GetWormData( 3 )
    Human4 = GetWormData( 4 )

    if CheckAreAllWormsDead( 0 ) == true then 
    EndMissionFail() 
    end
    
    if Human1.Health <= 0 and Human1Dead == false then
    PlayersWormsDead = PlayersWormsDead + 1
    Human1Dead = true
    end
    
    if Human2.Health <= 0 and Human2Dead == false then
    PlayersWormsDead = PlayersWormsDead + 1
    Human2Dead = true
    end
    
    if Human3.Health <= 0 and Human3Dead == false then
    PlayersWormsDead = PlayersWormsDead + 1
    Human3Dead = true
    end
    
    if Human4.Health <= 0 and Human4Dead == false then
    PlayersWormsDead = PlayersWormsDead + 1
    Human4Dead = true
    end
    
    if PlayersWormsDead == 4 then
    EndMissionFail() 
    end
    

    --if WormIndex == 0 then
        --EndMissionFail()
        if WormIndex > 4 and WormIndex < 13 then
        if FloodInUse == true then
            SayEnemyDead()
        else
            SetCommentaryText("Miss.Generic.Hint27")
            
            RespawnWorms()
        end
    end
    
    collectgarbage()
end

--Check for the human controlled team dying..



function RespawnWorms()
    SetCommentaryText("Miss.Generic.Hint41")
    
    if WhatWormJustDied == 5 then
        SpawnWorm(5,"wfRefC2_Enemy1")
    elseif WhatWormJustDied == 6 then
        SpawnWorm(6,"wfRefC2_Enemy2")
    elseif WhatWormJustDied == 7 then
        SpawnWorm(7,"wfRefC2_Enemy3")
    elseif WhatWormJustDied == 8 then
        SpawnWorm(8,"wfRefC2_Enemy4")
--    elseif WhatWormJustDied == 9 then
--        SpawnWorm(9,"wfRefC2_Enemy5")
--    elseif WhatWormJustDied == 10 then
--        SpawnWorm(10,"wfRefC2_Enemy6")
--    elseif WhatWormJustDied == 11 then
--        SpawnWorm(11,"wfRefC2_Enemy7")
--    elseif WhatWormJustDied == 12 then
--        SpawnWorm(12,"wfRefC2_Enemy8")
    end
end

function SayEnemyDead()
    -- You've killed X amount of enemy
end

function CheckSuddenDeath()
    collectgarbage()
end

--function CheckVictoryConditions()

function CheckVictoryConditions( )

        referee = GetRefereeData()


  
            if referee.TotalGameTime >= 180000 then
                EndMissionFail()
            end

        
	return false
        
end 

--    collectgarbage()
--    
--    return false
--end

function EndMissionSuccess()


        Unlock("LOCK.Scheme.AirAssault")
        Unlock("LOCK.Fortpot")

        
        if referee.TotalGameTime < 90000 then 
           SetMedal(kGoldMedal)
           Unlock("LOCK.Flag.Egyptian2")
           Unlock("LOCK.Fortapedia.Seth")
        
        
        elseif referee.TotalGameTime < 120000 then 
            SetMedal(kSilverMedal) 
            Unlock("LOCK.Fortapedia.Seth")
        
        
        
        elseif referee.TotalGameTime > 120000 then 
            SetMedal(kBronzeMedal) 
            Unlock("LOCK.Fortapedia.Seth")
        end 
 



    SetCommentaryText("Miss.Generic.Success")
    EndRound(0)
end

function EndMissionFail()
    SetCommentaryText("Miss.Generic.Failed")
    EndRound(1)
end

--~ function Startofmission()
--~     
--~         
--~         
--~     
--~         MenstFound = true
--~         -- Menst explains where to build keep, keep crate spawns, Mummy worms are spawned.
--~         HideWorm(9)

--~         
--~     
--~ end



-- ***********************************************************************************************
-- *                                   Relevant to Chapter 2 Only                                *
-- ***********************************************************************************************

function SetUpLandscape()
    -- remove all the enemy buildings
    --RemoveBuilding("buildHere005")
    --RemoveBuilding("buildHere006")
    --RemoveBuilding("buildHere009")
    --RemoveBuilding("buildHere0010")
    --RemoveBuilding("buildHere0011")
    RemoveBuilding("buildHere0022")
    RemoveBuilding("buildHere0023")
    RemoveBuilding("buildHere0024")
    RemoveBuilding("buildHere0025")
    RemoveBuilding("buildHere0032")
    RemoveBuilding("buildHere0033")
    -- remove the hospitals
    RemoveBuilding("buildHere0026")
    RemoveBuilding("buildHere0027")
    RemoveBuilding("buildHere0028")
    RemoveBuilding("buildHere0029")
end

function Chap2Variables()
    Horus = GetWormData(0)
    MenstFound = false
    FloodInUse = false
    WhatWormJustDied = 0
end




function OnEntrypCubetrigger2( wormTaskId )

    Worm5 = GetWormData(wormTaskId)
	    
    if Worm5.WormIndex == 5 and worm5fell == false then
	    
        worm5fell = true
        SetCommentaryText("Miss.Generic.Hint26")
            
    end
    
    
    Worm6 = GetWormData(wormTaskId)
	    
    if Worm6.WormIndex == 6 and worm6fell == false then
	    
        worm6fell = true
        SetCommentaryText("Miss.Generic.Hint36")    
    end
    
    
    Worm7 = GetWormData(wormTaskId)
	    
    if Worm7.WormIndex == 7 and worm7fell == false then
	    
        worm7fell = true
        SetCommentaryText("Miss.Generic.Hint35")    
    end
    
    
    Worm8 = GetWormData(wormTaskId)
	    
    if Worm8.WormIndex == 8 and worm8fell == false then
	    
        worm8fell = true
        SetCommentaryText("Miss.Generic.Hint40")    
    end
    
	
end 









--**********************************************************************************************************

--					CAMERA STUFF DOWN BELOW

--**********************************************************************************************************

function EFMVFlyby() -- Starts the EFMV sequence
	
	FlushCommentaryText()
	
	--if cameras are active then continue with intro
	 if EFMVCamerasAreActive == true then

		CameraArrayNumber = CameraArrayNumber + 1
		StartEFMV(EFMVArray[CameraArrayNumber], bQuitable)
	
	--if cameras are disabled then start the game
	elseif EFMVCamerasAreActive == false then
		SetGameUpAndCancelEverything()
	end

end

function OnEndEFMV(szSeqName, bUserQuit)

	if bUserQuit == 1 then -- User has skipped EFMV
		SetGameUpAndCancelEverything()

		elseif bUserQuit == 0 then
		
			if CameraArrayNumber == 5  then --last intro cam
				SetGameUpAndCancelEverything()
		
				-- End of the mid-game EFMV Sequence
			elseif CameraArrayNumber == 10 then
				GameIsMidSequence = false
            
				--last sequence in the outro
			elseif CameraArrayNumber == 12 then 
				--Game will end here if the player has completed the mission.
				EndMissionSuccess()
			
			else
				EFMVFlyby()
			
			end
		end
end


function StartAllEFMVTimers() 

	if CameraArrayNumber == 0 then
	
		DelayCall("SpawnHorusAndSeth", 1)
		DelayCall("SpawnPharaohsArmy", 38)
		
		DelayCall("SethWave", 25.5)
		DelayCall("HorusSalute", 26)
		DelayCall("OrientateHorusAndSeth1", 30)
		DelayCall("SethSpeak", 31)
		DelayCall("HorusNod", 32.5)
		DelayCall("HorusNod", 33)
		--DelayCall("SethSpeak", 34)
		DelayCall("OrientateHorusAndSeth2", 39)
		
--~ 		DelayCall("SethInsane", 32)
--~ 		DelayCall("HorusBemused", 33) 
		
		DelayCall("Enemy4Taunt", 38.5)
		DelayCall("Enemy3Taunt", 42)
		DelayCall("Enemy1Taunt", 48)
		DelayCall("Enemy2Taunt", 49)
		DelayCall("Enemy1Taunt2", 52)
		DelayCall("Enemy2Taunt2", 51)
		
		DelayCall("HorusWorried", 54)
		DelayCall("SpawnMummyWorms", 75)
		DelayCall("SethNod", 60)
		DelayCall("SethNod", 60.5)
		DelayCall("SethMagic", 62.5)
		DelayCall("SpawnKeepCrate", 69)
		--DelayCall("HideSeth", 75)
	
	elseif CameraArrayNumber == 5 then
		
		DelayCall("SpawnSethAgain", 0)
		DelayCall("SethTalk", 2)
		DelayCall("HideSethAgain", 6)
		
	elseif CameraArrayNumber == 10 then
	
		DelayCall("SpawnHorusFinal", 0)
		DelayCall("SpawnSethFinal", 0)
		DelayCall("HideRemainingMummyWormsAndSetWaterLevel", 0)
		DelayCall("SethOutroNod", 2)
		DelayCall("HorusBemused", 3)
		DelayCall("SethClueless", 6)
	end
end


-------------------------------INTRO STUFF---------------------------------

function SpawnHorusAndSeth()
	CreateParticleEffect("wormspawnA", "wfRefC2_Horus") 
	SpawnWorm(0, "wfRefC2_Horus")
	OrientateWorm(0, 230)
	SpawnWorm(1, "wfRefEFMVSeth")
	OrientateWorm(1, 205)
end

function OrientateHorusAndSeth1()
	OrientateWormToWorm(0, 1)
	OrientateWormToWorm(1, 0)
end

function SethSpeak()
	WormResetAnim(1) 
	WormQueueAnim(1, "worm_speak3")
	
	DelayCall("SethSpeak", 1.76)
end

function HorusNod()
	WormResetAnim(0) 
	WormQueueAnim(0, "worm_nod")
end

function HorusSalute()
	WormResetAnim(0) 
	WormQueueAnim(0, "worm_confident")
end

function SethWave()
	WormResetAnim(1) 
	WormQueueAnim(1, "worm_wave1")
end

function OrientateHorusAndSeth2()
--~ 	WormResetAnim(0)
--~ 	WormQueueAnim(0, "neutral")
	OrientateWorm(0, 250)
	OrientateWorm(1, 208)
end

--~ function SethInsane()
--~ 	WormResetAnim(1) 
--~ 	WormQueueAnim(1, "worm_insane")
--~ end

--~ function HorusBemused()
--~ 	WormResetAnim(0) 
--~ 	WormQueueAnim(0, "worm_bemused")
--~ end

function SpawnPharaohsArmy()

	CreateParticleEffect("wormspawnA", "wfRefC2_Enemy1")
	SpawnWorm(5, "wfRefC2_Enemy1")
	OrientateWorm(5, 260) 
	CreateParticleEffect("wormspawnA", "wfRefC2_Enemy2")
	SpawnWorm(6, "wfRefC2_Enemy2")
	OrientateWorm(6, 230) 
	CreateParticleEffect("wormspawnA", "wfRefC2_Enemy3")
	SpawnWorm(7, "wfRefC2_Enemy3")
	OrientateWorm(7, 300 ) 
	CreateParticleEffect("wormspawnA", "wfRefC2_Enemy4")
	SpawnWorm(8, "wfRefC2_Enemy4")
	OrientateWorm(8, 243 ) 
end

function Enemy1Taunt()
	WormResetAnim(5) 
	WormQueueAnim(5, "worm_comeon1")
end

function Enemy1Taunt2()
	WormResetAnim(5) 
	WormQueueAnim(5, "worm_confident")
end

function Enemy2Taunt2()
	WormResetAnim(6) 
	WormQueueAnim(6, "win2")
end

function Enemy2Taunt()
	WormResetAnim(6) 
	WormQueueAnim(6, "angry1")
end

function Enemy3Taunt()
	WormResetAnim(7) 
	WormQueueAnim(7, "angry2")
end

function Enemy4Taunt()
	CancelDelayCall("SethSpeak")
	WormResetAnim(8) 
	WormQueueAnim(8, "angry3")
end

function HorusWorried()
	WormResetAnim(0)
	WormQueueAnim(0, "scared2")
end

function SpawnMummyWorms()
	SpawnWorm(2, "wfRefC2_Mummy2")
	SpawnWorm(3, "wfRefC2_Mummy3")
	SpawnWorm(4, "wfRefC2_Mummy4")
end

function SethNod()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_nod")
end

function SethMagic()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_spellcast")
end

function SpawnKeepCrate()

	HaveSpawnedOpeningCrate = true
	
	CreateParticleEffect("weaponspawnA", "wfRefC2_Keep")
	crate = CreateCrate()
	crate.Contents = kWF_BUILDING_KEEP
	crate.CrateId = 1
	crate.TeamDestructible = 10
	crate.TeamCollectable = 0
	crate.FixedPosition = false
	crate.Destructible = false
	crate.Pushable = false
	crate.CollectableByPayload = false
	crate.Collectable = true
	crate.GroundSnap = false
	SpawnCrate(WhichCrate,"wfRefC2_Keep")
end

function HideSeth()
	HideWorm(1)
end

--------------MID SEQUENCE: CAM = 5 / Num = 16 -------------------

function SpawnSethAgain()
	SpawnWorm(1, "wfRefEFMVSeth")
	OrientateWorm(1, 220)
	WormResetAnim(1)
	WormQueueAnim(1, "worm_speak4")
end

function SethTalk()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_directingheave")
end

function HideSethAgain()
	HideWorm(1)
end


--------------------OUTRO: CAM = 10 / Num = 24 ------------------------
function HideRemainingMummyWormsAndSetWaterLevel()
	SpawnWorm(2)
	SpawnWorm(3)
	SpawnWorm(4)
	HideWorm(2)
	HideWorm(3)
	HideWorm(4)
	SetBarrierLevel(1000)
end

function SpawnHorusFinal()
	HideWorm(0)
	SpawnWorm(0, "wfRefEFMVHorus")
	OrientateWorm(0, 220)
end

function HorusBemused()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_bemused")
end

function SethOutroNod()
	WormResetAnim(1)
	WormQueueAnim(1, "disappointed1")
end

function SpawnSethFinal()
	SpawnWorm(1, "wfRefEFMVSeth1")
	OrientateWorm(1, 220)
	--WormResetAnim(1)
	--CreateExplosionEffects("wfRefEFMVSeth1", kWF_EXPLOSION_SMALL, false)
	WormQueueAnim(1, "worm_clueless")
	
end

function SethClueless()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_bemused")
end

function SetGameUpAndCancelEverything() 
-- Called if the user skips the efmv sequence or the sequence has ended.

	if GameIsMidSequence == true then 
	
		if CameraArrayNumber > 5 then
		
			HideWorm(1)
		
--~ 			CancelDelayCall("SpawnSethAgain")
--~ 			CancelDelayCall("SethTalk")
--~ 			CancelDelayCall("HideSethAgain")
		end
	end
	
	if GameHasFinished == 1 then
		EndMissionSuccess()
		 
	elseif GameHasFinished == 0 and GameIsMidSequence == false then
	
		--set the game up to its intial state
	
		
--~ 		Chap2Variables()
		
		SetBarrierLevel(wlevel)
		
		SetBriefingBoxPosition(0,0) 
		SetBriefingBoxSize(190,120) 
		CreateBriefingBox("Miss.Egypt2-Objectives")
		
		--cancel all timers
		CancelDelayCall("SpawnHorusAndSeth")
		CancelDelayCall("SpawnPharaohsArmy")
		
		CancelDelayCall("SethWave")
		CancelDelayCall("HorusSalute")
		CancelDelayCall("OrientateHorusAndSeth1")
		CancelDelayCall("SethSpeak")
		CancelDelayCall("HorusNod")
		CancelDelayCall("HorusNod")
		CancelDelayCall("SethSpeak")
		CancelDelayCall("OrientateHorusAndSeth2")
		
		CancelDelayCall("Enemy4Taunt")
		CancelDelayCall("Enemy3Taunt")
		CancelDelayCall("Enemy1Taunt")
		CancelDelayCall("Enemy2Taunt")
		CancelDelayCall("Enemy1Taunt2")
		CancelDelayCall("Enemy2Taunt2")
		
		CancelDelayCall("HorusWorried")
		CancelDelayCall("SpawnMummyWorms")
		CancelDelayCall("SethNod")
		CancelDelayCall("SethNod")
		CancelDelayCall("SethMagic")
		CancelDelayCall("SpawnKeepCrate")
		--CancelDelayCall("HideSeth")
		
		-- check if the keep crate was spawned in during efmv
		if HaveSpawnedOpeningCrate == false then
		
			CancelDelayCall("SpawnKeepCrate")		
			SpawnKeepCrate()
			
		end
		-- sets crate and mummy army up
		--DelayCall("Startofmission", 2)
--~ 		
--~ 		SpawnWorm(1)
		HideWorm(1)
		
		
		SpawnWorm(0, "wfRefC2_Horus")
		SpawnWorm(2, "wfRefC2_Mummy2")
		SpawnWorm(3, "wfRefC2_Mummy3")
		SpawnWorm(4, "wfRefC2_Mummy4")
		SpawnWorm(5, "wfRefC2_Enemy1")
		SpawnWorm(6, "wfRefC2_Enemy2")
		SpawnWorm(7, "wfRefC2_Enemy3")
		SpawnWorm(8, "wfRefC2_Enemy4")
	end
end	
	
--------------- TEXT CODE------------------------------

function EFMV_TextTrigger() 
    
    if Num == 29 then
	
		Fade(true, 3, true)
    end
    
    Text = TextLabelsArray[Num]

-- (-1) is infinite, (0) is default to 2000 (2 secs)
    SetCommentaryText(Text, -1)
    
    Num = Num + 1

end 

function EFMV_TextTriggerEnd() 

-- Do something to turn the current text thingy off.

--put in as a parameter the delay in miliseconds
-- (0) means no delay, it will hide it straight away
   HideCurrentText(0)
    
end 

--~ function TurnEnded()
--~ 	CameraArrayNumber = 10
--~ 	Num = 24
--~ 	--GameIsMidSequence = true
--~ 	EFMVFlyby()
--~ 	
--~ 	
--~ end

