
--***********************************************************
--                Egyptian Mission 4 chapter 1
--      The all powerful seth no goads our player into a
--      response after revealing his true evil intent.
--      The player must take horus and recover as many crates
--      possible in order to wipe Seths buildings from the map.
--      Seth will sportingly give Horus a few turns start before 
--      he unleashes his minions.
--***********************************************************

function InitialiseLevel()
    LoadLevel("landscapes/E/E4.xom", true)

    -- global variables
    
    CurrentTurn = 0
    Num = 1
    Counter = 2
    CrateID = 0
    CrateIndex = 0
    CycleTurn = 0
    Util_ID = 0
    Util_Index = 0
    BuildingDestroyed = false
    CrateSpawnID = 1
    CrateSpawn_Index = 0
    NumberOfEnemy = 0
    Turn = 0
    
     SetObjectives("Miss.Egypt4-Objectives", 3)
        
    HorusSpawned = false
    SethSpawned = false
    EnemyBuildingsSpawned = false
    PlayersBuildingSpawned = false
--~     bQuitable = true

   
    -- establish a couple of few arrays
    CrateList = { "wfRefCrate000", "wfRefCrate001", "wfRefCrate002", "wfRefCrate003", "wfRefCrate004", "wfRefCrate005" } 
    wContents = { kWF_BUILDING_TOWER, kWF_BUILDING_KEEP, kWF_BUILDING_CASTLE, --citadel is for debug use
                        kWF_WEAPON_BATTERING_RAM, kWF_WEAPON_FIRE_GRENADE_LAUNCHER, kWF_WEAPON_MINI_GUN }  
    CrateContents = { kWF_WEAPON_CLUSTER_LAUNCHER, kWF_WEAPON_BALLISTA, kWF_WEAPON_MORTAR, kWF_BUILDING_TOWER }
    
    SethsSpawnPoints = { "wfRefSeth1", "wfRefSeth2", "wfRefSeth3", "wfRefSeth4", "wfRefSeth5" } 
    
    
    -- Initialise a basic scheme
    
    scheme = GetCurrentSchemeData()
    

    scheme.CrateProbability = 0
    scheme.TurnTime = 4500
    scheme.SuddenDeathTime = 180000
    scheme.RetreatTime = 300
    scheme.HotSeatTime = 500

    scheme.ResourceMax = 32


    
--    SetupDefaultScheme()

	--efmv ONLY cut names, ARRAYS and variables
	bQuitable = true
	bUserQuit = 0
	CameraArrayNumber = 0
	GameHasFinished = 0
	TextNum = 1
	
	-- stops the victory sequence from playing
	referee = GetRefereeData()
        referee.ShowVictorySequence = false
	
	--switch to false to disable cameras
	EFMVCamerasAreActive = true
	
	
	
	TextLabelsArray = { "Miss.Egypt4-EFMV.Intro1", "Miss.Egypt4-EFMV.Intro2", "Miss.Egypt4-EFMV.Intro3",	
					"Miss.Egypt4-EFMV.Intro4", "Miss.Egypt4-EFMV.Intro5", "Miss.Egypt4-EFMV.Intro6",	
					"Miss.Egypt4-EFMV.Intro7", "Miss.Egypt4-EFMV.Intro8", "Miss.Egypt4-EFMV.Intro9",	
					"Miss.Egypt4-EFMV.Intro10", "Miss.Egypt4-EFMV.Intro11", "Miss.Egypt4-EFMV.Intro12",	
					"Miss.Egypt4-EFMV.Intro13", "Miss.Egypt4-EFMV.Intro14", "Miss.Egypt4-EFMV.Intro15",	
					"Miss.Egypt4-EFMV.Intro16", "Miss.Egypt4-EFMV.Outro1", "Miss.Egypt4-EFMV.Outro2" }
    
	EFMVArray = { "TestFlybyClip", "Seth1Clip", "StaticShot1", "StaticShot2", "StaticShot3", "SlowZoomSeth1", "StaticShot4", 
				"SlowPan1", "SlowZoomOutandPanDown1", "MultiCuts", "SlowZoomOut2", "Outro1", "Outro2", "Outro3" } 

end


function CreatePlayers()

    
--        CreateStandardPlayer("HUMAN",1,"Horus","Classic") 
--        player.WormStartingHealth = 150
--        GetPlayerData(0).MaxJetpackFuel = 1000
--        StandardWorm(GetWormData(0),"Horus", "wfRefHorus1")                
--        --GetWormData(0,0).VitalWorm = true   -- Horus is the vital worm
--        worm = GetWormData(0)
--        worm.JetpackFuel = 1000
        
        
        
        SetupHumanPlayer(1,100)
        player = GetPlayerData(0)
        player.SpecialWeapon =  "kNoSpecialWeapon"
        GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRefHorus1"
        
        
        CreateStandardPlayer("AI",4,"Pharaoh and his Henchmen","Classic")
        GetPlayerData(1).MaxJetpackFuel = 0
        StandardWorm(GetWormData(1),"Pharaoh", "wfRefSeth1")
        CopyContainer( GetAIParamsCPU3(), GetAIParamsWorm(1) )
        GetAIParamsWorm(1).WeightingWormVital = 1.5
	
	player = GetPlayerData(1)
	player.WormStartingHealth = 200
	
        --------------
        player.Flag = 72
        --------------
	
        worm = GetWormData(1)
        worm.Health = 200
        worm.ArtilleryMode = true
        worm.Pushable = false

        
        StandardWorm(GetWormData(2),"Undead Priest", "wfRefUndead1")
        StandardWorm(GetWormData(3),"Decomposing Slave", "wfRefUndead2")
        StandardWorm(GetWormData(4),"Rotting Reject", "wfRefUndead3")
        CopyContainer( GetAIParamsCPU3(), GetAIParamsWorm(2) )
        GetAIParamsWorm(2).WeightingWormVital = 1
        
        CopyContainer( GetAIParamsWorm(2), GetAIParamsWorm(3) ) 
        CopyContainer( GetAIParamsWorm(2), GetAIParamsWorm(4) ) 
        
        CreateNeutralWorm(5) --dummy horus worm
        CreateNeutralWorm(6) --dummy pharaoh worm
        CreateNeutralWorm(7) -- dummy seth worm
        SetWormHatFromPlayer(5,0)
        
        
        
        
        --Let's sort out some hats.
        
--	Worm = GetWormData(0) 
--        Worm.HatOverride = "NoHat"
--	
         --Seth
        Worm = GetWormData(1) 
        Worm.HatOverride = "Hat.Egyptian1"
	        
        --Seth's Henchman
	Worm = GetWormData(2) 
        Worm.HatOverride = "Hat.Egyptian2"
		
	Worm = GetWormData(3) 
        Worm.HatOverride = "Hat.Egyptian2"
	        
	Worm = GetWormData(4) 
        Worm.HatOverride = "Hat.Egyptian2"
	        
        
	Worm = GetWormData(6) 
        Worm.HatOverride = "Hat.Egyptian1"
	
	Worm = GetWormData(7) 
        Worm.HatOverride = "Hat.Egyptian3"
        
        ------------------------------
        
        
        
        EmptyInventory(0)
        inventory = GetPlayerInventory(0)   -- Empty out the inventory
        inventory.Jetpack = 4
        inventory.Bazooka = kWF_INFINITE_AMOUNT
        inventory.Grenade = kWF_INFINITE_AMOUNT
        inventory.Mortar = 5
        inventory.FireWeapon = 4
        inventory.AirStrike = 3
        inventory.ClusterLauncher = 4
        inventory.FireGrenadeLauncher = 3
        inventory.RepairBuilding = 2
        inventory.Tower = 5
        inventory.Keep = 5
        inventory.Surrender = 0
        --inventory.Trebuchet = 5

        inventory.BatteringRam = 3 
        
	
        EmptyInventory(1)
        inventory = GetPlayerInventory(1)   -- Give Seth infinite god power
    --    inventory.ElectricalStorm = kWF_INFINITE_AMOUNT;
        inventory.AirStrike = kWF_INFINITE_AMOUNT;
        inventory.Bazooka = kWF_INFINITE_AMOUNT;
        inventory.Grenade = kWF_INFINITE_AMOUNT;
        inventory.AirStrikeDelay = 12
        inventory.MiniGunDelay = 5
        SpawnCrates()
    
    
    
end

function HideWormsNow()

	SetEFMVCameraShakeRatio(0.0) -- Turn the camera shake off
	
    SetInstantReplaysOn(false)
    
	crate = CreateCrate()
	crate.Contents = kWF_WEAPON_AIR_STRIKE
	crate.NumContents = 1	
	crate.CrateId = 99		
	crate.TeamDestructible = 1		
	crate.WormCollectable = 0		
	crate.TeamCollectable = 0		
	crate.GroundSnap = false		
	crate.FixedPosition = true		
	crate.UXB = false				
	crate.Destructible = false		
	crate.Pushable = false			
	crate.CollectableByPayload = false	
	crate.Collectable = true	
	crate.IsCritical = false
	SpawnCrate(99,"wfRefcrate1")
	
	HideWorm(0)
	HideWorm(1)
	HideWorm(2)
	HideWorm(3)
	HideWorm(4)
	
	--ShowOnlyScriptCommentary(true)
	
	StartAllEFMVTimers()
	EFMVFlyby()
	FlushCommentaryText()
        
end






function Briefing1()

   

end

function CheckVictoryConditions( )

	return false
end 


--////////////////////////////////////////////////////////////////////////////////
--//                                                                            //
--//            Ensure Seth takes no damage, Seth is indestructible             //
--//                                                                            //
--////////////////////////////////////////////////////////////////////////////////

-- returns the actual damage the worm should take
function WormDamaged( damagedWormIndex, AssailantTaskId, damageTaken )

	
	if damagedWormIndex == 1 then
		return 0
	end

	return damageTaken
end



function TurnEnded(playerTaskId)




--    CameraArrayNumber = 11
--    StartAllEFMVTimers()
--    EFMVFlyby()

    CurrentTurn = CurrentTurn + 1
    
    CycleTurn = CycleTurn + 1
    
    if BuildingDestroyed == false then
        SpawnEnemy()
    end
    
    SpawnCrates()
    --MoveSeth()
    SpawnRepairUtil()
    CheckTime()
    
    if BuildingDestroyed == true then
        SpawnCratePerTurn()
    end

    
end




--////////////////////////////////////////////////////////////////////////////////
--//                                                                            //
--//            Seth appears to spawn in more opponents each new turn           //
--//            bar the first few.                                              //
--//                                                                            //
--////////////////////////////////////////////////////////////////////////////////


function SpawnEnemy()

    if CurrentTurn == 4 then
        SpawnWorm(2, "wfRefUndead1")
        NumberOfEnemy = NumberOfEnemy + 1
    elseif CurrentTurn == 12 then
        SpawnWorm(3, "wfRefUndead2")
        NumberOfEnemy = NumberOfEnemy + 1
    elseif CurrentTurn == 20 then
        SpawnWorm(4, "wfRefUndead3")
        NumberOfEnemy = NumberOfEnemy + 1    
    end

    AddToInventory()
    
end


--////////////////////////////////////////////////////////////////////////////////
--//                                                                            //
--//            Gently increase enemy inventory stock to ratchet up             //
--//            the difficulty.                                                 //
--//                                                                            //
--////////////////////////////////////////////////////////////////////////////////


function AddToInventory()

    inventory = GetPlayerInventory(1)

    if CurrentTurn == 4 then
        inventory.Mortar = kWF_INFINITE_AMOUNT;
        inventory.ClusterLauncher = kWF_INFINITE_AMOUNT;
        inventory.Ballista = kWF_INFINITE_AMOUNT;
    elseif CurrentTurn == 12 then
        inventory.FireGrenadeLauncher = kWF_INFINITE_AMOUNT;
        inventory.MineStrike = kWF_INFINITE_AMOUNT;
        inventory.MiniGun = kWF_INFINITE_AMOUNT;
        inventory.FireWeapon = kWF_INFINITE_AMOUNT;
    elseif CurrentTurn == 24 then
        inventory.GiantCrossbow = kWF_INFINITE_AMOUNT;
        inventory.BananaBombLauncher = kWF_INFINITE_AMOUNT;
    end

end


function SpawnCrates()

    while Num < 7 do
    
        WeapRefPoint = CrateList[Num]
        Crate_Contents = wContents[Num]
        
        crate = CreateCrate()
        crate.Model = "Crate.Weapon"
        crate.Contents = Crate_Contents         -- what is in the crate.
        crate.CrateId = CrateID   		-- id only used and set by scripts
        crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
        crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
        crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
        crate.Destructible = false		-- whether crate can be destroyed.
        crate.Pushable = false		        -- whether crate can be moved by weapons.
        crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
        crate.Collectable = true		-- whether crate can be collected
        crate.GroundSnap = true
        SpawnCrate(CrateIndex, WeapRefPoint)
        
        Num = Num + 1
        CrateID = CrateID + 1
        CrateIndex = CrateIndex + 1
    
    end

end


--////////////////////////////////////////////////////////////////////////////////////////////////
--//                                                                                            //
--//            Move seth to 1 of 5 points around the map so it looks like he's everywhere      //
--//                                                                                            //
--////////////////////////////////////////////////////////////////////////////////////////////////

--function MoveSeth()

--        counter = RandomRange(4, true) -- randomise an integer between 1 and 5 
--        counter = counter + 1
--        
--        SethPoint = SethsSpawnPoints[counter]
--        
--        MoveWorm(1, SethPoint)

--end



function SpawnRepairUtil()

        counter = RandomRange(5, true) -- randomise an integer between 1 and 5 
        counter = counter + 1
        
        RepairPoints = CrateList[counter]
        
        if CycleTurn == 4 then
        
            crate = CreateCrate()
            crate.Model = "Crate.Weapon"
            crate.Contents = kWF_UTILITY_REPAIR_BUILDING
            crate.CrateId = Util_ID   		-- id only used and set by scripts
            crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
            crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
            crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
            crate.Destructible = false		-- whether crate can be destroyed.
            crate.Pushable = false		        -- whether crate can be moved by weapons.
            crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
            crate.Collectable = true		-- whether crate can be collected
            crate.GroundSnap = true
            SpawnCrate(Util_Index, RepairPoints)
            
            Util_ID = Util_ID + 1
            Util_Index = Util_Index + 1
            CycleTurn = 0
        end
                
   
end



function SpawnCratePerTurn()

    
        counter = RandomRange(5, true) -- randomise an integer between 1 and 5 
        counter = counter + 1

        CrateSpawnPoints = CrateList[counter]
        Weapon = CrateContents[counter]
        
        if CycleTurn == 4 then
            crate = CreateCrate()
            crate.Model = "Crate.Weapon"
            crate.Contents = Weapon
            crate.CrateId = Util_ID   		-- id only used and set by scripts
            crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
            crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
            crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
            crate.Destructible = false		-- whether crate can be destroyed.
            crate.Pushable = false		        -- whether crate can be moved by weapons.
            crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
            crate.Collectable = true		-- whether crate can be collected
            crate.GroundSnap = true
            SpawnCrate(CrateSpawn_Index, WCrateSpawnPoints)
            
            CrateSpawnID = CrateSpawnID + 1
            CrateSpawn_Index = CrateSpawn_Index + 1
            CycleCrateTurn = 0
        end
  
end



function CheckTime()

    referee = GetRefereeData()
    TotalTime = referee.TotalGameTime
    
    if TotalTime >= 180000 then
        EndMissionFail()
    end

end

function ClearTheRoom()
	RemoveAllBuildings()
end

function BuildingHasBeenDestroyed( PlayerId, BuildingType )

    -- a building has been destroyed at the start

    StrongholdPoint = GetBuildPointInfo("buildHere0010")
    

    if StrongholdPoint.BuildingType ~= kWF_BUILDING_STRONGHOLD then
    CheckObjective(1)
		
		CameraArrayNumber = 11 --skip camera to outro
		GameHasFinished = 1 --when mission has finished set to 1
		TextNum = 17
		
		FlushCommentaryText()
		DelayCall("StartAllEFMVTimers", 1) -- ****when replays are sorted alter this delaytimer****
		DelayCall("EFMVFlyby", 1.5)
		DelayCall("ClearTheRoom", 1.5) 
    end
    
    weaklink = GetBuildPointInfo( "buildHere008" )
    
    if weaklink.BuildingType ~= kWF_BUILDING_KEEP and BuildingDestroyed == false then
        CheckObjective(2)
        SetCommentaryText("Miss.Egyptian4a.Weak")
        
        inventory = GetPlayerInventory(0)
        inventory.BananaBombLauncher = 4
        inventory.GiantCrossbow = 1
        inventory.AirStrike = (inventory.AirStrike + 2)
    
        inventory = GetPlayerInventory(1)   -- Empty out the inventory
        inventory.Jetpack = 5
        inventory.Tower = 4
        inventory.Keep = 2
        inventory.Castle = 1
        
        inventory.Bazooka = kWF_INFINITE_AMOUNT
        inventory.Mortar = 3
        inventory.Grenade = kWF_INFINITE_AMOUNT
        inventory.ClusterLauncher = 3
        inventory.FireGrenadeLauncher = 2
        inventory.Ballista = 3
        inventory.MiniGun = 2
        
        if NumberOfEnemy < 1 then
            SpawnWorm(2, "wfRefUndead1")
        end
        
        if NumberOfEnemy < 2 then
            SpawnWorm(3, "wfRefUndead2")
        end
        
        if NumberOfEnemy < 3 then
            SpawnWorm(4, "wfRefUndead3")
        end
        
        BuildingDestroyed = true
    end

end


--////////////////////////////////////////////////////////////////////////
--//                                                                    //
--//            Function to check whether horus has died                //
--//                                                                    //
--////////////////////////////////////////////////////////////////////////

function WormDied( wormTaskId )

               
    if CheckAreAllWormsDead( 0 ) == true then 
    EndMissionFail() 
    end          
               
	-- a worm somewhere has worm died, hope its not Horus 
	 
	--HorusWorm = GetWormData( 0, 0 )
	
--	if HorusWorm.Health <= 0 then	
            -- Horus has died so player 1 (AI) has won!!
  --          HorusHasDied = true
            --EndNeverEndingTurn( 0 )--Not needed as the game is going to end anyway
    --        EndMissionFail()
      --  end
        
        --// nice!

	collectgarbage()
end 


function CheckVictoryConditions( )
	return false
end 


function CheckSuddenDeath()
    return 0
end


function EndMissionSuccess()

        Unlock("LOCK.Scheme.Breathing")
        
        if referee.TotalGameTime < 90000 then 
           SetMedal(kGoldMedal)
           Unlock("LOCK.Gravestone.Egyptian1")
            Unlock("LOCK.Fortapedia.Ra")

        elseif referee.TotalGameTime < 120000 then 
            SetMedal(kSilverMedal) 
            Unlock("LOCK.Fortapedia.Ra")
        
        elseif referee.TotalGameTime > 120000 then 
            SetMedal(kBronzeMedal) 
            Unlock("LOCK.Fortapedia.Ra")
        end 

	SetCommentaryText("Miss.Generic.Success")
	EndRound(0)
end

function EndMissionFail()

    SetCommentaryText("Miss.Generic.Failed")
    EndRound(1)
    
end









--**********************************************************************************************************

--					CAMERA STUFF DOWN BELOW

--**********************************************************************************************************

function StartAllEFMVTimers() 
--~ 	
	if CameraArrayNumber == 0 then
	
		DelayCall("HelloHorus", 26)
		DelayCall("HorusWave", 29)
		DelayCall("HorusLook", 31.5)
		DelayCall("EnterPharaoh", 41)
		DelayCall("PharaohNutter", 41.5)
		DelayCall("HorusCower", 45)
		DelayCall("HorusNod", 48)
		DelayCall("HorusNod", 48.5)
		DelayCall("PharaohNutter2", 51) 	
		DelayCall("PharaohSpellcast", 56)
		DelayCall("PharaohVanish1", 59)
		DelayCall("SpawnEnemyBuildings", 62)
		DelayCall("HorusThink", 62)
		DelayCall("HorusUnderstands", 72)
		DelayCall("SpawnPlayersStronghold", 74)
		DelayCall("HorusPuzzled", 84.5) 
		DelayCall("SpawnSeth", 87)
		DelayCall("SethScared", 88)
		DelayCall("HideSeth", 90)
		DelayCall("HorusScared", 91.5)
	
	elseif CameraArrayNumber == 11 then
		
		-- SPP Hide the pharoah worm before the neutral one take over
		HideWorm(1)
		
		--DelayCall("HideHorus", 0.1)
		DelayCall("SpawnHorusAgain", 0)
		DelayCall("SpawnPharaohAgain", 1)
		DelayCall("HorusCelebrateA", 1)
		DelayCall("AngryPharaoh", 3)
		DelayCall("PharaohVanish2", 5)
		DelayCall("HorusCelebrateB", 7)
		--DelayCall("FadeToBlack", 11)
	end
end

----------------------------INTRO STUFF----------------------------------------

function HelloHorus()
	--Worm = GetWormData(0) 
      --  Worm.HatOverride = "NoHat"
	
	SpawnWorm(0, "wfRefHorus1")
end

function HorusWave()
	WormAllowIdleAnims(0, false) 
	WormResetAnim(0)
	WormQueueAnim(0, "worm_wave1")
end

function HorusLook()
	WormResetAnim(0)
	WormQueueAnim(0, "looklefttoright")
end

function EnterPharaoh()
	CreateParticleEffect("wormspawnB", "wfRefSeth1")
	SpawnWorm(1, "wfRefSeth1")
	OrientateWorm(1, 270)
end

function PharaohNutter()
	WormResetAnim(1)
	WormQueueAnim(1, "angry2")
end

function HorusCower()
	WormResetAnim(0)
	WormQueueAnim(0, "cower1")
end

function HorusNod()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_nod")
end

function PharaohNutter2()
	WormResetAnim(1)
	WormQueueAnim(1, "happy1")
end


function PharaohSpellcast()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_spellcast")
end

function PharaohVanish1()
	CreateParticleEffect("wormspawnB", "wfRefSeth1")
--	HideWorm(1)
end

function SpawnEnemyBuildings()

	-- enemy buildings
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0010")
	ModifyBuildingHealth("buildHere0010", 50, true)
	
	CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere008")
	CreateBuilding( kWF_BUILDING_CASTLE, 1, "buildHere007")
	CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere005")
	CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere003")
	CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere004")
	--CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere006")
	
	--EnemyBuildingsSpawned = true
    
end

function HorusThink()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_contemplates")
end

function HorusUnderstands()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_understands")
end

function SpawnPlayersStronghold()
        -- players stronghold
        CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHerePlayerStronghold")
       -- PlayersBuildingSpawned = true
end

function HorusPuzzled()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_puzzled")
end 	

function SpawnSeth()
	CreateParticleEffect("wormspawnA", "wfRefSeth2")
	SpawnWorm(7, "wfRefSeth2")
end

function SethScared()
	WormResetAnim(7)
	WormQueueAnim(7, "scared1")
end

function HideSeth()
	CreateParticleEffect("wormspawnA", "wfRefSeth2")
	HideWorm(7)
end

function HorusScared()
	WormResetAnim(0)
	WormQueueAnim(0, "scared2")
end 	

-------------------OUTRO: CAM = 11 / Num = 17-------------------------------

--~ function HideHorus()
--~ 	HideWorm(0)
--~ end

function SpawnHorusAgain()
	--Worm = GetWormData(5) 
        --Worm.HatOverride = "NoHat"
	
	HideWorm(0)
	SpawnWorm(5, "wfRefHorus1")
end

function SpawnPharaohAgain()
	SpawnWorm(6, "wfRefSeth1")
	OrientateWorm(6, 270)
end

function HorusCelebrateA()
	--OrientateWorm(0, 230)
	WormAllowIdleAnims(5, false) 
	WormResetAnim(5)
	WormQueueAnim(5, "happy2")
end

function AngryPharaoh()
	WormResetAnim(6)
	WormQueueAnim(6, "worm_shakefist")
end

function PharaohVanish2()
	CreateExplosionEffects("wfRefSeth1", kWF_EXPLOSION_MEDIUM, false) 
	HideWorm(6)
end

function HorusCelebrateB()
    WormSay(5, "Victory")
	WormAllowIdleAnims(5, false)
	--WormResetAnim(5)
	WormQueueAnim(5, "happy3")
	
	DelayCall("HorusCelebrate", 2.05)
end

function FadeToBlack()
	Fade( true, 3, true )
end
----------------------------------------------------------------------------------
function EFMVFlyby() -- Starts the EFMV sequence
	
	SetInstantReplaysOn(false)
	
	--if cameras are active then continue with intro
	 if EFMVCamerasAreActive == true then

		CameraArrayNumber = CameraArrayNumber + 1
		StartEFMV(EFMVArray[CameraArrayNumber], bQuitable)
	
	--if cameras are disabled then start the game
	elseif EFMVCamerasAreActive == false then
		SetGameUpAndCancelEverything()
	end

end

function OnEndEFMV(szSeqName, bUserQuit)

	if bUserQuit == 1 then -- User has skipped EFMV
		SetGameUpAndCancelEverything()

		elseif bUserQuit == 0 then
		
		if CameraArrayNumber < 11 then
			EFMVFlyby()
		
		elseif CameraArrayNumber == 11  then --last intro cam
			SetGameUpAndCancelEverything()
			
--~ 		elseif CameraArrayNumber == 12  then 
--~ 			EFMVFlyby()

		--last sequence in the outro
		elseif CameraArrayNumber == 14 then 
			--Game will end here if the player has completed the mission.
			EndMissionSuccess()
		else
			EFMVFlyby()
		end
	end	
end

function SetGameUpAndCancelEverything() 
-- Called if the user skips the efmv sequence or the sequence has ended.

	if GameHasFinished == 1 then
		EndMissionSuccess()
		
	elseif GameHasFinished == 0 then
		
		--set the game up to its intial state
		SetBriefingBoxPosition(0,0) 
		SetBriefingBoxSize(190,120) 
		CreateBriefingBox("Miss.Egypt4-Objectives")
		
		WormAllowIdleAnims(0, true) 
		SetEFMVCameraShakeRatio(1.0) -- Turn the camera shake on
		
		CancelDelayCall("HelloHorus")
		CancelDelayCall("HorusWave")
		CancelDelayCall("EnterPharaoh")
		CancelDelayCall("PharaohNutter")
		CancelDelayCall("HorusNod")
		CancelDelayCall("HorusNod")
		CancelDelayCall("PharaohNutter2") 	
		CancelDelayCall("PharaohSpellcast")
		CancelDelayCall("PharaohVanish1")
		CancelDelayCall("SpawnEnemyBuildings")
		CancelDelayCall("HorusThink")
		CancelDelayCall("HorusUnderstands")
		CancelDelayCall("SpawnPlayersStronghold")
		CancelDelayCall("HorusPuzzled") 
		CancelDelayCall("SpawnSeth")
		CancelDelayCall("SethScared")
		CancelDelayCall("HideSeth")
		CancelDelayCall("HorusScared")
		
		SpawnMine("wfRefMine001")
		SpawnMine("wfRefMine002")
		SpawnMine("wfRefMine003")
		SpawnMine("wfRefMine004")
		SpawnMine("wfRefMine005")
		
		RemoveAllBuildings()

		SpawnEnemyBuildings()
		SpawnPlayersStronghold()		
		
		FlushCommentaryText()
		
--~ 		SpawnHorus()
		
		SpawnWorm(0, "wfRefHorus1")

		--SPP Set health for enemy team here
		player = GetPlayerData(1)
		player.WormStartingHealth = 200		
		SpawnWorm(1)-- SPP, this was commented out				
		player.WormStartingHealth = 50
		SpawnWorm(2)		
		SpawnWorm(3)		
		SpawnWorm(4)
			
	end	
end

--------------- TEXT CODE------------------------------

function EFMV_TextTrigger() 
    
	if Num == 18 then
	    
		Fade(true, 3, true)
	end
	
	if TextNum < 19 then
	
	    Text = TextLabelsArray[TextNum]
	
	-- (-1) is infinite, (0) is default to 2000 (2 secs)
	    SetCommentaryText(Text, -1)
	    
	    TextNum = TextNum + 1
	end
    
end 

function EFMV_TextTriggerEnd() 

-- Do something to turn the current text thingy off.

--put in as a parameter the delay in miliseconds
-- (0) means no delay, it will hide it straight away
   HideCurrentText(0)
end 