-- Do a search in this script for CUTOFF and you come across all the areas where a scripted camera sequence
-- is necessary.
-- Do a search in this script for ENDPOINT and you will come across the parts of the script where one chapter
-- ends and the next starts.
-- Do a search for PENDING to find piece of the script that are waiting on development.
--
-- Chapter 2:
-- * Wormagamenon and Menelaus must survive.
-- * Player must build at three build points near spartan ship dock.
-- * Attack any incoming enemy ships with Colossus' fire.
-- * Wormagamenon must be advanced to one of the spartan ships.
-- * Menelaus must be advanced to a ship.. (how if he is an npc?)

function InitialiseLevel()
    LoadLevel("landscapes/G/G2.xom",true)
SetObjectives("Miss.Greek2-Objectives", 2)

    EnemyTeamDead = false
    DeadEnemies = 0

    Player0StrongholdGone = false
    timesup = false
    
    
    
	CameraArrayNumber = 0 -- Used for EFMV ONLY
	bQuitable = true -- Used for EFMV ONLY
	GameHasFinished = 0 -- Used for EFMV OUTRO ONLY
	Num = 1 -- Used for the EFMV Text Array ONLY
	EFMVCamerasAreActive = true -- Set to false to disable the intro EFMV camera
	referee = GetRefereeData()
        referee.ShowVictorySequence = false -- Turns the end victory sequence off
	
	EFMVArray = { "intro", "cut1", "cut2", "cut3", "cut4", "cut6", "cut7", "cut8"} -- EFMV - cut7 on is the outro
	
	TextLabelsArray = { "Miss.Greek2-EFMV.Intro1", "Miss.Greek2-EFMV.Intro2", "Miss.Greek2-EFMV.Intro3", "Miss.Greek2-EFMV.Intro4", "Miss.Greek2-EFMV.Intro5", "Miss.Greek2-EFMV.Intro6",
                          "Miss.Greek2-EFMV.Intro7", "Miss.Greek2-EFMV.Intro8", "Miss.Greek2-EFMV.Intro9", "Miss.Greek2-EFMV.Intro10", "Miss.Greek2-EFMV.Intro11", "Miss.Greek2-EFMV.Intro12",
                          "Miss.Greek2-EFMV.Intro13","Miss.Greek2-EFMV.Intro16", "Miss.Greek2-EFMV.Intro17" , "Miss.Greek2-EFMV.Intro18"
			  , "Miss.Greek2-EFMV.Intro19", "Miss.Greek2-EFMV.Intro20", "Miss.Greek2-EFMV.Intro21", "Miss.Greek2-EFMV.Intro22", "Miss.Greek2-EFMV.Intro23", "Miss.Greek2-EFMV.Intro24"}
	    
    doneonce = false
    
    Vic1got = false
    Vic2got = false
    usedallspawns = false
    worm0onship = false
    worm1onship = false
    worm2onship = false
    worm3onship = false
    enemy1dead = false
    enemy2dead = false
    enemy3dead = false
    enemy4dead = false
    enemy5dead = false
    enemy6dead = false
    
    

end

function CreatePlayers()


    -- Team 0, Human Controlled Team - Spartans
    
--    player = CreatePlayer("HUMAN")
--	player.NumberOfWorms = 4
--	player.Name = "Players Team"
--	player.WormStartingHealth = 100
--    player.VoiceBank = "Classic"
--	CreatePlayersTeam(player.PlayerIndex)
--    
--    GetPlayerData(0).MaxJetpackFuel = 999
--    StandardWorm(GetWormData(0),"player1","wfRefC2_Wormgamenon")
--    StandardWorm(GetWormData(1),"player2","wfRefC2_Spartan1")
--    StandardWorm(GetWormData(2),"player3","wfRefC2_Spartan2")
--    StandardWorm(GetWormData(3),"player4","wfRefC2_Menelaus")

        
        
    SetupHumanPlayer(4, 125)
	--player.VoiceBank = "Classic"
    player = GetPlayerData(0)
    player.SpecialWeapon =  "kNoSpecialWeapon"
    GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRefC2_Wormgamenon"
	GetWormData(player.PlayerIndex,1).SpawnPointName ="wfRefC2_Spartan1"
	GetWormData(player.PlayerIndex,2).SpawnPointName ="wfRefC2_Spartan2"
	GetWormData(player.PlayerIndex,3).SpawnPointName ="wfRefC2_Menelaus"    
        
        
        
        
    -- Team 1, Enemy CPU Team - Trojans
    
    player = CreatePlayer("AI")
	player.NumberOfWorms = 4
	player.Name = "Enemy Rearguard"
	player.WormStartingHealth = 30
    player.VoiceBank = "Classic"
	CreatePlayersTeam(player.PlayerIndex)
    player = GetPlayerData(1)
	player.TeamTombstone = 4
    
    

    StandardWorm(GetWormData(4),"Trojan Aston","wfRefC2_Enemy1A")
    StandardWorm(GetWormData(5),"Trojan Charlish","wfRefC2_Enemy1B")
    StandardWorm(GetWormData(6),"Trojan Jax","wfRefC2_Enemy1C")
    StandardWorm(GetWormData(7),"Trojan Varley","wfRefC2_Enemy2A")       
    CopyContainer(GetAIParamsCPU4(), GetAIParamsWorm(4))
    CopyContainer(GetAIParamsWorm(4), GetAIParamsWorm(5))
    CopyContainer(GetAIParamsWorm(4), GetAIParamsWorm(6))
    CopyContainer(GetAIParamsWorm(4), GetAIParamsWorm(7))
    
        
    Worm = GetWormData(4) 
    Worm.HatOverride = "Hat.Roman3"   
    Worm = GetWormData(5) 
    Worm.HatOverride = "Hat.Roman3"
    Worm = GetWormData(6) 
    Worm.HatOverride = "Hat.Roman3"
    Worm = GetWormData(7) 
    Worm.HatOverride = "Hat.Roman3"
--    Worm = GetWormData(8) 
--    Worm.HatOverride = "Hat.Roman3"
--    Worm = GetWormData(9) 
--    Worm.HatOverride = "Hat.Roman3"   
        
        
    player.Flag = 77
        
    --Sets up Team 0 inventory
    EmptyInventory(0)
    inventory = GetPlayerInventory(0)
    inventory.Grenade = kWF_INFINITE_AMOUNT
    inventory.FirePunch = 4
    inventory.Bazooka = kWF_INFINITE_AMOUNT
    inventory.Tower = kWF_INFINITE_AMOUNT
    inventory.ClusterLauncher = 1
    inventory.Jetpack = 3
    inventory.Hospital = 1
    inventory.SpawnWorm = 2 
    inventory.Mortar = kWF_INFINITE_AMOUNT
    inventory.Ballista = kWF_INFINITE_AMOUNT
    inventory.RepairBuilding = 1
    inventory.AirStrike = 0
    inventory.Surrender = 0
    
    --Clears out  worm inventory
    EmptyInventory(1)
    inventory = GetPlayerInventory(1)
    inventory.Bazooka = kWF_INFINITE_AMOUNT
    inventory.Grenade = kWF_INFINITE_AMOUNT
    inventory.Mortar = 1
    inventory.ClusterLauncher = 5
    inventory.FirePunch = kWF_INFINITE_AMOUNT

    scheme = GetCurrentSchemeData()
    scheme.TurnTime = 4500
    scheme.SuddenDeathTime = 180000
    scheme.RetreatTime = 500
    scheme.HotSeatTime = 0
    scheme.HealthInCrates = 50
    scheme.CrateProbability = 0
    scheme.WeaponProbability   = 0
    scheme.UtilityProbability   = 0
    scheme.HealthProbability   = 0
    
	CreateNeutralWorm(8) -- Ghost worms for the EFMV outro
	Worm = GetWormData(8) 
	Worm.HatOverride = "Hat.Roman4"
	
	CreateNeutralWorm(9)
	GetWormData(9).VitalWorm = true
    Worm = GetWormData(9)
    Worm.HatOverride = "Hat.Helen"
    
    
	CreateNeutralWorm(10)
    
    
    
    CreateNeutralWorm(11)
    SetWormHatFromPlayer(11,0)
    
    
    CreateNeutralWorm(12)
    SetWormHatFromPlayer(12,0)
    
    
    CreateNeutralWorm(13)
    SetWormHatFromPlayer(13,0)
    
    
    
    StandardRefereeSettings()
end

function HideWormsNow()

    SetInstantReplaysOn(false)




        EffectId1 = CreateParticleEffect("whirlpoolsplash", "wfRefsplash1") 
        EffectId2 = CreateParticleEffect("whirlpoolsplash", "wfRefsplash2") 


        
        
        
        Spawninhealth()
    
    
--		SpawnOilDrum("wfRefoil1")
--		SpawnOilDrum("wfRefoil2")
--		SpawnOilDrum("wfRefoil3")
--		SpawnOilDrum("wfRefoil4")        
--		SpawnOilDrum("wfRefoil5")
--		SpawnOilDrum("wfRefoil6")
--		SpawnOilDrum("wfRefoil7")    
--		SpawnOilDrum("wfRefoil8")
--		SpawnOilDrum("wfRefoil9")     
--		SpawnOilDrum("wfRefoil10")
--		SpawnOilDrum("wfRefoil11")
--		SpawnOilDrum("wfRefoil12")
--      SpawnOilDrum("wfRefoil13")
--		SpawnOilDrum("wfRefoil14")
--		SpawnOilDrum("wfRefoil15")

        
		--SpawnMine("wfRefmine1")
		SpawnMine("wfRefmine2")
		SpawnMine("wfRefmine3")
		SpawnMine("wfRefmine4")   
		SpawnMine("wfRefmine5")
		--SpawnMine("wfRefmine6")
		--SpawnMine("wfRefmine7")
		SpawnMine("wfRefmine8")
		SpawnMine("wfRefmine9")
		SpawnMine("wfRefmine10")
		SpawnMine("wfRefmine11")   
		--SpawnMine("wfRefmine12")
		--SpawnMine("wfRefmine13")
		SpawnMine("wfRefmine14")   
		SpawnMine("wfRefmine15")
		SpawnMine("wfRefmine16")
		SpawnMine("wfRefmine17")
		SpawnMine("wfRefmine18")
		SpawnMine("wfRefmine19")   
		SpawnMine("wfRefmine20")
		SpawnMine("wfRefmine21")
		SpawnMine("wfRefmine22")   
		SpawnMine("wfRefmine23")

	WormAllowIdleAnims(0,false)
	WormAllowIdleAnims(1,false)
	WormAllowIdleAnims(2,false)
	WormAllowIdleAnims(3,false)
	WormAllowIdleAnims(4,false)
	WormAllowIdleAnims(5,false)
	WormAllowIdleAnims(6,false)
	WormAllowIdleAnims(7,false)
	
	SetEFMVCameraShakeRatio(0.0) -- Turn the camera shake off 

	--Watch ("EnemyTeamDead")
	--Watch ("DeadEnemies")
	StartAllEFMVTimers() 
	EFMVFlyby() -- EFMVStart

end



function CheckSuddenDeath()
    return 0
end



function CheckVictoryConditions()


    if referee.TotalGameTime >= 180000 and timesup == false then
        timesup = true
        SetCommentaryText("Miss.Generic.Timesup")       
        DelayCall("EndMissionFailed", 2)
                
                
    end


    return false
end





function PlayerUsedItem( eItem, playerId, wormId )


--~ StartAllEFMVTimers() 
--~     CameraArrayNumber = 7 -- Indexs the camera array to the end efmv sequence (8)
--~     GameHasFinished = 1
--~     Num = 17 -- Indexs the text to start at 17
--~     EFMVFlyby()	

    inventory = GetPlayerInventory( 0 ) 

-- check if there's less than 1 SpawnWorm left 
    if inventory.SpawnWorm == 0 and EnemyTeamDead == true and usedallspawns == false then 
        CheckObjective(1)
            usedallspawns = true
		CameraArrayNumber = 6 -- Indexs the camera array to the end efmv sequence (8)
		DelayCall("StartAllEFMVTimers",2) 
		GameHasFinished = 1
		Num = 17 -- Indexs the text to start at 17
		DelayCall("EFMVFlyby",2)	
    
    end 

    
    collectgarbage()
end


function CreateInvaders()

end


function BuildingHasBeenBuilt(PlayerId, BuildingType , buildingIndex) -- this function is triggered every time a building is placed
   

    -- get the number of victory locations for player 0 
    NumVictoryLocations = GetPlayerResourcePoints( 0 ) 
    
    
    
    if NumVictoryLocations == 1 and Vic1got == false then
        SetCommentaryText("Miss.Generic.Game10")
        
        Vic1got = true
        Vic2got = false
        
    end
    
    
    
    if NumVictoryLocations == 2 and Vic2got == false then
    
    Vic2got = true
    Vic1got = false
    
        SetCommentaryText("Miss.Generic.Game10")
    end



   
end


function BuildingHasBeenDestroyed( PlayerId, BuildingType )



		Player0Stronghold = GetBuildPointInfo( "buildHere0038" )
		if Player0Stronghold.BuildingType == -1 and Player0StrongholdGone == false then
			Player0StrongholdGone = true
             
            DelayCall("EndMissionFailed", 1) 
             
            
		end


end







function Spawninhealth()

crate = CreateCrate()
crate.Contents = kWF_UTILITY_HEALTH -- what is in the crate.
crate.HealthInCrate = 30		-- amount of health in a health crate, if set to negative uses the current scheme's CrateHealth
crate.CrateId = 1				-- id only used and set by scripts
crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
crate.GroundSnap = true		-- set to true for crate to be placed on the ground below spawn point.
crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
crate.UXB = false				-- whether crate is booby trapped
crate.Destructible = false		-- whether crate can be destroyed.
crate.Pushable = false			-- whether crate can be moved by weapons.
crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
crate.Collectable = true		-- whether crate can be collected
SpawnCrate(1,"wfRefhealth1")




crate = CreateCrate()
crate.Contents = kWF_UTILITY_HEALTH -- what is in the crate.
crate.HealthInCrate = 30		-- amount of health in a health crate, if set to negative uses the current scheme's CrateHealth
crate.CrateId = 2				-- id only used and set by scripts
crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
crate.GroundSnap = true		-- set to true for crate to be placed on the ground below spawn point.
crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
crate.UXB = false				-- whether crate is booby trapped
crate.Destructible = false		-- whether crate can be destroyed.
crate.Pushable = false			-- whether crate can be moved by weapons.
crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
crate.Collectable = true		-- whether crate can be collected
SpawnCrate(2,"wfRefhealth2")




crate = CreateCrate()
crate.Contents = kWF_UTILITY_HEALTH -- what is in the crate.
crate.HealthInCrate = 30		-- amount of health in a health crate, if set to negative uses the current scheme's CrateHealth
crate.CrateId = 3				-- id only used and set by scripts
crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
crate.GroundSnap = true		-- set to true for crate to be placed on the ground below spawn point.
crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
crate.UXB = false				-- whether crate is booby trapped
crate.Destructible = false		-- whether crate can be destroyed.
crate.Pushable = false			-- whether crate can be moved by weapons.
crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
crate.Collectable = true		-- whether crate can be collected
SpawnCrate(3,"wfRefhealth3")





crate = CreateCrate()
crate.Contents = kWF_WEAPON_BATTERING_RAM -- what is in the crate.
crate.NumContents = 1			-- amount in the crate use kWF_INFINITE_AMOUNT for infite
crate.CrateId = 4				-- id only used and set by scripts
crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
crate.GroundSnap = true		-- set to true for crate to be placed on the ground below spawn point.
crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
crate.UXB = false				-- whether crate is booby trapped
crate.Destructible = false		-- whether crate can be destroyed.
crate.Pushable = false			-- whether crate can be moved by weapons.
crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
crate.Collectable = true		-- whether crate can be collected
SpawnCrate(4,"wfRefwep1")



crate = CreateCrate()
crate.Contents = kWF_BUILDING_KEEP -- what is in the crate.
crate.NumContents = 1			-- amount in the crate use kWF_INFINITE_AMOUNT for infite
crate.CrateId = 5				-- id only used and set by scripts
crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
crate.GroundSnap = true		-- set to true for crate to be placed on the ground below spawn point.
crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
crate.UXB = false				-- whether crate is booby trapped
crate.Destructible = false		-- whether crate can be destroyed.
crate.Pushable = false			-- whether crate can be moved by weapons.
crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
crate.Collectable = true		-- whether crate can be collected
SpawnCrate(5,"wfRefwep2")


crate = CreateCrate()
crate.Contents = kWF_WEAPON_NAPALM_STRIKE -- what is in the crate.
crate.NumContents = 1			-- amount in the crate use kWF_INFINITE_AMOUNT for infite
crate.CrateId = 6				-- id only used and set by scripts
crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
crate.GroundSnap = true		-- set to true for crate to be placed on the ground below spawn point.
crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spanw point
crate.UXB = false				-- whether crate is booby trapped
crate.Destructible = false		-- whether crate can be destroyed.
crate.Pushable = false			-- whether crate can be moved by weapons.
crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
crate.Collectable = true		-- whether crate can be collected
SpawnCrate(6,"wfRefwep3")







end




function WormDied( wormIndex )
--~   
--~   
        if CheckAreAllWormsDead( 0 ) == true then 
        EndMissionFailed() 
        end

--~   
--~         worm0 = GetWormData( 0 )
--~         
--~         if worm0.Health <= 0 then
--~         
--~             EndRound(1)
--~             SetCommentaryText("Miss.Generic.Hint39")
--~             
--~         end

--~     

--~         worm1 = GetWormData( 1 )
--~         
--~         if worm1.Health <= 0 then
--~         
--~             EndRound(1)
--~             SetCommentaryText("Miss.Generic.Hint39")
--~             
--~         end
--~     
--~       
--~         worm2 = GetWormData( 2 )
--~         
--~         if worm2.Health <= 0 then
--~         
--~             EndRound(1)
--~             SetCommentaryText("Miss.Generic.Hint39")    
--~         
--~         
--~         end
--~         
--~         
--~         worm3 = GetWormData( 3 )
--~         
--~         if worm3.Health <= 0 then
--~         
--~             EndRound(1)
--~             SetCommentaryText("Miss.Generic.Hint39")
--~         
--~         end
--~     
--~     
--~     -- Here we are checking for the enemy team dying 6 worms in total).
--~     
--~         worm4 = GetWormData( 4 )
--~         
--~         if worm4.Health <= 0 and enemy1dead == false then
--~         
--~             enemy1dead = true
--~             DeadEnemies = DeadEnemies + 1
--~             
--~         
--~         end
--~         
--~         
--~         worm5 = GetWormData( 5 )
--~         
--~         if worm5.Health <= 0 and enemy2dead == false then
--~         
--~             enemy2dead = true
--~             DeadEnemies = DeadEnemies + 1
--~            
--~         
--~         end
--~         
--~         
--~         worm6 = GetWormData( 6 )
--~         
--~         if worm6.Health <= 0 and enemy3dead == false then
--~         
--~             enemy3dead = true
--~             DeadEnemies = DeadEnemies + 1
--~             
--~         end
--~         
--~         
--~         worm7 = GetWormData( 7 )
--~         
--~         if worm3.Health <= 0 and enemy4dead == false then
--~         
--~             enemy4dead = true
--~             DeadEnemies = DeadEnemies + 1
--~            
--~         end
--~     
--~     
--~         worm8 = GetWormData( 8 )
--~         
--~         if worm8.Health <= 0 and enemy5dead == false then
--~         
--~             enemy5dead = true
--~             DeadEnemies = DeadEnemies + 1
--~            
--~         end
--~         
--~         
--~         worm9 = GetWormData( 9 )
--~         
--~         if worm8.Health <= 0 and enemy6dead == false then
--~         
--~             enemy6dead = true
--~             DeadEnemies = DeadEnemies + 1
--~            
--~         end
--~     
--~     
--~     
--~     
--~         if DeadEnemies == 6 then EnemyTeamDead = true
--~         end


     collectgarbage()
 end

function WormDied( WormIndex )
  
  DeadWorm = WormIndex
  
        worm0 = GetWormData( 0 )
        
        if worm0.Health <= 0 then
        
            EndRound(1)
            SetCommentaryText("Miss.Generic.Hint39")
            
        end

    
--Don't check on last 3 human worms health as they will probably only exist at end of game when the human has effectivley won
--And checking thier health will cause the mission to fail as we have to have these 3 worms dead to spawn them
--        worm1 = GetWormData( 1 )
        
 --       if worm1.Health <= 0 then
        
 --           EndRound(1)
 --           SetCommentaryText("Miss.Generic.Hint39")
            
 --       end
    
      
  --      worm2 = GetWormData( 2 )
        
  --      if worm2.Health <= 0 then
        
 --           EndRound(1)
 --           SetCommentaryText("Miss.Generic.Hint39")    
        
        
 --       end
        
        
 --       worm3 = GetWormData( 3 )
        
 --       if worm3.Health <= 0 then
        
 --           EndRound(1)
 --           SetCommentaryText("Miss.Generic.Hint39")
        
 --       end

    -- Here we are checking for the enemy team dying 6 worms in total).
    
    if DeadWorm == 4 and enemy1dead == false then
    
        enemy1dead = true
        DeadEnemies = DeadEnemies + 1
    elseif DeadWorm == 5 and enemy2dead == false then
        enemy2dead = true
        DeadEnemies = DeadEnemies + 1
    elseif DeadWorm == 6 and enemy3dead == false then
        enemy3dead = true
        DeadEnemies = DeadEnemies + 1
    elseif DeadWorm == 7 and enemy4dead == false then 
        enemy4dead = true
        DeadEnemies = DeadEnemies + 1

        
    end
    
    if DeadEnemies == 4 then 
    SetCommentaryText("Miss.Generic.Hint39")
        CheckObjective(0)
        EnemyTeamDead = true
    end

    collectgarbage()
end

--function OnEntrypCubetrigger1( wormTaskId  )




--    worm1 = GetWormData(wormTaskId)


--    if worm1.WormIndex == 0  then
--        worm0onship = true 
--        worm = GetWormData(0)
--        worm.Pushable = false
--        worm.ArtilleryMode = true
--        SetCommentaryText("Miss.Generic.Game9")
--    
--    end


--    worm1 = GetWormData(wormTaskId)

--    if worm1.WormIndex == 1  then
--        worm1onship = true
--        worm = GetWormData(1)
--        worm.Pushable = false
--        worm.ArtilleryMode = true
--        SetCommentaryText("Miss.Generic.Game9")
--    
--    end
--    
--    worm2 = GetWormData(wormTaskId)

--    if worm2.WormIndex == 2  then
--        worm2onship = true
--        worm = GetWormData(2)
--        worm.Pushable = false
--        worm.ArtilleryMode = true
--        SetCommentaryText("Miss.Generic.Game9")
--        
--    end

--    worm3 = GetWormData(wormTaskId)

--    if worm3.WormIndex == 3  then
--        worm3onship = true
--        worm = GetWormData(3)
--        worm.Pushable = false
--        worm.ArtilleryMode = true
--        SetCommentaryText("Miss.Generic.Game9")
--    
--    
--    end




--end




function EndMissionSuccess()



        Unlock("LOCK.Speech.AmericanNews")


        
        if referee.TotalGameTime < 120000 then 
           SetMedal(kGoldMedal)
           Unlock("LOCK.Flag.Greek2")
           Unlock("LOCK.Fortapedia.Helen")
        
        
        elseif referee.TotalGameTime < 150000 then 
            SetMedal(kSilverMedal) 
            Unlock("LOCK.Fortapedia.Helen")
        
        
        
        elseif referee.TotalGameTime > 150000 then 
            SetMedal(kBronzeMedal) 
            Unlock("LOCK.Fortapedia.Helen")
        end 





    SetCommentaryText("Miss.Generic.Success")
    EndRound(0)
end

function EndMissionFailed()
    SetCommentaryText("Miss.Generic.Failed")
    EndRound(1)
end

-- ***********************************************************************************************
-- *                                   Relevant to Chapter 2 Only                                *
-- ***********************************************************************************************

-- -1 - Enemy have arrived on landscape.
--  0 - Enemy will dock NEXT turn.
--  1 - Enemy are within Colossus firing range!
--  2 - Enemy are drawing closer!
--  3 - Enemy are on the horizon!

function Chapter2Brief()
    SetBriefingBoxPosition(0,0) 
    SetBriefingBoxSize(190,120) 
    CreateBriefingBox("Miss.Greek2-Objectives")
end

function Chapter2Success()

	StartAllEFMVTimers() 
	CameraArrayNumber = 6 -- Indexs the camera array to the end efmv sequence (8)
	GameHasFinished = 1
	Num = 15 -- Indexs the text to start at 17
	EFMVFlyby()	
    
end





-- ***********************************************************************************************
-- *                                   Camera things bellow here     				                       *
-- ***********************************************************************************************


function StartAllEFMVTimers() 





	if CameraArrayNumber == 0 then
    
    HideWorm(1)
    HideWorm(2)
    HideWorm(3)
--Set the rest of the teams health to 0 so we can actually spawn them in
	player = GetPlayerData(0)
-- 	Worm = GetWormData(0)
--	Worm.Health = 125
 	Worm = GetWormData(1)
	Worm.Health = 0
 	Worm = GetWormData(2)
	Worm.Health = 0
 	Worm = GetWormData(3)
	Worm.Health = 0

	
		-- fly particle over the fish
		EffectId1 = CreateParticleEffect("fly", "wfReffly1") 
		EffectId2 = CreateParticleEffect("fly", "wfReffly2") 
		EffectId3 = CreateParticleEffect("fly", "wfReffly3") 
		EffectId4 = CreateParticleEffect("fly", "wfReffly4") 
		--EffectId5 = CreateParticleEffect("ceilingdust01", "wfRefdebri") 
    
		SpawnWorm(8, "wfRefParis") -- Currently commented out until the landscape matches
		SpawnWorm(9, "wfRefhelen")
		OrientateWorm(0,80) 
		OrientateWorm(4,240) 
		OrientateWorm(8,80) 
		OrientateWorm(9,80) 
		DelayCall("ParisWormOnBoatFarFarAway", 18)
		DelayCall("HelenWormOnBoatFarFarAway", 18)
		DelayCall("Worm0INtroAnimation", 20)
		DelayCall("Worm0INtroAnimation1", 27)
		DelayCall("Worm0INtroAnimation2", 53)
		DelayCall("Worm0INtroAnimation2b", 58)
		DelayCall("Worm0INtroAnimation2b", 60)
		DelayCall("Worm0INtroAnimation2b", 62)
		DelayCall("Worm0INtroAnimation3", 55)
		DelayCall("Worm0INtroAnimation4", 65)
		DelayCall("EnemyWormCloseUpLooksAngry", 34)
		--DelayCall("Worm0INtroAnimation5", 59)
		-- sets up buildings and victory locations
		RemoveVictoryLocation( "buildHere0040" )
		RemoveVictoryLocation( "buildHere0047" )
		RemoveVictoryLocation( "buildHere0049" )
		AddVictoryLocation( "buildHere005" )
    

    
    
		CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0037", true )
		CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0036", true )

		CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0020", true )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0018", true )
        
        
		CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0023", true )
		CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0022", true )
        
        
        
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0014", true )
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere006", true )
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere007", true )
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere008", true )
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0012", true )
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0027", true )
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0029", true )
		CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0028", true )
		-- Set up all timers (builds and Worm Spawns) been used for the EFMV here.
		
	elseif CameraArrayNumber == 6 then
	
		SweepAndClearArea("wfRef_EFMV_Player")
		SweepAndClearArea("wfRef_EFMV_Crew1")
		SweepAndClearArea("wfRef_EFMV_Crew2")
		SpawnWorm(11, "wfRef_EFMV_Player")
		SpawnWorm(12, "wfRef_EFMV_Crew1")
		SpawnWorm(13, "wfRef_EFMV_Crew2")
		OrientateWorm(11,150) 
		OrientateWorm(12,80) 
		OrientateWorm(13,160) 
		DelayCall("EndWorm1", 7)
		DelayCall("EndWorm2", 9)
		DelayCall("EndWorm3", 2)
		DelayCall("EndWorm4", 11)
		DelayCall("EndWorm5", 13)
		DelayCall("EndWorm6", 13)
		DelayCall("EndWorm7", 14)
		DelayCall("EndWorm8", 17)
		DelayCall("EndWorm9", 21)
		DelayCall("EndWorm10", 4)
	end

end



function EFMVFlyby() -- Starts the EFMV sequence

FlushCommentaryText()

	 if EFMVCamerasAreActive == true then -- As requested, will disable the EFMV camera if set to false

		CameraArrayNumber = CameraArrayNumber + 1
		StartEFMV(EFMVArray[CameraArrayNumber], bQuitable)
		
	elseif EFMVCamerasAreActive == false then
		SetGameUpAndCancelEverything()
	end

end



function OnEndEFMV(szSeqName, bUserQuit)

if bUserQuit == 1 then
	SetGameUpAndCancelEverything()

	elseif bUserQuit == 0 then
	
		if CameraArrayNumber == 6 then  -- Just change the number variable to the amount of flyby cams.
			SetGameUpAndCancelEverything()
		
		elseif CameraArrayNumber == 8 then -- Start of the outro EFMV Sequence
			EndMissionSuccess()
		else
		
			EFMVFlyby()
			

		end
end
end



function SetGameUpAndCancelEverything() -- Called if the user skips the efmv sequence or the sequence has ended. - Things needed for the game go here.
							

	if GameHasFinished == 1 then
		EndMissionSuccess()
	else
	
		CancelDelayCall("ParisWormOnBoatFarFarAway")
		CancelDelayCall("HelenWormOnBoatFarFarAway")
		CancelDelayCall("Worm0INtroAnimation")
		CancelDelayCall("Worm0INtroAnimation1")
		CancelDelayCall("Worm0INtroAnimation2")
		CancelDelayCall("Worm0INtroAnimation2b")
		CancelDelayCall("Worm0INtroAnimation2b")
		CancelDelayCall("Worm0INtroAnimation2b")
		CancelDelayCall("Worm0INtroAnimation3")
		CancelDelayCall("Worm0INtroAnimation4")
		CancelDelayCall("EnemyWormCloseUpLooksAngry")
		HideWorm(8)
		HideWorm(9)
		WormAllowIdleAnims(0,true)
		WormAllowIdleAnims(1,true)
		WormAllowIdleAnims(2,true)
		WormAllowIdleAnims(3,true)
		WormAllowIdleAnims(4,true)
		WormAllowIdleAnims(5,true)
		WormAllowIdleAnims(6,true)
		WormAllowIdleAnims(7,true)


    SetEFMVCameraShakeRatio(1.0)  -- Turn the camera shake on

    

    Chapter2Brief()
    
    --get rid of all the commentary coz a lot has happened
    FlushCommentaryText()

end
	
end


--///////////////////////////////////////////////////////
--  Trigger text code

function EFMV_TextTrigger() 

    	if Num == 22 then
		Fade(true, 15, true) -- fades to black over 3 seconds
	end

    Text = TextLabelsArray[Num]

-- (-1) is infinite, (0) is default to 2000 (2 secs)
    SetCommentaryText(Text, 0)
Num = Num + 1

end 

function EFMV_TextTriggerEnd() 

--put in as a parameter the delay in miliseconds
-- (0) means no delay, it will hide it straight away
   HideCurrentText(0)
   
end




--function TurnEnded()

-- 	   -- StartAllEFMVTimers() 
--             CameraArrayNumber = 6 -- Indexs the camera array to the end efmv sequence (8)
-- 	    DelayCall("StartAllEFMVTimers",2) 
--             GameHasFinished = 1
--             Num = 15 -- Indexs the text to start at 17
--             DelayCall("EFMVFlyby",2)	
--end


 -- Intro animations
function Worm0INtroAnimation()
	WormResetAnim(0) 
	WormQueueAnim(0,"worm_surveying") 
end

function Worm0INtroAnimation1()
	--WormResetAnim(0) 
	WormQueueAnim(0,"angry1") 
end

function Worm0INtroAnimation2()
	OrientateWorm(0,120) 
	--WormResetAnim(0) 
	WormQueueAnim(0,"breathe") 
end

function Worm0INtroAnimation2b()
	--WormResetAnim(0) 
	WormQueueAnim(0,"breathe") 
end

function Worm0INtroAnimation3()
	--WormResetAnim(0) 
	WormQueueAnim(0,"worm_contemplates") 
end

function Worm0INtroAnimation4()
	--WormResetAnim(0) 
	WormQueueAnim(0,"worm_anticipation") 
end

function ParisWormOnBoatFarFarAway()
	WormResetAnim(8) 
	WormQueueAnim(8,"worm_smug") 
end

function HelenWormOnBoatFarFarAway()
	WormResetAnim(9) 
	WormQueueAnim(9,"sad2") 
end

function EnemyWormCloseUpLooksAngry()
	WormResetAnim(4) 
	WormQueueAnim(4,"angry3") 
end

-- Outro animations

function EndWorm1()
	WormResetAnim(12) 
	WormQueueAnim(12,"worm_puzzled") 
	
end

function EndWorm2()
	WormResetAnim(12) 
	WormQueueAnim(12,"worm_speak3") 
end

function EndWorm3()
	WormResetAnim(11) 
	WormQueueAnim(11,"worm_directingheave") 
end

function EndWorm4()
	OrientateWorm(11,250) 
	OrientateWorm(12,250) 
	WormResetAnim(13) 
	WormQueueAnim(13,"worm_shrug") 
end

function EndWorm5()
	WormResetAnim(13) 
	
	WormQueueAnim(13,"worm_speak3") 
end

function EndWorm6()
	WormResetAnim(12) 
	WormQueueAnim(12,"worm_speak3") 
end

function EndWorm7()
	WormResetAnim(12) 
	WormQueueAnim(12,"worm_franticpointing") 
end

function EndWorm8()
	WormResetAnim(11) 
	WormQueueAnim(11,"worm_contemplates")	
end

function EndWorm9()
	WormResetAnim(11) 
	WormQueueAnim(11,"worm_speak3")	
end

function EndWorm10()
	WormResetAnim(13) 
	WormQueueAnim(13,"worm_directingheave") 
end
