--**********************************************************************
--                Quick Game 5
--**********************************************************************

function InitialiseLevel()
	LoadLevel("landscapes/MP/MR2.xom",true) 

	scheme = GetCurrentSchemeData()

	scheme.OverrideInventory = false
	scheme.WormSelectMode = false

	scheme.HealthInCrates = 50
	scheme.CrateProbability = 75

	scheme.TurnTime = 6000
	scheme.SuddenDeathTime = 270000
	scheme.RetreatTime = 500
	scheme.HotSeatTime = 500

	scheme.WeaponProbability   = 25
	scheme.BuildingProbability = 25
	scheme.UtilityProbability   = 25
	scheme.HealthProbability   = 25

	scheme.Bazooka.Crate = 0
	scheme.Bazooka.Delay    = 0

	scheme.Mortar.Crate    = 0
	scheme.Mortar.Delay    = 0

	scheme.FireWeapon.Crate    = 0
	scheme.FireWeapon.Delay    = 0

	scheme.HomingPigeon.Crate    = 0
	scheme.HomingPigeon.Delay    = 0

	scheme.RocketLauncher.Crate    = 0
	scheme.RocketLauncher.Delay    = 0

	scheme.Grenade.Crate    = 0
	scheme.Grenade.Delay    = 0

	scheme.ClusterLauncher.Crate    = 1
	scheme.ClusterLauncher.Delay    = 0

	scheme.FireGrenadeLauncher.Crate    = 0
	scheme.FireGrenadeLauncher.Delay    = 0

	scheme.BananaBombLauncher.Crate     = 1
	scheme.BananaBombLauncher.Delay     = 0

	scheme.Trebuchet.Crate     = 0
	scheme.Trebuchet.Delay     = 0

	scheme.Canary.Crate     = 1
	scheme.Canary.Delay     = 0

	scheme.OldLady.Crate     = 1
	scheme.OldLady.Delay     = 0

	scheme.BatteringRam.Crate     = 1
	scheme.BatteringRam.Delay     = 0

	scheme.SuperHippo.Crate     = 0
	scheme.SuperHippo.Delay     = 0

	scheme.MonkeyHerd.Crate     = 0
	scheme.MonkeyHerd.Delay     = 0

	scheme.AirStrike.Crate     = 0
	scheme.AirStrike.Delay     = 0

	scheme.NapalmStrike.Crate     = 1
	scheme.NapalmStrike.Delay     = 0

	scheme.MineStrike.Crate     = 1
	scheme.MineStrike.Delay     = 0

	scheme.AnimalStrike.Ammo      = 0
	scheme.AnimalStrike.Crate     = 0

	scheme.TrojanDonkey.Crate     = 0
	scheme.TrojanDonkey.Delay     = 0

	scheme.ElectricalStorm.Crate	= 1
	scheme.ElectricalStorm.Delay	= 0

	scheme.Earthquake.Crate     = 0
	scheme.Earthquake.Delay     = 0

	scheme.Flood.Crate     = 0
	scheme.Flood.Delay     = 0

	scheme.NuclearStrike.Crate     = 0
	scheme.NuclearStrike.Delay     = 0

	scheme.Armageddon.Crate     = 0
	scheme.Armageddon.Delay     = 0

	scheme.FirePunch.Crate     = 0
	scheme.FirePunch.Delay     = 0

	scheme.Ballista.Crate     = 1
	scheme.Ballista.Delay     = 0

	scheme.MiniGun.Crate     = 0
	scheme.MiniGun.Delay     = 0

	scheme.GiantCrossbow.Crate     = 1
	scheme.GiantCrossbow.Delay     = 0

	scheme.GiantLaser.Crate     = 0
	scheme.GiantLaser.Delay     = 0

	scheme.Tower.Crate = 1
	scheme.Tower.Delay  = 0

	scheme.Keep.Crate   = 1
	scheme.Keep.Delay  = 0

	scheme.Castle.Crate   = 0
	scheme.Castle.Delay  = 0

	scheme.Citadel.Crate   = 0
	scheme.Citadel.Delay  = 0

	scheme.Hospital.Crate   = 0
	scheme.Hospital.Delay  = 0

	scheme.Refinery.Crate   = 1
	scheme.Refinery.Delay  = 0

	scheme.ScienceLab.Crate   = 1
	scheme.ScienceLab.Delay  = 0

	scheme.Wonder.Crate   = 0
	scheme.Wonder.Delay  = 0

	scheme.Jetpack.Crate     = 1
	scheme.Jetpack.Delay     = 0

	scheme.Freeze.Crate     = 1
	scheme.Freeze.Delay     = 0

	scheme.WormSelect.Crate     = 0
	scheme.WormSelect.Delay     = 0

	scheme.Parachute.Crate     = 1
	scheme.Parachute.Delay     = 0

	scheme.Girder.Crate     = 1
	scheme.Girder.Delay     = 0

	scheme.RepairBuilding.Crate     = 0
	scheme.RepairBuilding.Delay     = 0

	scheme.SpawnWorm.Crate     = 0
	scheme.SpawnWorm.Delay     = 0

	scheme.SkipGo.Crate     = 0
	scheme.SkipGo.Delay     = 0

	scheme.Suicide.Crate     = 0
	scheme.Suicide.Delay     = 0

	scheme.Surrender.Crate     = 0
	scheme.Surrender.Delay     = 0

	scheme.DoubleDamageCrate	= 1
	scheme.DoubleTimeCrate		= 1
	scheme.CrateShowerCrate		= 0
	scheme.CrateSpyCrate		= 1
	
	scheme.NumRandomOilDrums = 16
	scheme.NumRandomMines = 16

	
end

function HideWormsNow()

	--Create Player Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere00218", false )


	--Create Enemy Stonghold--
	CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere00175", false )
	
	--Destroy Unwanted Strongholds and Victory Locations--
	
	RemoveBuilding("buildHere00210")
	RemoveBuilding("buildHere00193")
	
	RemoveVictoryLocation("buildHere00210")
	RemoveVictoryLocation("buildHere00193")

	
	FlushCommentaryText()
	
end

function CreatePlayers()

	--Human Team Setup--

	player = CreatePlayer("HUMAN")
	player.NumberOfWorms = 4
	player.Name = "Team 1"
	player.WormStartingHealth = 100
	player.VoiceBank = "Classic"
	player.Flag = 80
	CreatePlayersTeam(player.PlayerIndex)
	StandardWorm(GetWormData(player.PlayerIndex,0),"Jegg")
	StandardWorm(GetWormData(player.PlayerIndex,1),"Kel")
	StandardWorm(GetWormData(player.PlayerIndex,2),"Chesh")
	StandardWorm(GetWormData(player.PlayerIndex,3),"Defcon")
	
	--Change Hats--
	Worm = GetWormData(0) 
	Worm.HatOverride = "Hat.Roman1"
	Worm = GetWormData(1) 
	Worm.HatOverride = "Hat.Roman1"
	Worm = GetWormData(2) 
	Worm.HatOverride = "Hat.Roman1"
	Worm = GetWormData(3) 
	Worm.HatOverride = "Hat.Roman1"

	
	--AI Team Setup--
	
	
	player = CreatePlayer("AI")
	player.NumberOfWorms = 4
	player.Name = "Team 2"
	player.WormStartingHealth = 100
	player.VoiceBank = "Classic"
	player.Flag = 79
	CreatePlayersTeam(player.PlayerIndex)
	StandardWorm(GetWormData(player.PlayerIndex,0),"Varley")
	StandardWorm(GetWormData(player.PlayerIndex,1),"Dunst")
	StandardWorm(GetWormData(player.PlayerIndex,2),"Jax")
	StandardWorm(GetWormData(player.PlayerIndex,3),"Agent Dennis")
	
	CopyContainer( GetAIParamsCPU2(), GetAIParamsWorm(4) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(5) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(6) )
	CopyContainer( GetAIParamsWorm(4), GetAIParamsWorm(7) )
	
	--Change Hats--
	Worm = GetWormData(4) 
	Worm.HatOverride = "Hat.Roman3"   
	Worm = GetWormData(5) 
	Worm.HatOverride = "Hat.Roman3"
	Worm = GetWormData(6) 
	Worm.HatOverride = "Hat.Roman3"
	Worm = GetWormData(7) 
	Worm.HatOverride = "Hat.Roman3"


	---------------------------
	--Sets up the inventories--
	---------------------------
    
	--Player Inventory
    
	EmptyInventory(0)
	inventory = GetPlayerInventory(0)
	inventory.Bazooka = kWF_INFINITE_AMOUNT    
	inventory.Grenade = kWF_INFINITE_AMOUNT    
	inventory.FirePunch = kWF_INFINITE_AMOUNT 
	inventory.AirStrike = 1 
    
  
	inventory.Mortar = 6   
	inventory.ClusterLauncher = 6
	inventory.Ballista = 4

    
	inventory.FireWeapon = 2
	inventory.FireGrenadeLauncher = 2
	inventory.MiniGun = 1
    
	inventory.BananaBombLauncher = 1
	inventory.HomingPigeon = 1
	inventory.GiantCrossbow = 1
    
	inventory.Trebuchet = 1    
	inventory.GiantLaser = 1
    
	inventory.Tower = 8
	inventory.Keep = 4
	inventory.Castle = 2
	inventory.Citadel = 1
	inventory.Hospital = 1
	inventory.Refinery = 1
	inventory.ScienceLab = 1
	inventory.Wonder = 1
    
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.Freeze = 1
	inventory.RepairBuilding = 1
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
    
 
	--Delays
	inventory.AirStrikeDelay = 2
	inventory.HomingPigeonDelay = 5
 
  

	--AI inventory
	EmptyInventory(1)
	inventory = GetPlayerInventory(1)
	inventory.Bazooka = kWF_INFINITE_AMOUNT    
	inventory.Grenade = kWF_INFINITE_AMOUNT    
	inventory.FirePunch = kWF_INFINITE_AMOUNT 
	inventory.AirStrike = 1 
    
  
	inventory.Mortar = 6   
	inventory.ClusterLauncher = 6
	inventory.Ballista = 4

    
	inventory.FireWeapon = 2
	inventory.FireGrenadeLauncher = 2
	inventory.MiniGun = 1
    
	inventory.BananaBombLauncher = 1
	inventory.HomingPigeon = 1
	inventory.GiantCrossbow = 1
    
	inventory.Trebuchet = 1    
	inventory.GiantLaser = 1
    
	inventory.Tower = 8
	inventory.Keep = 4
	inventory.Castle = 2
	inventory.Citadel = 1
	inventory.Hospital = 1
	inventory.Refinery = 1
	inventory.ScienceLab = 1
	inventory.Wonder = 1
    
	inventory.Jetpack = 2
	inventory.Girder = 2
	inventory.Freeze = 1
	inventory.RepairBuilding = 1
	inventory.SkipGo = kWF_INFINITE_AMOUNT
	inventory.Surrender = 1
	inventory.SpawnWorm = 2
    
 
	--Delays
	inventory.AirStrikeDelay = 2
	inventory.HomingPigeonDelay = 5

	

	referee = GetRefereeData()
	referee.TurnCounter = 0
	referee.WindDirection = 0
	referee.WindDirectionVariance = 180.0
	referee.WindStrengthMinimum = 0.0
	referee.WindStrengthVariance = 10.0
--	referee.SuspendTimer = true;





end

