
-- Tutorial 1
--
-- Gripes:
-- * When a worm dies and respawns, the briefing box pops up before the worm is placed back upon the landscape.


-- * Worm taking fall damage at any point, either needs to be turned off or have dialogue box added.
-- * Worm damaging self with bazooka need dialogue box.

-- * In the firing section add randmom txt for the missed shots.  Txt is in lang file.
-- Bugs:

-- Points 1 - 8 are the stages for the jumping.
-- Point 10 moves the position of Remus and spawns a landmine.

function InitialiseLevel()
    LoadLevel("landscapes/T/T.xom",true)
    SetupDefaultScheme()

    PointInTutorial = 0         -- used to keep of track of the player's progression in the tutorials
    WhichCrate = 0              -- used to set the crate INDEX, not the crate ID
    WormHasJustDied = false     -- switch makes sure certain arguments don't occur when they shouldn't
    MineSectionInProgress = false -- switch used in MineDetonated function, easier to count mines this way
    MineCounter = 0             -- used to keep track of how many mines the player has detonated
    WeaponSelectSwitch = false  -- used in OnCreateWeapon to prevent bazooka being selected more than once
    TargetSectionInProgress = false -- switch used in CrateDestroyed function, easier to keep track of destroyed target this way
    TargetCounter = 0           -- used to keep track of how many targets player has destroyed
    MyRandomNumber = 0          -- used in MakeRandomShotText - set here so I can watch it
    ReminderTimer = false       -- used to keep a timer running to remind the player to select the bazooka
    RemusSequence = false       -- this will be set to true whenever it's a sequence involving Remus moving as an AI worm
    RestartLongTurn = false
    bQuitable = true
    InGameCameras = false		-- are these the intro cameras, yes/no ?
    bUserQuitGodWorm = false
    ReEquipWormBazooka = false  -- this is a switch, look at function wormdied, PointInTutorial == 18
	kForceBazooka = false		-- after re-equipping the bazooka, FORCE IT ON THEM!
    WormHasFallen = false		-- switch checks whether or not the worm has taken fall damage
	RemusHit = false			-- checks to see if player has hit remus with bazooka
	PlayerInDangerArea = false	-- used in the OnEntry and OnExit functions, checks whether or not player has moved into the path of Remus'
								-- shot and if so replaces him elsewhere on the landscape
	MinesHaveSpawnedOnce = false -- switch used to guarantee that the mines only spawn once
			
	BriefingBoxIsOpen = false	-- tells me whether or not we have a briefing box open
	kForceEndSpecialCamera = true -- forces the end of the special camera after the played dies and is spawned again
end

function CreatePlayers()    
    SetupHumanPlayer(1,100)
    player.SpecialWeapon = "kNoSpecialWeapon"
    GetPlayerData(0).MaxJetpackFuel = 999
    GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRef_0W1"

    EmptyInventory(0)
    inventory = GetPlayerInventory(0)
	inventory.SkipGo = 0
	inventory.Surrender = 0
	
    CreateStandardPlayer("AI",1,"Remus","Classic")
    GetPlayerData(1).MaxJetpackFuel = 0
    player.WormStartingHealth = 200
    player.SpecialWeapon = "kNoSpecialWeapon"
    player.Flag = 75
	
	worm = GetWormData(1)
	worm.HatOverride = "Hat.Roman4"
	
    StandardWorm(GetWormData(1),"Remus","wfRef_0W2")

    EmptyInventory(1)

    scheme = GetCurrentSchemeData()
    scheme.TurnTime = 6000
    scheme.SuddenDeathTime = 0
    scheme.RetreatTime = 0
    scheme.HotSeatTime = 0
    scheme.HealthInCrates = 50
    scheme.CrateProbability = 0
    scheme.WeaponProbability = 0
    scheme.UtilityProbability = 0
    scheme.HealthProbability = 0

    StandardRefereeSettings()

    referee = GetRefereeData()
    referee.WindStrengthMinimum = 0.0
    referee.WindStrengthVariance = 0.0
	referee.ShowVictorySequence = false -- Turns the end of game worm celebrations off
	
	SetVictorySequenceAllowed(false)
	
    SetupNeverEndingTurn(0,false)

    -- This is where we would like Remus to wander when he is first asked to hop onto the mine
    CopyContainer( GetAIParamsCPU5(), GetAIParamsWorm(1) )
    GetAIParamsWorm(1).ImaginaryCrateReferencePoint = "wfRef_T1M1"
    GetAIParamsWorm(1).ImaginaryCrateCollectWeight = 10000
    GetAIParamsWorm(1).AllowMoveThroughMoveableBlockages = true
end

function HideWormsNow()
    TurnOffHudElement("Time", false)
    TurnOffHudElement("TeamStatus", false)
    TurnOffHudElement("ResourcePoints", false)
    TurnOffHudElement("GetReadyMsg", false)

    SetInstantReplaysOn(false)    -- no replays
    
    RemoveVictoryLocation( "buildHere000" )
    RemoveVictoryLocation( "buildHere0010" )
    RemoveVictoryLocation( "buildHere0036" )
    RemoveVictoryLocation( "buildHere0038" )

    OrientateWorm(1,180)
	
	WormAllowIdleAnims(0,false)
	WormAllowIdleAnims(1,false)
	
	DelayCall("DelayFirstLineOfText", 2.0)
    StartEFMV("IntroT1A",bQuitable)
	--BeginTutorial()
end

function DelayFirstLineOfText()
    SetCommentaryText("Tut1.Opening.Comment1",3000)
end

function OnEndEFMV(szSeqName, bUserQuit)
    if InGameCameras == false then                                      -- from here down is the intro and outro
        if bUserQuit == 0 then
            if szSeqName == "IntroT1A" then
				OrientateWorm(0, -115)
				OrientateWorm(1, -140)
                StartEFMV("IntroT1B",bQuitable)
				DelayCall("IntroT1B_Anim_W1", 1.0)
				DelayCall("IntroT1B_Anim_W0", 2.3)
            elseif szSeqName == "IntroT1B" then
				WormResetAnim(0)
				WormResetAnim(1)
				OrientateWorm(1, -15)
				DelayCall("IntroT1B_Orientate_W0", 0.5)
                StartEFMV("IntroT1C",bQuitable)
                SetCommentaryText("Tut1.Opening.Comment3",4000)
				DelayCall("IntroT1C_Anim_W0", 0.7)
				DelayCall("IntroT1C_Anim_W1", 1.0)
				DelayCall("IntroT1C_Anim_W1_A2", 2.0)
            elseif szSeqName == "IntroT1C" then
				OrientateWorm(0, -140)
				OrientateWorm(1, -175)
                StartGodAnimSequence()
                DelayCall("RemoveGodWorm", 5.0)
                SetCommentaryText("Tut1.Opening.Comment4",4000)
            elseif szSeqName == "IntroT1D" then
                BeginTutorial()
            elseif szSeqName == "OutroT1" then
                EndMissionSuccess()
            end
        elseif bUserQuit == 1 then
            if szSeqName == "IntroT1A" then
                CancelDelayCall("DelayFirstLineOfText")
				CancelDelayCall("IntroT1B_Anim_W1")
				CancelDelayCall("IntroT1B_Anim_W0")
                BeginTutorial()
            elseif szSeqName == "IntroT1B" then
				CancelDelayCall("IntroT1B_Orientate_W0")
				CancelDelayCall("IntroT1C_Anim_W0")
				CancelDelayCall("IntroT1C_Anim_W1")
				CancelDelayCall("IntroT1C_Anim_W1_A2")
				BeginTutorial()
            elseif szSeqName == "IntroT1C" then
				CancelDelayCall("RemoveGodWorm")
				BeginTutorial()
            elseif szSeqName == "IntroT1D" then
				CancelDelayCall("IntroT1D_Anim_W0")
				CancelDelayCall("IntroT1D_Anim_W1")
				CancelDelayCall("NextLineOfText1")
				CancelDelayCall("NextLineOfText2")
				CancelDelayCall("OrientWormToFaceOtherWorm")
				CancelDelayCall("IntroT1D_Anim2_W0")
				CancelDelayCall("IntroT1D_Anim2_W1")
				CancelDelayCall("ReOrientWorm")
				CancelDelayCall("OrientWorm1ToFollowCamera")
				CancelDelayCall("OrientWorm2ToFollowCamera")
				CancelDelayCall("IntroT1D_Anim3_W0")
                BeginTutorial()
            elseif szSeqName == "GodWorm" then
                bUserQuitGodWorm = true
                BeginTutorial()
            elseif szSeqName == "OutroT1" then
                EndMissionSuccess()
            end
        end
    elseif InGameCameras == true then                                   -- from here down is the in game cameras
        if bUserQuit == 0 then
            if szSeqName == "ClipT1D" then
                After_ClipT1D()
            elseif szSeqName == "ClipT1A" then
                After_ClipT1A()
            elseif szSeqName == "ClipT1B" then
                After_ClipT1B()
            end
        elseif bUserQuit == 1 then
            if szSeqName == "ClipT1D" then
                After_ClipT1D()
            elseif szSeqName == "ClipT1A" then
                After_ClipT1A()
            elseif szSeqName == "ClipT1B" then
                After_ClipT1B() 
            end
        end
    end
end

--~ Tut1.Opening.Comment1	Washed up on an island
--~ Tut1.Opening.Comment2	our unlikely heroes find themselves alone.
--~ Tut1.Opening.Comment3	Luckily, someones watching over them
--~ Tut1.Opening.Comment4	its the Supreme Being!
--~ Tut1.Opening.Comment5	Whats that hes saying?
--~ Tut1.Opening.Comment6	Hes going to teach you how to play the game?
--~ Tut1.Opening.Comment7	With a series of tests?
--~ Tut1.Opening.Comment8	This looks like it could be fun!

function IntroT1B_Orientate_W0()
	OrientateWorm(0, -12)--khere
end

function IntroT1B_Anim_W1()
	SetCommentaryText("Tut1.Opening.Comment2",4000)
	WormResetAnim(1)
	WormQueueAnim(1, "worm_surveying")
end

function IntroT1B_Anim_W0()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_impatient")
end

function IntroT1C_Anim_W1()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_shakehead")
end

function IntroT1C_Anim_W1_A2()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_shrug")
end

function IntroT1C_Anim_W0()
	WormResetAnim(1)
	WormQueueAnim(0, "worm_understandsfalse")
end

function StartGod()
    StartGodAnimSequence()
end

function RemoveGodWorm()
    -- only remove if the god worm wasn't skipped
    if bUserQuitGodWorm == false then
		EndGodAnimSequence()
        StartEFMV("IntroT1D",bQuitable)
        SetCommentaryText("Tut1.Opening.Comment5",3500)
		DelayCall("IntroT1D_Anim_W0", 1.2)
		DelayCall("IntroT1D_Anim_W1", 2.7)
		DelayCall("NextLineOfText1", 6.0)
		DelayCall("NextLineOfText2", 10.5)
		DelayCall("OrientWormToFaceOtherWorm", 6.2)
		DelayCall("IntroT1D_Anim2_W0", 7.0)
		DelayCall("IntroT1D_Anim2_W1", 8.0)
		DelayCall("ReOrientWorm", 10.0)
		DelayCall("OrientWorm1ToFollowCamera",13.0)
		DelayCall("OrientWorm2ToFollowCamera",14.0)
		DelayCall("IntroT1D_Anim3_W0", 15.0)
    end
end

function IntroT1D_Anim_W0()
	WormResetAnim(0)
	WormQueueAnim(0, "Idle_contemplates")
end

function IntroT1D_Anim_W1()
	WormResetAnim(1)
	WormQueueAnim(1, "Idle_shakehead")
end

function OrientWormToFaceOtherWorm()
	OrientateWorm(0, 10)
end

function IntroT1D_Anim2_W0()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_shrug")
end

function IntroT1D_Anim2_W1()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_puzzled")
end

function ReOrientWorm()
	WormResetAnim(0)
	WormResetAnim(1)
	WormQueueAnim(1, "worm_tired")
	WormQueueAnim(0, "worm_prompt")
	OrientateWorm(0, -140)
end

function IntroT1D_Anim3_W0()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_wave1")
end

function OrientWorm1ToFollowCamera()
	OrientateWorm(0, -105)
end

function OrientWorm2ToFollowCamera()
	OrientateWorm(1, -130)
end

function NextLineOfText1()
	SetCommentaryText("Tut1.Opening.Comment6",3500)
end

function NextLineOfText2()
	SetCommentaryText("Tut1.Opening.Comment7",2500)
	SetCommentaryText("Tut1.Opening.Comment8",3500)
end

function After_ClipT1A()
    PointInTutorial = 4
    MakeDefaultBriefingBox("Tut1.Jumping.1New")
end

function After_ClipT1B()
    PointInTutorial = 7
    MakeDefaultBriefingBox("Tut1.Backflip.1New")
end

function After_ClipT1D()
	HideWorm(1)
    PointInTutorial = 12
    MakeDefaultBriefingBox("Tut1.Mines.3")
    MineSectionInProgress = true
end

function BeginTutorial()
    FlushCommentaryText()
	WormResetAnim(0)
	WormResetAnim(1)
	WormAllowIdleAnims(0,true)
	WormAllowIdleAnims(1,true)
	OrientateWorm(0,0)
	OrientateWorm(1,180)
	HideWorm(1)
    MakeDefaultBriefingBox("Tut1.Movement.1New")
    MakeHealthCrate(1,"wfRefT1MHC1")
    InGameCameras = true
end

function CrateCollected(CrateIndex,WormIndex)
    crate = GetCrateData(CrateIndex)
    
    if crate.CrateId == 1 then
        PointInTutorial = 1
        MakeDefaultBriefingBox("Tut1.Movement.2")
		MakeHealthCrate(2,"wfRefT1MHC2")
    elseif crate.CrateId == 2 then
        MakeHealthCrate(3,"wfRefT1MHC3")
    elseif crate.CrateId == 3 then
        MakeHealthCrate(4,"wfRefT1MHC4")
		MakeDefaultBriefingBox("Tut1.Movement.4NewConsole")
        ShowOnlyScriptCommentary(true)
		PointInTutorial = 3
    elseif crate.CrateId == 4 then
	    PointInTutorial = 4
		MakeDefaultBriefingBox("Tut1.Jumping.1New")
        MakeHealthCrate(92,"wfRefT1JHC9B")
		SetSpecialCamera("wfRefT1JHC9B","wfRef_T1_Steps")
    elseif crate.CrateId == 91 then
        MakeHealthCrate(92,"wfRefT1JHC9B")
    elseif crate.CrateId == 92 then
        MakeHealthCrate(93,"wfRefT1JHC9C")
    elseif crate.CrateId == 93 then
        MakeHealthCrate(10,"wfRefT1JHC10")
    elseif crate.CrateId == 10 then
        MakeHealthCrate(11,"wfRefT1JHC11")
    elseif crate.CrateId == 11 then
        PointInTutorial = 6
        MakeHealthCrate(111,"wfRefT1JHC11A")
    elseif crate.CrateId == 111 then
        MakeHealthCrate(112,"wfRefT1JHC11B")
    elseif crate.CrateId == 112 then
        MakeHealthCrate(12,"wfRefT1JHC12")
    elseif crate.CrateId == 12 then
        MakeHealthCrate(13,"wfRefT1JHC13")
    elseif crate.CrateId == 13 then
        MakeHealthCrate(131,"wfRefT1JHC13A")
    elseif crate.CrateId == 131 then
        MakeHealthCrate(14,"wfRefT1BHC14")
        Camera_ClipT1B()
    elseif crate.CrateId == 14 then
        PointInTutorial = 8
        -- CAMERA: Point camera at the next crate to drop.
        MakeHealthCrate(15,"wfRefT1BHC15")
        MakeDefaultBriefingBox("Tut1.Backflip.2New")
    elseif crate.CrateId == 15 then
        MakeHealthCrate(151,"wfRefT1BHC15A")
        DelayCall("Camera_ClipT1C", 0.2)
    elseif crate.CrateId == 151 then 
        PointInTutorial = 9
        MakeHealthCrate(16,"wfRefT1BHC16")
        MakeDefaultBriefingBox("Tut1.Backflip.3New")
    elseif crate.CrateId == 16 then
        MakeHealthCrate(161,"wfRefT1BHC16A")
    elseif crate.CrateId == 161 then
        PointInTutorial = 10
        --MoveWorm(1,"wfRef_9W2") -- we used to move the worm, but now we hide him beforehand
		SpawnWorm(1,"wfRef_9W2")
        MakeMine(1,"wfRef_T1M1",1.0,true)
        OrientateWorm(1,45)
		SetSpecialCamera("wfRef_T1_Remus1_LookAt","wfRef_T1_Remus1_Cam")
        -- CAMERA: Camera points at Remus, pulls out slowly and shows land mine lined up in front of him.
        MakeDefaultBriefingBox("Tut1.Mines.1")
    elseif crate.CrateId == 17 then
        PointInTutorial = 17
        MakeDefaultBriefingBox("Tut1.Weapons.2")
    end
end

function CrateDestroyed(CrateIndex,WormIndex)
    crate = GetCrateData(CrateIndex)

    if TargetSectionInProgress == false then
        if crate.CrateId == 18 then
            -- REMUS_END_2
            -- take the bazooka off Remus
            EmptyInventory(1)
            
            DelayCall("EndRemusSequence", 3)--used to be 4 seconds
            DelayCall("NextBriefingBoxAfterRemusDestroysTarget", 5)
        end
    elseif TargetSectionInProgress == true then
        TargetCounter = TargetCounter + 1
        
        if TargetCounter < 4 then
            RandomShotText()
        elseif TargetCounter == 4 then
            SetCommentaryText("Tut1.Firing.Comment6")
        elseif TargetCounter == 5 then
			DelayCall("PauseAfterLastTargetDestroyed", 2.5)
        end
    end
end

function PauseAfterLastTargetDestroyed()
	PointInTutorial = 24
	
	-- SPP : Remove the bazooka from inventory and from the worm
	-- to stop it trying to get it out during the final breifing boxes
	inventory = GetPlayerInventory(0)
	inventory.Bazooka = 0
	RemoveWeapon(0)
	
	MakeDefaultBriefingBox("Tut1.Wind.1")
end

function RandomShotText()
    MyRandomNumber = RandomRange(1.0,true)
    
    if MyRandomNumber == 0 then
        SetCommentaryText("Tut1.Firing.Comment1")
    elseif MyRandomNumber == 1 then
        SetCommentaryText("Tut1.Firing.Comment2")
    end
end

function MineDetonated( mineIndex )
    MinesLeft = GetNumMines(false)
    
    if MineSectionInProgress == false then
        if ( mineIndex == 1 ) then
            -- REMUS_END_1
            -- clear out Remus' imaginery waypoint
            GetAIParamsWorm(1).ImaginaryCrateReferencePoint = ""
            GetAIParamsWorm(1).ImaginaryCrateCollectWeight = 10000
            DelayCall("EndRemusSequence", 2)
            DelayCall("NextBriefingBoxAfterRemusDetonatesMine", 7)
        end
    elseif MineSectionInProgress == true then
        MineCounter = MineCounter + 1
        
        if MineCounter == 3 then
            PointInTutorial = 13
            MakeDefaultBriefingBox("Tut1.Mines.4")
        elseif MineCounter == 5 then
            PointInTutorial = 15
            SetCommentaryText("Tut1.Mines.Comment1")
        elseif MineCounter == 6 then
            DelayCall("NextBriefingBoxAfterUserDetonatesMine", 0.5)
        end
    end
end

function NextBriefingBoxAfterUserDetonatesMine()--khere11
    PointInTutorial = 16
    -- CAMERA: Camera points to show weapons crate drop in at top of landscape
    SetSpecialCamera("wfRef_T1WC1","wfRef_T1_BazCrate")
	
	if IsWormWithinPhantom( 0, "pCubetrigger2" ) == true then
		MakeWeaponCrate(17,"wfRef_T1WC1A",kWF_WEAPON_BAZOOKA,kWF_INFINITE_AMOUNT)
	else
		MakeWeaponCrate(17,"wfRef_T1WC1",kWF_WEAPON_BAZOOKA,kWF_INFINITE_AMOUNT)
	end 
	
	MineSectionInProgress = false
    MakeDefaultBriefingBox("Tut1.Weapons.1")
end

function NextBriefingBoxAfterRemusDetonatesMine()
    PointInTutorial = 11
    ShowOnlyScriptCommentary(false)
    MakeDefaultBriefingBox("Tut1.Mines.2")
	FlushCommentaryText()
end

function NextBriefingBoxAfterRemusDestroysTarget()
	MoveWorm(0,"wfRef_11W1")
	OrientateWorm(0,-90)
	
    CreateAllTargets()
	ReEquipWormBazooka = true
	kForceBazooka = true
    PointInTutorial = 22
    MakeDefaultBriefingBox("Tut1.Firing.3")--kbug2
	
	ShowOnlyScriptCommentary(false)
	--RemoveWeapon(0)
    SetSpecialCamera("wfRef_T1_TargetsLookAt","wfRef_T1_Targets")

	RemoveWeapon(1)
	HideWorm(1)
end

function Camera_ClipT1A()
    StartEFMV("ClipT1A",bQuitable)
end

function Camera_ClipT1B()
    OrientateWorm(0,140)
    StartEFMV("ClipT1B",bQuitable)
end

function Camera_ClipT1C()
    OrientateWorm(0,115)
    StartEFMV("ClipT1C",bQuitable)
end

function Camera_ClipT1D()
	FlushCommentaryText()
    StartEFMV("ClipT1D",bQuitable)
end

function OnExitBriefingBox()
	BriefingBoxIsOpen = false

    if ReEquipWormBazooka == true then
		DelayCall("ReEquipBazooka", 0.2)
    end

	if kForceEndSpecialCamera == true then
		EndSpecialCamera()
		kForceEndSpecialCamera = false
	end
	
    if WormHasJustDied == false then
        if PointInTutorial == 1 then
            -- CAMERA: At this point the camera points to Remus, and shows how much health he has.
            MakeDefaultBriefingBox("Tut1.Movement.3")
            PointInTutorial = 2
        elseif PointInTutorial == 4 then
			EndSpecialCamera()
            PointInTutorial = 5
        elseif PointInTutorial == 7 then
            --khere
        elseif PointInTutorial == 10 then
			EndSpecialCamera()
            -- REMUS_START_1
            StartRemusSequence()
        elseif PointInTutorial == 11 then
			FlushCommentaryText()
            DelayCall("Camera_ClipT1D", 0.2)
			DelayCall("CreateAllMines", 0.2)
        elseif PointInTutorial == 13 then
            PointInTutorial = 14
            MakeDefaultBriefingBox("Tut1.Mines.5New")
        elseif PointInTutorial == 16 then
            EndSpecialCamera()
        elseif PointInTutorial == 17 then
            PointInTutorial = 18
            MakeDefaultBriefingBox("Tut1.Weapons.3")
        elseif PointInTutorial == 18 then
            ReminderTimer = true
            DelayCall("RemindUserToSelectBazooka",8)
        elseif PointInTutorial == 19 then
			SetSpecialCamera("wfRef_T1_Remus2_LookAt","wfRef_T1_Remus2_Cam")
            PointInTutorial = 20
            TurnOnArtilleryMode(1)
            MakeDefaultBriefingBox("Tut1.Firing.1")
			
			WormAllowIdleAnims(1,false)--khere21
			WormResetAnim(1)
			WormQueueAnim(1,"worm_wake")
        elseif PointInTutorial == 20 then
			WormAllowIdleAnims(1,true)
			WormResetAnim(1)
			EndSpecialCamera()
		
			if PlayerInDangerArea == true then
				MoveWorm(0,"wfRef_11W1")
			end
		
            PointInTutorial = 21
			SetSpecialCamera("wfRef_T1Targ1","wfRef_T1_OneTarget")
            MakeDefaultBriefingBox("Tut1.Firing.2")
            MakeTarget(18,"wfRef_T1Targ1")
			
			ShowOnlyScriptCommentary(true)
        elseif PointInTutorial == 21 then
			-- Take human player's weapon away to prevent LOD crash - kbug1
			RemoveWeapon(0)
			EmptyInventory(0)
			inventory = GetPlayerInventory(0)
			inventory.SkipGo = 0
			inventory.Surrender = 0
			
            -- REMUS_START_2
            -- set Remus a target ref point and arm him with a bazooka
			EndSpecialCamera()
            EmptyInventory(1)
            inventory = GetPlayerInventory(1)
            inventory.Bazooka = kWF_INFINITE_AMOUNT
            GetAIParamsWorm(1).TargetReferencePoint  = "wfRef_T1Targ1"            
            StartRemusSequence()
        elseif PointInTutorial == 22 then
            PointInTutorial = 23
            TargetSectionInProgress = true
            EndSpecialCamera()
            -- CAMERA: Camera shows targets appearing across landscape
        elseif PointInTutorial == 24 then
            PointInTutorial = 25
            MakeDefaultBriefingBox("Tut1.Wind.2")
        elseif PointInTutorial == 25 then
            PointInTutorial = 26
            MakeDefaultBriefingBox("Tut1.Ending.1")
        elseif PointInTutorial == 26 then
			SetSpecialCamera("wfRef_T1_Island_LookAt","wfRef_T1_Island_Cam")
            PointInTutorial = 27
            MakeDefaultBriefingBox("Tut1.Ending.2")
        elseif PointInTutorial == 27 then
			EndSpecialCamera()
            -- CAMERA: Outro sequence ending, camera shots, etc.
            InGameCameras = false
            DelayCall("Cam_OutroT1", 0.2)
        end
    end
    
    WormHasJustDied = false
end

function Cam_OutroT1()
    StartEFMV("OutroT1",bQuitable)
end

function StartRemusSequence()
    RemusSequence = true
    ShowBlackBorders()
    EndNeverEndingTurn( 599 )
    EndTurn()
	FlushCommentaryText()
end

function EndRemusSequence()
    RemusSequence = false
    RestartLongTurn = true
    RemoveBlackBorders()
	FlushCommentaryText()
    --EndTurn()
    --SetupNeverEndingTurn(0,false)
end

function CreateAllMines()
	if MinesHaveSpawnedOnce == false then
		MinesHaveSpawnedOnce = true
		MakeMine(2,"wfRef_T1M2",5.0,false)
		MakeMine(2,"wfRef_T1M3",5.0,false)
		MakeMine(2,"wfRef_T1M4",5.0,false)
		MakeMine(2,"wfRef_T1M5",5.0,false)
		MakeMine(2,"wfRef_T1M6",5.0,false)
		MakeMine(2,"wfRef_T1M7",5.0,false)
	end
end

function CreateAllTargets()
    MakeTarget(19,"wfRef_T1Targ2")
    MakeTarget(20,"wfRef_T1Targ3")
    MakeTarget(21,"wfRef_T1Targ4")
    MakeTarget(22,"wfRef_T1Targ5")
    MakeTarget(23,"wfRef_T1Targ6")
end

function WormDiedInNeverEndingTurn()
end

function WormDied( WormIndex )
	if WormIndex == 0 then
		WormHasJustDied = true
	
		if PointInTutorial == 0 then
			SpawnWorm(0,"wfRef_0W1")
			OrientateWorm(0,0)
			MakeDefaultBriefingBox("Tut1.Movement.NegativeANew")
		elseif PointInTutorial == 1 or PointInTutorial == 2 then
			SpawnWorm(0,"wfRef_0W1")
			MakeDefaultBriefingBox("Tut1.Movement.NegativeBNew")
		elseif PointInTutorial == 3 then
			SpawnWorm(0,"wfRefT1MHC3")
			OrientateWorm(0,118)
			MakeDefaultBriefingBox("Tut1.Movement.NegativeBNew")
		elseif PointInTutorial == 4 or PointInTutorial == 5 then
			SpawnWorm(0,"wfRefT1MHC4")
			OrientateWorm(0,180)
			MakeDefaultBriefingBox("Tut1.Jumping.NegativeANew")
		elseif PointInTutorial == 6 then
			SpawnWorm(0,"wfRef_5W1")
			OrientateWorm(0,90)
			MakeDefaultBriefingBox("Tut1.Jumping.NegativeANew")
		elseif PointInTutorial == 7 then
			SpawnWorm(0,"wfRefT1JHC13A")
			OrientateWorm(0,140)
			MakeDefaultBriefingBox("Tut1.Backflip.NegativeA")
		elseif PointInTutorial == 8 or PointInTutorial == 9 then
			SpawnWorm(0,"wfRef_8W1")
			OrientateWorm(0,-90)
			MakeDefaultBriefingBox("Tut1.Backflip.NegativeBNew")
		elseif PointInTutorial == 12 or PointInTutorial == 14 or PointInTutorial == 15 then
			SpawnWorm(0,"wfRef_9W1")
			MakeDefaultBriefingBox("Tut1.Mines.NegativeA")
		elseif PointInTutorial == 16 then
			SpawnWorm(0,"wfRef_10W1")
			OrientateWorm(0,-145)
			MakeDefaultBriefingBox("Tut1.Weapons.NegativeA")
			if MineCounter == 6 then
				kForceEndSpecialCamera = true
			end
		elseif PointInTutorial == 18 then
			EmptyInventory(0)
			inventory = GetPlayerInventory(0)
			inventory.SkipGo = 0
			inventory.Surrender = 0
			SpawnWorm(0,"wfRef_11W1")
			OrientateWorm(0, -90)
			ReEquipWormBazooka = true
			MakeDefaultBriefingBox("Tut1.Selecting.NegativeANew")
		elseif PointInTutorial == 23 then
			SpawnWorm(0,"wfRef_11W1")
			OrientateWorm(0, -90)
			
			EmptyInventory(0)
			inventory = GetPlayerInventory(0)
			inventory.SkipGo = 0
			inventory.Surrender = 0
			inventory.Bazooka = 0

			ReEquipWormBazooka = true
			kForceBazooka = true
			
			MakeDefaultBriefingBox("Tut1.Firing.NegativeANew")
		end
	end
end

function WormDamaged( wormIndex, AssailantTaskId, damage )
	if wormIndex == 0 and WormHasFallen == false and MineSectionInProgress == false and PointInTutorial < 19 then
		if BriefingBoxIsOpen == false then
			WormHasFallen = true
			WormHasJustDied = true
			
			if PointInTutorial > 17 then
				EmptyInventory(0)
				inventory = GetPlayerInventory(0)
				inventory.SkipGo = 0
				inventory.Surrender = 0
				inventory.Bazooka = 0
				
				ReEquipWormBazooka = true
			end
			
			-- display dialogue box warning the user about falling
			MakeDefaultBriefingBox("TutAll.Fall")
		end
	end

	return damage
end

function ReEquipBazooka()
    inventory = GetPlayerInventory(0)
    inventory.Bazooka = kWF_INFINITE_AMOUNT
	ReEquipWormBazooka = false
	if kForceBazooka == true then
		CreateWeapon(0, kWF_WEAPON_BAZOOKA)
		kForceBazooka = false
	end
end

function RemindUserToSelectBazooka()
    if ReminderTimer == true then
        SetCommentaryText("Tut1.Selecting.Comment1")
        SetCommentaryText("Tut1.Selecting.Comment2")
        DelayCall("RemindUserToSelectBazooka", 12)
    end
end

function OnCreateWeapon(WeaponType)
    if WeaponType == kWF_WEAPON_BAZOOKA and WeaponSelectSwitch == false then 
		SpawnWorm(1, "wfRef_10W2")
		OrientateWorm(1, 180)

        WeaponSelectSwitch = true
        ReminderTimer = false
        PointInTutorial = 19
        MakeDefaultBriefingBox("Tut1.Selecting.1")
    end
end

function OnEntrypCubetrigger1( WormIndex  )
    if WormIndex == 0 then
		PlayerInDangerArea = true
    end
end

function OnExitpCubetrigger1( WormIndex  )
    if WormIndex == 0 then
		PlayerInDangerArea = false
    end
end

-- ********************************************************************************************************
-- *                                            ENGINE ROOM!!                                             *
-- ********************************************************************************************************

function CheckSuddenDeath()
end

function CheckVictoryConditions()
    return false
end

function SetNextPlayerToGo( playerIndex )
	if RemusSequence == true then
			-- remove? this is set to false in EndRemusSequence
			--RemusSequence = false 
			return 1
	else
		if RestartLongTurn == true then
			RestartLongTurn = false
			SetupNeverEndingTurn(0,false)
		end

		return 0
	end

	return playerIndex
end

function EndMissionSuccess()
    Unlock("LOCK.Tutorial.02")
    
    EndRound(0)
end

function EndMissionFail()
    EndRound(1)
end

function MakeHealthCrate(CrateId,CrateString)
    crate = CreateCrate(kWF_UTILITY_HEALTH)
    crate.Contents = kWF_UTILITY_HEALTH -- what is in the crate.
    crate.HealthInCrate = 1		-- amount of health in a health crate, if set to negative uses the current scheme's CrateHealth
    crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
    crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
    crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
    crate.GroundSnap = true		-- set to true for crate to be placed on the ground below spawn point.
    crate.FixedPosition = false		-- set to true, crate will not move i.e. stays at spawn point
    crate.UXB = false			-- whether crate is booby trapped
    crate.Destructible = false		-- whether crate can be destroyed.
    crate.Pushable = false		-- whether crate can be moved by weapons.
    crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
    crate.Collectable = true		-- whether crate can be collected
    crate.CrateId = CrateId
    --crate.IsCritical = true           -- come back to this, u just want the arrow and not the effect
    SpawnCrate(WhichCrate,CrateString)
    WhichCrate = WhichCrate + 1
end

function MakeWeaponCrate(CrateId,CrateString,CrateContents,CrateAmmo)
    crate = CreateCrate(CrateContents)
    crate.Contents = CrateContents
    crate.NumContents = CrateAmmo
    crate.TeamDestructible = -1
    crate.WormCollectable = -1
    crate.TeamCollectable = 0
    crate.GroundSnap = true
    crate.FixedPosition = false
    crate.UXB = false
    crate.Destructible = false
    crate.Pushable = false
    crate.CollectableByPayload = false
    crate.Collectable = true
    crate.CrateId = CrateId
    crate.IsCritical = false
    SpawnCrate(WhichCrate,CrateString)
    WhichCrate = WhichCrate + 1
end

function MakeTarget(TargetId,TargetString)
    crate = CreateCrate(kWF_TRIGGER_CRATE )
    crate.Contents = kWF_TRIGGER_CRATE 
    crate.NumContents = 0
    crate.CrateId = TargetId
    crate.TeamDestructible = -1
    crate.WormCollectable = 10
    crate.TeamCollectable = 10
    crate.GroundSnap = true
    crate.FixedPosition = true
    crate.UXB = false
    crate.Destructible = true
    crate.Pushable = false
    crate.CollectableByPayload = false
    crate.Collectable = false
    crate.IsCritical = false
	crate.Model = "Crate.Target"
	crate.SpinBaby = true
	crate.ScaleFactor = 1.0
    SpawnCrate(WhichCrate,TargetString)
end

function MakeDefaultBriefingBox(String)
	if BriefingBoxIsOpen == false then
		SetBriefingBoxPosition(0,0) -- two variables set size and position of briefing box
		SetBriefingBoxSize(190,120)
		CreateBriefingBox(String)
		BriefingBoxIsOpen = true
	end
end

function MakeMine(IndexNo,String,kFuse,GSnap)
    mine = CreateMine()
    mine.Fuse = kFuse
    mine.RandomFuse = false
    mine.Dud = false
    mine.GroundSnap = GSnap
    mine.Index = IndexNo
    SpawnMine(String,mine) 
end

function TurnOnArtilleryMode(kWorm)
    PlayerWorm = GetWormData(kWorm)
    PlayerWorm.ArtilleryMode = true
end

function TurnOffArtilleryMode(kWorm)
    PlayerWorm = GetWormData(kWorm)
    PlayerWorm.ArtilleryMode = false
end