-- Tutorial 2
--
-- Gripes:
--
-- ! Remove all "Watch" commands.
-- ! Do a search for KDEBUG - remove these, they are in to aid the scripter in getting through the tut quicker

-- Bugs:

function InitialiseLevel()
    LoadLevel("landscapes/T/T2.xom",true)
    SetupDefaultScheme()
end

function CreatePlayers()	
	SetupHumanPlayer(1,100)
    --player.VoiceBank = "Classic" *JE* I took this out Kev so the player could choose the soundbank
    player.SpecialWeapon = "kNoSpecialWeapon"
    GetPlayerData(0).MaxJetpackFuel = 0
    GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRef_Tut2_0W1"--wfRef_T2WC3--wfRef_Tut2_0W1
	
	EmptyInventory(0)
    inventory = GetPlayerInventory(0)
	inventory.SkipGo = 0
    inventory.Surrender = 0

    player = CreatePlayer("AI")
    player.NumberOfWorms = 4
    player.Name = "Remus"
    player.WormStartingHealth = 100
    player.VoiceBank = "Classic"
    player.SpecialWeapon = "kNoSpecialWeapon"
    player.Flag = 75
    CreatePlayersTeam(player.PlayerIndex)
    EmptyInventory(player.PlayerIndex);
    
    worm = GetWormData(1)
	worm.HatOverride = "Hat.Roman4"
    worm.SpawnPointName = "wfRef_Tut2_0W2"
    StandardWorm(worm ,"Remus")

    -- settlers spawn in at the end
    worm = GetWormData(2)
    worm.SpawnPointName = "wfRef_Tut2_Vis1"	
	worm.HatOverride = "Hat.Roman1"
    StandardWorm( worm , "Billy")
    
    worm = GetWormData(3)
    worm.SpawnPointName = "wfRef_Tut2_Vis2"	
	worm.HatOverride = "Hat.Medieval3"
    StandardWorm( worm , "Bobby")
    
    worm = GetWormData(4)
    worm.SpawnPointName = "wfRef_Tut2_Vis3"	
	worm.HatOverride = "Hat.Egyptian2"
    StandardWorm( worm , "Boo Boo")
	
    CopyContainer( GetAIParamsCPU5(), GetAIParamsWorm(1) )
    
    -- the initial "stronghold" crate the AI will collect
    GetAIParamsWorm(1).ImaginaryCrateReferencePoint = "wfRef_T2UC1_RemRef"
    GetAIParamsWorm(1).ImaginaryCrateCollectWeight = 10000
    GetAIParamsWorm(1).DelayBeforeFirstMove = -1
    
    referee = GetRefereeData()
    referee.TurnCounter = 0
    referee.WindDirection = 0
    referee.WindDirectionVariance = 0.0
    referee.WindStrengthMinimum = 0.0
    referee.WindStrengthVariance = 0.0
	referee.ShowVictorySequence = false -- Turns the end of game worm celebrations off

	SetVictorySequenceAllowed(false)
	
    scheme = GetCurrentSchemeData()

    scheme.CrateProbability = 0
    scheme.TurnTime = 9000
    scheme.HotSeatTime = 0
    scheme.RetreatTime = 0

    buildingStage = 0                   -- what stage are we at in the tutorial
    towersgone = 0                      -- this is used to count the number of towers fallen in the isolation bit
    bResetingIsolatedBuildings = false  -- the isolated building stage needs to know if it's being reset
    bDontShootYourOwnBuildings = false  -- Tell them not to shoot there own buildings, but only do it once
    kCounter = 0                        -- Variable to count where the briefing boxes are...
    WormHasJustDied = false             -- switch makes sure certain arguments don't occur when they shouldn't
    BuildDamSwitch = false              -- switch used in function DamageBuilding()
    FindTowerSwitch = false             -- switch used to find position of player's first tower
    MortarCratePos = "cuckoo"           -- used to determine spawn position of mortar crate
    bQuitable = true
    bResetingStrongholdBuildings = false
    WhichCrate = 1

	BriefingBoxIsOpen = false			-- tells me whether or not we have a briefing box open
	kPlayerWormHasBeenDamaged = false	-- if the player worm is damaged he might die.. and so we can't move him out of the way at the end
	RemusEndSequence = false			-- used to ensure script doesn't try to respawn player worm if he dies at the end
	MortarCrateCollected = false		-- switch used to ensure the tutorial doesn't get stuck when collecting the mortar immediately
	
	
end

function HideWormsNow()
    TurnOffHudElement("Time", false)
    TurnOffHudElement("TeamStatus", false)
    TurnOffHudElement("ResourcePoints", false)
    TurnOffHudElement("GetReadyMsg", false)
    
    SetInstantReplaysOn(false)    -- no replays
    
    RemoveVictoryLocation( "buildHere0021" )
    RemoveVictoryLocation( "buildHere0010" )
    RemoveVictoryLocation( "buildHere0012" )
    RemoveVictoryLocation( "buildHere0051" )
	RemoveVictoryLocation( "buildHere000" )
    RemoveAllBuildings()
	
    HideWorm( 2 )
    HideWorm( 3 )
    HideWorm( 4 )
    
	WormAllowIdleAnims(0,false)
	WormAllowIdleAnims(1,false)
	WormResetAnim(0)
	WormResetAnim(1)
	OrientateWorm(0, 0)
	OrientateWorm(1, 0)
	
    TurnOnArtilleryMode(0)
    
	StartEFMV("IntroT2A1",bQuitable)
end

function OnEndEFMV(szSeqName,bUserQuit)
    if bUserQuit == 0 then
        if szSeqName == "IntroT2A1" then
            StartEFMV("IntroT2A2",bQuitable)
        elseif szSeqName == "IntroT2A2" then
            StartEFMV("IntroT2A3",bQuitable)
			WormResetAnim(0)
			WormResetAnim(1)
			WormQueueAnim(0, "worm_wave1")
        elseif szSeqName == "IntroT2A3" then
            StartEFMV("IntroT2A44",bQuitable)
			WormResetAnim(0)
			WormQueueAnim(0, "worm_I_spy")
			DelayCall("Line1Text", 1.0)
			DelayCall("IntroT2A44_Anim_W0", 6.5)--khere 5.0
			DelayCall("Line2Text", 5.5)
			DelayCall("Line3Text", 9.0)
			DelayCall("Line3Text_Anim2", 12.5)
        elseif szSeqName == "IntroT2A44" then
            BeginTutorial()
		elseif szSeqName == "OutroT2" then
			CancelDelayCall("OutroTextLine1")
			CancelDelayCall("OutroTextLine2")
			CancelDelayCall("Outro_Anim_W3")
			CancelDelayCall("OutroTextLine3")
			CancelDelayCall("Outro_Anim_W2")
			CancelDelayCall("Outro_Anim_W4")
			CancelDelayCall("Outro_Anim2_W3")
			CancelDelayCall("Line3Text_Anim2")
			EndMissionSuccess()
        end
    elseif bUserQuit == 1 then
        if szSeqName == "IntroT2A1"
        or szSeqName == "IntroT2A2"
        or szSeqName == "IntroT2A3"
        or szSeqName == "IntroT2A44" then
			CancelDelayCall("Line1Text")
			CancelDelayCall("IntroT2A44_Anim_W0")
			CancelDelayCall("Line2Text")
			CancelDelayCall("Line3Text")
			CancelDelayCall("Line3Text_Anim2")
            BeginTutorial()
		elseif szSeqName == "OutroT2" then
			CancelDelayCall("RemusStatic_Text")
			CancelDelayCall("RemusStatic_Anims")
			CancelDelayCall("OutroTextLine1")
			CancelDelayCall("OutroTextLine2")
			CancelDelayCall("Outro_Anim_W3")
			CancelDelayCall("OutroTextLine3")
			CancelDelayCall("Outro_Anim_W2")
			CancelDelayCall("Outro_Anim_W4")
			CancelDelayCall("Outro_Anim2_W3")
			EndMissionSuccess()
        end
    end
end

function Line1Text()
	SetCommentaryText("Tut2.Opening.Comment1", 4000)
end

function Line2Text()
	SetCommentaryText("Tut2.Opening.Comment2", 3000)
end

function IntroT2A44_Anim_W0()
	WormResetAnim(1)
	WormQueueAnim(1, "worm_sleep")
end

function Line3Text()
	SetCommentaryText("Tut2.Opening.Comment3", 4000)
	WormResetAnim(0)
	WormQueueAnim(0, "worm_anticipation")
end

function Line3Text_Anim2()
	WormResetAnim(0)
	WormQueueAnim(0, "worm_comeon1")
end

function BeginTutorial()
	FlushCommentaryText()

	WormResetAnim(0)
	WormResetAnim(1)
	WormAllowIdleAnims(0,true)
	WormAllowIdleAnims(1,true)
	
    DelayCall("Delay1", 0.1)
end

function Delay1()
    MakeDefaultBriefingBox("Tut2.Utility.1New")
    SetSpecialCamera("wfRef_T2_Start1_LookAt", "wfRef_T2_Start1")
end

function Pause_ToAllowRemusWakeAnim()
	MakeDefaultBriefingBox("Tut2.Utility.3New")
	RemoveBlackBorders()
	WormAllowIdleAnims(1, true)
end

function OnExitBriefingBox()
	BriefingBoxIsOpen = false

    if WormHasJustDied == false then
        if kCounter == 0 then
            kCounter = 1
            EndSpecialCamera()
            SetSpecialCamera("wfRef_T2_Start3_LookAt", "wfRef_T2_Start3")
			WormResetAnim(1)
            MakeDefaultBriefingBox("Tut2.Utility.2New")
            -- first "stronghold" crate for AI to collect
            MakeWeaponCrate(0,"wfRef_T2UC1",kWF_BUILDING_STRONGHOLD,1,1)
        elseif kCounter == 1 then
			ShowBlackBorders()
            kCounter = 2
            EndSpecialCamera()
			WormAllowIdleAnims(1, false)
			WormResetAnim(1)
			WormQueueAnim(1, "worm_sleep")
			WormQueueAnim(1, "worm_wake")
            SetSpecialCamera("wfRef_T2_Start2_LookAt", "wfRef_T2_Start2")
			DelayCall("Pause_ToAllowRemusWakeAnim", 6.5)
        elseif kCounter == 2 then
            EndSpecialCamera()
            ShowBlackBorders()
            DelayCall("EndRemusDelay", 1)
        elseif kCounter == 3 then
            --DelayCall("LittlePause", 3)
			LittlePause()
        elseif kCounter == 5 then
			DelayCall("kCounter5Pause", 0.2)
		elseif kCounter == 51 then
			kCounter = 6
			MakeDefaultBriefingBox("TutAll.NoPlace.1")
        elseif kCounter == 6 then
			kCounter6Pause()
        elseif kCounter == 7 then
			EndSpecialCamera()
            TurnOffArtilleryMode(0)
            HideWorm(1)
        elseif kCounter == 8 then
            kCounter = 9
            MakeDefaultBriefingBox("Tut2.Stronghold.5")
            buildingStage = 2
            BeginNextStage()
        elseif kCounter == 10 then
			MakeWeaponCrate(0,MortarCratePos,kWF_WEAPON_MORTAR,kWF_INFINITE_AMOUNT,0)
            SetSpecialCamera(kCamLook, kCamPos)--khere11
			DelayCall("PauseBeforeNextBriefingBox", 1.0)
        elseif kCounter == 11 then--khere
            EndSpecialCamera()
        elseif kCounter == 12 then
            kCounter = 13
            MakeDefaultBriefingBox("Tut2.Firing.3")
        elseif kCounter == 13 then
            buildingStage = 6 
            BeginNextStage()
            SetSpecialCamera("wfRef_T2_EnemTowerCamLookAt", "wfRef_T2_EnemTowerCam")
            kCounter = 14
            MakeDefaultBriefingBox("Tut2.Firing.4")
        elseif kCounter == 14 then
            EndSpecialCamera()
            SetSpecialCamera("buildHere0021", "wfRef_T2_BaseCam")
            kCounter = 15
            MakeDefaultBriefingBox("Tut2.Firing.5")
        elseif kCounter == 15 then
            SpawnWorm(1, "wfRef_Tut2_1W2")
            OrientateWorm(1,20)
            kCounter = 16
            MakeDefaultBriefingBox("Tut2.Firing.6")
        elseif kCounter == 16 then
            EndSpecialCamera()
	    
	    -- SPP : Take mortar off them so they can't select it 
	    --    while remus is waving
	     inventory = GetPlayerInventory(0)
	    inventory.Mortar = 0
            -- CAMERA show Remus stood in front of tower, own sequence
            ShowBlackBorders()
            SetSpecialCamera("wfRef_T2_RemusStoodByTowerLookAt", "wfRef_T2_RemusStoodByTower")
            TurnOnArtilleryMode(0)
            
            WormAllowIdleAnims(1,false)
            WormResetAnim(1)
            
            DelayCall("EndRemusStoodByTowerSequence_Anim", 0.5)
            DelayCall("EndRemusStoodByTowerSequence", 3)
        elseif kCounter == 17 then
            EndSpecialCamera()
        elseif kCounter == 18 then
            kCounter = 19
            MakeDefaultBriefingBox("Tut2.Isolating.1")
            
            buildingStage = 7
            BeginNextStage()
        elseif kCounter == 19 then
            SetSpecialCamera("wfRef_T2_LineOfTowers_LookAt","wfRef_T2_LineOfTowers")
            kCounter = 20
            MakeDefaultBriefingBox("Tut2.Isolating.2")
        elseif kCounter == 20 then
            EndSpecialCamera()
        elseif kCounter == 21 then
			TurnOffArtilleryMode(0)
            kCounter = 221
            MakeDefaultBriefingBox("Tut2.Scorched.1")
		elseif kCounter == 221 then
			EndSpecialCamera()
	SetSpecialCamera("wfRef_T3_KeepLookAt","wfRef_T3_Keep")
			TurnOnArtilleryMode(0)
			DelayCall("PauseBeforeLighthouseBriefingBox", 1.0)
		elseif kCounter == 222 then
			kCounter = 223
			MakeDefaultBriefingBox("Tut.Lighthouse.2")
		elseif kCounter == 223 then
			kCounter = 22
			MakeDefaultBriefingBox("Tut.Lighthouse.3")
        elseif kCounter == 22 then
            EndSpecialCamera()
            SetSpecialCamera("wfRef_T2_GrenadeCrateLookAt","wfRef_T2_GrenadeCrate")
            buildingStage = 8
			kCounter = 23
            MakeDefaultBriefingBox("Tut2.Grenade.1")
        elseif kCounter == 23 then
            kCounter = 24
			EndSpecialCamera()
        elseif kCounter == 25 then
            kCounter = 26
            MakeDefaultBriefingBox("Tut2.Grenade.3")
        elseif kCounter == 26 then
            buildingStage = 9
            BeginNextStage()
            ShowBlackBorders()
            
            WormAllowIdleAnims(1,false)
            WormResetAnim(1)
            WormQueueAnim(1, "worm_shocked")
            
            SetSpecialCamera("wfRef_Tut2_2W2","wfRef_T2_TriWall")
            TurnOnArtilleryMode(0)
            DelayCall("EndRemusInTriangleWallSequence", 4)
        elseif kCounter == 27 then
            kCounter = 28
            MakeDefaultBriefingBox("Tut2.Grenade.5")
        elseif kCounter == 28 then
            kCounter = 29
        end
    end
    
    WormHasJustDied = false
end

function PauseBeforeLighthouseBriefingBox()
	kCounter = 222
	TurnOffArtilleryMode(0)
	MakeDefaultBriefingBox("Tut.Lighthouse.1")
end

-- This pause and kCounter6Pause mean that between two briefing boxes there is a total 0.2 second pause, which is enough time to allow the game
-- logic to pass over the turn from the cpu to the human.  This means that when skipping through these boxes very quickly you should never see the
-- cpu, but the turn should always now start on the human player.
function kCounter5Pause()
	buildingStage = 1
	EndTurn()
	kCounter = 51
	TurnOffArtilleryMode(0)
	MakeDefaultBriefingBox("Tut2.Stronghold.2New")
end

function kCounter6Pause()
	EndSpecialCamera()
	SetSpecialCamera("wfRef_T2UC2","wfRef_T2_FirstUtilCrateCam")
	kCounter = 7
	MakeDefaultBriefingBox("Tut2.Stronghold.3New")
	MakeWeaponCrate(0,"wfRef_T2UC2",kWF_BUILDING_TOWER,1,0)
end

function EndRemusDelay()
    EndAIDelayState()
end

function LittlePause()
    kCounter = 4
    buildingStage = 1
    BeginNextStage()
end

function EndRemusInTriangleWallSequence()
    RemoveBlackBorders()
    EndSpecialCamera()
    TurnOffArtilleryMode(0)
    
    WormAllowIdleAnims(1,true)
    WormResetAnim(1)
    
    kCounter = 27
    MakeDefaultBriefingBox("Tut2.Grenade.4")
end

function EndRemusStoodByTowerSequence_Anim()
	WormResetAnim(1)
    WormQueueAnim(1,"worm_wave1")
end

function EndRemusStoodByTowerSequence()
    RemoveBlackBorders()
    EndSpecialCamera()
    TurnOffArtilleryMode(0)
    
    -- SPP : Give mortar back as we took it off them so
    --    they couldn't select it during the remus waving sequence
    inventory = GetPlayerInventory(0)
    inventory.Mortar = kWF_INFINITE_AMOUNT
    
    SetSpecialCamera("buildHere0021", "wfRef_T2_BaseCam")
    
    WormAllowIdleAnims(1,true)
    WormResetAnim(1)
    
    kCounter = 17
    HideWorm(1)
    MakeDefaultBriefingBox("Tut2.Firing.7")
end

function PauseBeforeNextBriefingBox()
	if MortarCrateCollected == false then
		kCounter = 11
		TurnOffArtilleryMode(0)
		MakeDefaultBriefingBox("Tut2.Firing.1")
	end
end

function SetNextPlayerToGo(player)
    if buildingStage == 0 then
        -- the beginning, where Remus AI worm collects his crate
        return 1
    elseif buildingStage == 1 then
        -- end of initial AI turn, stronghold should be created
        -- set off the players super long turn and spawn in the tower
        -- crate to be collected
        SetupNeverEndingTurn( 600, true )
        return 0
    end

    return 0
end

function CrateCollected( crateIndex, wormIndex )
    -- a crate, somewhere has been collected, respond depending on
    -- what stage we are at in the tutorial
    if buildingStage == 0 then
        -- collection of this crate triggers the next stage
        RemoveBlackBorders()
        MakeDefaultBriefingBox("Tut2.Utility.4")
        kCounter = 3
        TurnOnArtilleryMode(0)
		TurnOnArtilleryMode(1)
        ShowOnlyScriptCommentary(true)
    elseif buildingStage == 1 then
        -- the player has collected the initial tower crate
        kCounter = 8
        MakeDefaultBriefingBox("Tut2.Stronghold.4")
    elseif buildingStage == 4 then
		MortarCrateCollected = true
        kCounter = 12
        MakeDefaultBriefingBox("Tut2.Firing.2")
    elseif buildingStage == 8 then
        kCounter = 25
        MakeDefaultBriefingBox("Tut2.Grenade.2")
    end
end

-- function that prepares everything for the next stage of the tutorial
-- the 'buildingStage' variable should be incremented BEFORE calling this function
function BeginNextStage()
    if buildingStage == 0 then
        -- do nothing
    elseif buildingStage == 1 then
        -- building stage 1 :
        -- stronghold springs up
        -- player collects tower crate
        -- end ai's turn and setup the player's super-long turn
        --EndTurn()
        -- clear the AI parameters
        GetAIParamsWorm(1).ImaginaryCrateReferencePoint = ""
        GetAIParamsWorm(1).ImaginaryCrateCollectWeight = 0
        -- need text/camera for stronghold creation, maybe some delay
        -- create it
        ShowOnlyScriptCommentary(false)
        SetSpecialCamera("wfRef_T2_StrongHold_LookAt", "wfRef_T2_StrongHold")
        CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0021" )
        -- make it invincible
        SetBuildingIndestructible( "buildHere0021", true, false )
    elseif buildingStage == 2 then
        -- player has collected the tower, tell them to select it
        -- SAM CreateBriefingBox("Miss.Generic.Hint14" )
    elseif buildingStage == 3 then
        --player is going to put the tower somewhere
        -- we have little to do here
    elseif buildingStage == 4 then
        -- drop a crate on the location where the tower was placed
        -- need code in BuildingHasBeenBuilt() to map 
        -- build locations to reference points somehow
        -- KCRATE
        kCounter = 10
        TurnOnArtilleryMode(0)
        MakeDefaultBriefingBox("Tut2.Stronghold.6")
    elseif buildingStage == 6 then
        -- the mortar crate has been collected, I couldn't be happier
        -- text and camera shit to do with strongholds
        CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0036" )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0030" )
        --ModifyBuildingHealth( "buildHere0036", 10, true  ) -- KDEBUG
        FlushCommentaryText()
    elseif buildingStage == 7 then
        -- they've hit the tower, spawn a new one	
		-- remove old tower and make a new one
		RemoveBuilding( "buildHere0030" )
		CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0030" )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0040" )
		ModifyBuildingHealth( "buildHere0030", 10, true  )
        FlushCommentaryText()
        -- tell them about isolation
        -- SAM CreateBriefingBox("Miss.Generic.Failed" )
    elseif buildingStage == 8 then
--~         inventory = GetPlayerInventory( 0 )
--~         inventory.Mortar = kWF_NOT_IN_INVENTORY
--~         -- KCRATE
    elseif buildingStage == 9 then
        -- There shouldnt be a tower left over from the previous round
        RemoveBuilding( "buildHere0030" )
        -- warp remus too where he needs to be
        SpawnWorm(1, "wfRef_Tut2_2W2")
        -- create triangle of buildings
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0030" )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0037" )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0040" )
        SetBuildingIndestructible( "buildHere0030", true, false )
        SetBuildingIndestructible( "buildHere0037", true, false )
        SetBuildingIndestructible( "buildHere0040", true, false )
        FlushCommentaryText()
    end
end

function MakeBriefingBoxAfterDelay()
    kCounter = 10
    MakeDefaultBriefingBox("Tut2.Stronghold.6")
end

function ItemSelectedOnWeaponsPanel( item )
    -- not sure if required
    -- bToldHowToPlace = false
    if item == kWF_BUILDING_TOWER and buildingStage == 2 then
        -- and bToldHowToPlace == false
        -- wahey they can select a tower from the weapons panel,
        -- tell them how to place it
        -- CreateBriefingBox("Miss.Generic.Hint14" )
        buildingStage = 3
        BeginNextStage()
        --bToldHowToPlace = true
    end 
end 

function BuildingHasBeenBuilt( PlayerId, BuildingType, buildingIndex ) 
    if buildingStage == 1 and BuildingType == kWF_BUILDING_STRONGHOLD then -- Remus AI worm collects his crate
        kCounter = 5
        MakeDefaultBriefingBox("Tut2.Stronghold.1")
    elseif buildingStage == 3 and BuildingType == kWF_BUILDING_TOWER then -- placing the tower
        -- the tower has been built, hurrah
        -- show congrats text and prepare to drop crate on top of the building

        WhereWasTheTowerBuilt()
        
        -- make the new tower invincible
        userTower = GetBuildingData( buildingIndex )
        userTower.BuildingName = "userTower"
        
        SetBuildingIndestructible( "userTower", true, false )
        
        buildingStage = 4
        BeginNextStage()
    end   
end

function WhereWasTheTowerBuilt()
    TBuildP1 = GetBuildPointInfo("buildHere0020")    
    if TBuildP1.BuildingType == kWF_BUILDING_TOWER then
        MortarCratePos = "wfRef_T2WCG1"
        kCamLook = "wfRef_T2_SC1_LookAt"
        kCamPos = "wfRef_T2_SC1"
    end
    
    TBuildP2 = GetBuildPointInfo("buildHere0014")
    if TBuildP2.BuildingType == kWF_BUILDING_TOWER then
        MortarCratePos = "wfRef_T2WCG2"
        kCamLook = "wfRef_T2_SC2_LookAt"
        kCamPos = "wfRef_T2_SC2"
    end
    
    TBuildP3 = GetBuildPointInfo("buildHere0015")
    if TBuildP3.BuildingType == kWF_BUILDING_TOWER then
        MortarCratePos = "wfRef_T2WCG3"
        kCamLook = "wfRef_T2_SC3_LookAt"
        kCamPos = "wfRef_T2_SC3"
    end
    
    TBuildP4 = GetBuildPointInfo("buildHere0022")
    if TBuildP4.BuildingType == kWF_BUILDING_TOWER then
        MortarCratePos = "wfRef_T2WCG4"
        kCamLook = "wfRef_T2_SC4_LookAt"
        kCamPos = "wfRef_T2_SC4"
    end
    
    TBuildP5 = GetBuildPointInfo("buildHere0016")
    if TBuildP5.BuildingType == kWF_BUILDING_TOWER then
        MortarCratePos = "wfRef_T2WCG5"
        kCamLook = "wfRef_T2_SC5_LookAt"
        kCamPos = "wfRef_T2_SC5"
    end
    
    TBuildP6 = GetBuildPointInfo("buildHere001")
    if TBuildP6.BuildingType == kWF_BUILDING_TOWER then
        MortarCratePos = "wfRef_T2WCG6"
        kCamLook = "wfRef_T2_SC6_LookAt"
        kCamPos = "wfRef_T2_SC6"
    end
end

-- buildHere0020
-- buildHere0014
-- buildHere0015
-- buildHere0022
-- buildHere0016
-- buildHere001

function DamageBuilding( PlayerId, BuildingType, buildingIndex, damage )	
    if PlayerId == 0 and bDontShootYourOwnBuildings == false then
        -- shoot your own buildings all you want, they're indestructible
        -- should at least tell them
        bDontShootYourOwnBuildings = true
    end 

    if buildingStage == 6 then
        if PlayerId == 1 and BuildingType == kWF_BUILDING_TOWER and BuildDamSwitch == false and bResetingStrongholdBuildings == false then
            -- successfully hit the tower
            TurnOnArtilleryMode(0)
            BuildDamSwitch = true
        end
    end

    return damage
end

function WeaponExpired( weaponId, playerId, wormId )
    if buildingStage == 6 then
        if BuildDamSwitch == true then
            -- successfully hit the tower
            DelayCall("SpecialCameraAfterTowerDamaged", 0.3)
        end
    end
end

function PlayerUsedItem( item, playerId, wormId )
	if kCounter == 29 then
		if item == kWF_WEAPON_GRENADE then
			kPlayerWormHasBeenDamaged = false
		end
	end
end

function SpecialCameraAfterTowerDamaged()
    SetSpecialCamera("wfRef_T2_EnemTowerCam2LookAt", "wfRef_T2_EnemTowerCam2")
    
    DelayCall("NextBriefingBoxAfterFirstTowerIsHit", 3)
end

function NextBriefingBoxAfterFirstTowerIsHit()--kh22
    
    -- make sure the camera doesn't get messed with when the player pulls
    -- out the mortar during the delay
    EndSpecialCamera( true )
    
    kCounter = 18
    MakeDefaultBriefingBox("Tut2.Firing.8")
    TurnOffArtilleryMode(0)
end

function BuildingHasBeenDestroyed( PlayerId, BuildingType )
    if PlayerId == 0 then
        -- What? they're killing their own building
        -- This really, really shouldnt happen as they're indestructable		
        DebugPrint( "Player should be unable to destroy own buildings" )
        
        return	
    end 

    if buildingStage == 6 then
        if BuildingType == kWF_BUILDING_STRONGHOLD and bResetingStrongholdBuildings == false then
            bResetingStrongholdBuildings = true
        
            RemoveBuilding( "buildHere0036" )
            RemoveBuilding( "buildHere0030" )
            CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0036" )
            CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0030" )
        
            WormHasJustDied = true
            MakeDefaultBriefingBox("Tut2.Firing.NegativeB")
            
            bResetingStrongholdBuildings = false
        end
    elseif buildingStage == 7 and bResetingIsolatedBuildings == false then
        if BuildingType == kWF_BUILDING_TOWER then
            towersgone = towersgone + 1

            -- make sure the right tower has been destroyed first
            if towersgone == 1 then
                -- this tower should be destroyed first
                buildpoint = GetBuildPointInfo( "buildHere0030" )
        
                if buildpoint.PlayerIndex == -1  then
                        -- bingo, they've destroyed the correct one
                        -- but wait until they've all fallen down (below)
                else
                        -- no, no, no wrong tower destroyed first
                        -- reset everything
                        DelayCall( "ResetIsolatedBuildingStage", 5 )
                end
            elseif towersgone == 2 then
                -- all the towers have fallen down, success!
                -- congrats all round, move to next stage
                SetSpecialCamera("wfRef_T2_LineOfTowers_LookAt","wfRef_T2_LineOfTowers")
				EmptyInventory(0)
				inventory = GetPlayerInventory(0)
				inventory.SkipGo = 0
				inventory.Surrender = 0
                RemoveWeapon(0)
				TurnOnArtilleryMode(0)
                SpawnNewCrate(kWF_WEAPON_GRENADE, kWF_INFINITE_AMOUNT ,"wfRef_T2WC3", 0)
				DelayCall("MakeNextBriefingBox_AfterTowersFallDown", 2.0)
            end		
        elseif BuildingType == kWF_BUILDING_STRONGHOLD and bResetingIsolatedBuildings == false then
            ResetStronghold()
        end
    end
end

function MakeNextBriefingBox_AfterTowersFallDown()
	kCounter = 21
	MakeDefaultBriefingBox("Tut2.Isolating.3")
end

function ResetStronghold()
    bResetingIsolatedBuildings = true

    -- removebuilding will ignore us if it's already gone
    -- and it's safest to fully reset
    RemoveBuilding( "buildHere0036" )
    RemoveBuilding( "buildHere0030" )
    RemoveBuilding( "buildHere0040" )
    
    CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0036" )
    CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0030" )
    CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0040" )
    
    towersgone = 0

    bResetingIsolatedBuildings = false
    
    WormHasJustDied = true
    MakeDefaultBriefingBox("Tut2.Isolating.NegativeA")
end

function ResetIsolatedBuildingStage()
    bResetingIsolatedBuildings = true

    -- removebuilding will ignore us if it's already gone
    -- and it's safest to fully reset	
    RemoveBuilding( "buildHere0030" )
    RemoveBuilding( "buildHere0040" )
    
    CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0030" )
    CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0040" )
    
    towersgone = 0

    bResetingIsolatedBuildings = false
    
    WormHasJustDied = true
    MakeDefaultBriefingBox("Tut2.Isolating.NegativeA")
end
	

function WormDamaged( wormIndex, AssailantTaskId, damage )
    if buildingStage == 9 then
        -- player damaging himself, duh
        if wormIndex == 0 then
            kPlayerWormHasBeenDamaged = true
        elseif wormIndex == 1 then
            -- they've hit remus, like they were supposed to
            buildingStage = 10  -- 10 isn't interactive, it's just the end sequence
            kCounter = 30
			RemusEndSequence = true
			-- delay move to function showing remus cam
			TurnOnArtilleryMode(0)
			-- remove grenade
			-- make worm artillery
			EmptyInventory(0)
			inventory = GetPlayerInventory(0)
			inventory.SkipGo = 0
			inventory.Surrender = 0
			TurnOnArtilleryMode(0)
			DelayCall("EndSequence", 4.0)
        end
    end

    return damage
end

function EndSequence()
    -- settlers spawn in ( location set in createplayers )
	MoveWorm(1, "wfRef_Tut2_RemusSeq", true)
    SpawnWorm(2,"wfRef_Tut2_Vis1")
    SpawnWorm(3,"wfRef_Tut2_Vis2")
    SpawnWorm(4,"wfRef_Tut2_Vis3")
	WormAllowIdleAnims(1,false)
	WormAllowIdleAnims(2,false)
	WormAllowIdleAnims(3,false)
	WormAllowIdleAnims(4,false)
	WormResetAnim(1)
	WormResetAnim(2)
	WormResetAnim(3)
	WormResetAnim(4)
	
	OrientateWorm(1, -75)
	OrientateWorm(2, 60)
	OrientateWorm(3, 95)
	OrientateWorm(4, 120)
    
	DelayCall("RemusStatic_Text", 1.3)
	--DelayCall("RemusStatic_Anims")
	DelayCall("RemusStatic_Anims", 0.5)
	DelayCall("RemusStatic_Anims2", 2.5)
 	DelayCall("OutroTextLine1", 9.5)
	DelayCall("OutroTextLine2", 14.5)
	DelayCall("Outro_Anim_W3", 15.1)
	DelayCall("OutroTextLine3", 19.0)
	DelayCall("Outro_Anim_W2", 20.0)
	DelayCall("Outro_Anim_W4", 20.5)
	DelayCall("Outro_Anim2_W3", 21.0)
	
	--khere need to determine if Rom is dead
	if kPlayerWormHasBeenDamaged == false then
		MoveWorm(0, "wfRef_T2WC3") -- move Romulus out of the way for the end sequence
	end

	StartEFMV("OutroT2", bQuitable)
end

function RemusStatic_Text()
	SetCommentaryText("Tut2.Ending.Comment1", 3200)
    SetCommentaryText("Tut2.Ending.Comment2", 3200)
end

function RemusStatic_Anims()
	WormResetAnim(1)
	WormQueueAnim(1,"worm_shakehead")
	WormQueueAnim(1,"worm_speakangry2")
end

function RemusStatic_Anims2()
	WormResetAnim(1)
	WormQueueAnim(1,"angry2")
end

function OutroTextLine1()
    SetCommentaryText("Tut2.Ending.Comment3", 3900)
end

function OutroTextLine2()
    SetCommentaryText("Tut2.Ending.Comment4", 3500)
end

function Outro_Anim_W3()
	WormResetAnim(3)
	WormQueueAnim(3, "worm_pompus")
end

function OutroTextLine3()
    SetCommentaryText("Tut2.Ending.Comment5", 4000)
end

function Outro_Anim_W2()
	WormResetAnim(2)
	WormQueueAnim(2, "worm_salute")
end

function Outro_Anim_W4()
	WormResetAnim(4)
	WormQueueAnim(4, "worm_smug")
end

function Outro_Anim2_W3()
	WormResetAnim(3)
	WormQueueAnim(3, "win1")
end

function WormDied( wormIndex )
    if wormIndex == 0 then
		WormHasJustDied = true
        SpawnRomulusAtHisStronghold()
    end
end

function WormDiedInNeverEndingTurn()
end

function SpawnRomulusAtHisStronghold()
    if kCounter == 7 then
        SpawnWorm( 0, "wfRef_Tut2_0W1" )
        MakeDefaultBriefingBox("TutAll.UtilityCrate.NegativeA")
    elseif kCounter == 9 then
        SpawnWorm( 0, "wfRef_Tut2_0W1" )
        MakeDefaultBriefingBox("Tut2.Stronghold.NegativeA")
    elseif kCounter == 11 then
        SpawnWorm( 0, "wfRef_Tut2_0W1" )
        MakeDefaultBriefingBox("TutAll.WeaponCrate.NegativeA")
    elseif kCounter == 17 then
        SpawnWorm( 0, MortarCratePos )
		OrientateWorm(0, -90)
        MakeDefaultBriefingBox("Tut2.Firing.NegativeB")
    elseif kCounter == 20 then
        SpawnWorm( 0, MortarCratePos )
		OrientateWorm(0, -90)
        MakeDefaultBriefingBox("Tut2.Firing.NegativeB")
    elseif kCounter == 24 then
        SpawnWorm( 0, "wfRef_T4HC6" )
		OrientateWorm(0, -135)
        MakeDefaultBriefingBox("TutAll.WeaponCrate.NegativeA")
    elseif kCounter == 29 then
		if RemusEndSequence == false then
			SpawnWorm( 0, "wfRef_T2WC3" )
			OrientateWorm(0, -140)
			MakeDefaultBriefingBox("Tut2.Grenade.NegativeA")
		end
    end
end
--OrientateWorm(0,90)
-- ********************************************************************************************************
-- *                                            ENGINE ROOM!!                                             *
-- ********************************************************************************************************

function CheckSuddenDeath()
end

function CheckVictoryConditions()
    return false
end

function EndMissionSuccess()
    Unlock("LOCK.Speech.MrT")
    Unlock("LOCK.Tutorial.03")
    
    EndRound(0)
end

function EndMissionFail()
    EndRound(1)
end

function MakeDefaultBriefingBox(String)
	if BriefingBoxIsOpen == false then
		SetBriefingBoxPosition(0,0) -- two variables set size and position of briefing box
		SetBriefingBoxSize(190,120)
		CreateBriefingBox(String)
		BriefingBoxIsOpen = true
	end
end

function TurnOnArtilleryMode(kWorm)
    PlayerWorm = GetWormData(kWorm)
    PlayerWorm.ArtilleryMode = true
end

function TurnOffArtilleryMode(kWorm)
    PlayerWorm = GetWormData(kWorm)
    PlayerWorm.ArtilleryMode = false
end

function MakeWeaponCrate(CrateId,CrateString,CrateContents,CrateAmmo,kTeamCollect)
    crate = CreateCrate(CrateContents)
    crate.Contents = CrateContents
    crate.NumContents = CrateAmmo
    crate.TeamDestructible = -1
    crate.WormCollectable = -1
    crate.TeamCollectable = kTeamCollect
    crate.GroundSnap = false
    crate.FixedPosition = false
    crate.UXB = false
    crate.Destructible = false
    crate.Pushable = false
    crate.CollectableByPayload = false
    crate.Collectable = true
    crate.CrateId = CrateId
    crate.IsCritical = false
    SpawnCrate(WhichCrate,CrateString)
    WhichCrate = WhichCrate + 1
end