-- Tutorial 3
--
-- Gripes:

-- Bugs:

-- what is "usertower" ?

function InitialiseLevel()
    LoadLevel("landscapes/T/T2.xom",true)
    SetupDefaultScheme()    
end

function CreatePlayers()	
	SetupHumanPlayer(1,100)
    player.SpecialWeapon = "kNoSpecialWeapon"
    GetPlayerData(0).MaxJetpackFuel = 0 
    GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRef_Tut3_0W1"

    EmptyInventory(0)
    inventory = GetPlayerInventory(0)
    inventory.Tower = 1
    inventory.Keep = 1
	inventory.SkipGo = 0
	inventory.Surrender = 0
	
    player = CreatePlayer("AI")
    player.NumberOfWorms = 3
    player.Name = "Remus"
    player.WormStartingHealth = 100
    player.VoiceBank = "Classic"
    player.Flag = 75
    player.SpecialWeapon = "kNoSpecialWeapon"
    CreatePlayersTeam(player.PlayerIndex)
    EmptyInventory(player.PlayerIndex);
    
    worm = GetWormData(1)
    worm.SpawnPointName = "wfRef_Tut3_0W2"
	worm.HatOverride = "Hat.Roman4"
    StandardWorm(worm ,"Remus")

    -- settlers spawn in at the end
    worm = GetWormData(2)
    worm.SpawnPointName = "wfRef_Tut3_Outro1"	
	worm.HatOverride = "Hat.Roman1"
    StandardWorm( worm , "Bert")
    
    worm = GetWormData(3)
    worm.SpawnPointName = "wfRef_Tut3_Outro2"	
	worm.HatOverride = "Hat.Medieval3"
    StandardWorm( worm , "Tony")
	
    CopyContainer( GetAIParamsCPU5(), GetAIParamsWorm(0) )

    referee = GetRefereeData()
    referee.TurnCounter = 0
    referee.WindDirection = 0
    referee.WindDirectionVariance = 0.0
    referee.WindStrengthMinimum = 0.0
    referee.WindStrengthVariance = 0.0
	referee.ShowVictorySequence = false -- Turns the end of game worm celebrations off
	
	SetVictorySequenceAllowed(false)

    scheme = GetCurrentSchemeData()
    scheme.TurnTime = 6000
    scheme.SuddenDeathTime = 0
    scheme.RetreatTime = 0
    scheme.HotSeatTime = 0
    scheme.HealthInCrates = 50
    scheme.CrateProbability = 0
    scheme.WeaponProbability = 0
    scheme.UtilityProbability = 0
    scheme.HealthProbability = 0

    weaponStage = 0                     -- what stage are we at in the tutorial
    bResetingInitialTower = false       -- are we removing the buildings when they get it wrong at the start
    bResetingInitialKeep = false        -- are we removing the buildings when they get it wrong at the start
    bNeedTowerLinkToCastle = false      -- do we need to build the extra towers to link to Castle
    castleTargetPosition = 0            -- where the castle has been built, alters where the target enemy buildings are placed
                                        -- zero is the default, it is only changed if castle is built in one of the locations below
    castleBuildPoint = 0                -- the actual index into array of where the castle is
    bQuitable = true

    -- array of build locations for determining castle location
    -- if the castle is in any of the first 6 locations the castleTargetPositions will be one
    -- and the enemy targets will be spawned in the same location as with the tower
    buildLocationArray = {"buildHere005","buildHere0011","buildHere0016","buildHere009","buildHere004","buildHere0014"}
	phantomLocationArray = {"pCubeCastlePhantom1","pCubeCastlePhantom2","pCubeCastlePhantom6","pCubeCastlePhantom3","pCubeCastlePhantom4","pCubeCastlePhantom5"}
	lookArray = {"wfRef_Banana1_LookAt","wfRef_Banana2_LookAt","wfRef_Banana6_LookAt","wfRef_Banana3_LookAt","wfRef_Banana4_LookAt","wfRef_Banana5_LookAt"}
	camArray = {"wfRef_Banana1_Cam","wfRef_Banana2_Cam","wfRef_Banana6_Cam","wfRef_Banana3_Cam","wfRef_Banana4_Cam","wfRef_Banana5_Cam"}
	
    targetId = 0                        -- target index of target crates
    kCounter = 0                        -- Variable to count where the briefing boxes are...
    WormHasJustDied = false             -- switch makes sure certain arguments don't occur when they shouldn't
    InGameCameras = false               -- switch to see whether or not this is intro/outro or in-game
    StrikeTargets = false               -- switch set to show only one briefing box after strike targets are destroyed
    OldLadyTargets = false              -- same as above
	ThisWasAGoodShot = false			-- this is used to calculate whether or not the player made some decent shots
	kRemovingBuildings = false			-- set when the buildings are being removed.
	kOldLadyTargetDestroyed = false		-- set to true when old lady blows up targets
	
	BriefingBoxIsOpen = false			-- tells me whether or not we have a briefing box open
	
	SetEFMVCameraShakeRatio(0.0)		-- command stops camera from shaking when buildings are created by the script
end

function HideWormsNow()
	Watch("weaponStage")

	HideWorm(2)
	HideWorm(3)

    RemoveAllBuildings()
	RemoveBuilding( "buildHere000" )

    CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0021" )
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0015" )
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0022" )
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere001" )
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0020" )
    
    SetupNeverEndingTurn(0, true)
    SetInstantReplaysOn(false)    -- no replays

    -- make player buildings invincible?
    SetBuildingIndestructible( "buildHere0021", true, false )
    SetBuildingIndestructible( "buildHere0015", true, false )
    SetBuildingIndestructible( "buildHere0022", true, false )
    SetBuildingIndestructible( "buildHere001", true, false )
    SetBuildingIndestructible( "buildHere0020", true, false )
    
    TurnOffHudElement("Time",false)
    TurnOffHudElement("TeamStatus",false)
    TurnOffHudElement("GetReadyMsg",false)
    
    -- intro over
    weaponStage = 1
    
	WormAllowIdleAnims(0,false)
	WormAllowIdleAnims(1,false)
	WormResetAnim(0)
	WormResetAnim(1)
	OrientateWorm(0, -50)
	OrientateWorm(1, 25)

    FlushCommentaryText()
    StartEFMV("IntroT3A",bQuitable)
end

function OnEndEFMV(szSeqName, bUserQuit)
	if InGameCameras == false then
		if bUserQuit == 0 then
			if szSeqName == "IntroT3A" then
				StartEFMV("IntroT3B",bQuitable)
			elseif szSeqName == "IntroT3B" then
				StartEFMV("IntroT3C",bQuitable)
			elseif szSeqName == "IntroT3C" then
				StartEFMV("IntroT3D",bQuitable)
				SetCommentaryText("Tut3.Opening.Comment1",3500 )
				WormResetAnim(1)
				WormQueueAnim(1, "worm_tired")
			elseif szSeqName == "IntroT3D" then
				StartEFMV("IntroT3E",bQuitable)
				SetCommentaryText("Tut3.Opening.Comment2",3500 )
			elseif szSeqName == "IntroT3E" then
				StartEFMV("IntroT3F",bQuitable)
				SetCommentaryText("Tut3.Opening.Comment3",3500 )
				WormResetAnim(0)
				WormQueueAnim(0, "worm_puzzled")
			elseif szSeqName == "IntroT3F" then
				BeginTutorial()
			elseif szSeqName == "OutroT3A" then
				StartEFMV("OutroT3B",bQuitable)
				DelayCall("EndingSeq_T2", 1.5)
				DelayCall("EndingSeq_Anim_W1", 2.0)
			elseif szSeqName == "OutroT3B" then
				StartEFMV("OutroT3C",bQuitable)
				DelayCall("EndingSeq_T3", 3.0)
				DelayCall("EndingSeq_Anim_W2", 3.5)
				DelayCall("EndingSeq_Anim_W3", 4.0)
			elseif szSeqName == "OutroT3C" then
				EndMissionSuccess()
			end
		elseif bUserQuit == 1 then
			if szSeqName == "IntroT3A"
			or szSeqName == "IntroT3B"
			or szSeqName == "IntroT3C"
			or szSeqName == "IntroT3D"
			or szSeqName == "IntroT3E"
			or szSeqName == "IntroT3F" then
				FlushCommentaryText()
				BeginTutorial()
			elseif szSeqName == "OutroT3A"
			or szSeqName == "OutroT3B" 
			or szSeqName == "OutroT3C" then
				CancelDelayCall("EndingSeq_T1")
				CancelDelayCall("EndingSeq_T2")
				CancelDelayCall("EndingSeq_Anim_W1")
				CancelDelayCall("EndingSeq_T3")
				CancelDelayCall("EndingSeq_Anim_W2")
				CancelDelayCall("EndingSeq_Anim_W3")
				EndMissionSuccess()
			end
		end
	elseif InGameCameras == true then
		if bUserQuit == 0 then
			if szSeqName == "ClipT3E" then
				DelayCall("BriefingBoxAfterStrikeEFMV", 0.7)
			end
		elseif bUserQuit == 1 then
			if szSeqName == "ClipT3E" then
				DelayCall("BriefingBoxAfterStrikeEFMV", 0.7)
			end
		end
	end
end

function BriefingBoxAfterStrikeEFMV()
	kCounter = 18
	MakeDefaultBriefingBox("Tut3.StrikeWeap.2")
end

function BeginTutorial()
	WormAllowIdleAnims(0,true)
	WormAllowIdleAnims(1,true)
	WormResetAnim(0)
	WormResetAnim(1)
	OrientateWorm(0, 50)
	HideWorm(1)
    InGameCameras = true
    MakeDefaultBriefingBox("Tut3.Resource.1New")
end

function Static_Cam_Stronghold()
    SetSpecialCamera("wfRef_Stronghold_LookAt","wfRef_Stronghold")
    MakeDefaultBriefingBox("Tut3.Resource.2New")
end

function OnExitBriefingBox()
	BriefingBoxIsOpen = false

    if WormHasJustDied == false then
        if kCounter == 0 then
            kCounter = 1
            DelayCall("Static_Cam_Stronghold", 0.1)
        elseif kCounter == 1 then
            kCounter = 2
            MakeDefaultBriefingBox("Tut3.Resource.3New")
        elseif kCounter == 2 then
            EndSpecialCamera()
            SetSpecialCamera("wfRef_VL_LookAt","wfRef_VL")
            kCounter = 3
            MakeDefaultBriefingBox("Tut3.Resource.4New")
        elseif kCounter == 3 then
            EndSpecialCamera()
        elseif kCounter == 4 then
			SetSpecialCamera("wfRef_VL2_LookAt","wfRef_VL2")
            kCounter = 5
            MakeDefaultBriefingBox("Tut3.Resource.6New")
		elseif kCounter == 5 then
			EndSpecialCamera()
        elseif kCounter == 51 then
            kCounter = 5
            EndSpecialCamera()
        elseif kCounter == 6 then
            EndSpecialCamera()
            kCounter = 7
            weaponStage = 3
            BeginNextStage()
        elseif kCounter == 8 then
            kCounter = 9
            MakeDefaultBriefingBox("Tut3.BiggerWeap.2")
        elseif kCounter == 9 then
            SetSpecialCamera("buildHere0013","wfRef_T3_EnemTowers")
            kCounter = 10
            SpawnEnemyBuildingTargets()
            MakeDefaultBriefingBox("Tut3.BiggerWeap.3New2")
        elseif kCounter == 10 then
            EndSpecialCamera()
            kCounter = 11
            BeginNextStage()
		elseif kCounter == 121 then
			kCounter = 122
			MakeDefaultBriefingBox("Tut3.FireScorch.1")
		elseif kCounter == 122 then
			RemoveLeftHandBuildings()
			SetSpecialCamera("wfRef_T3_CastleCrateLookAt","wfRef_T3_CastleCrateCam")
			kCounter = 12
			MakeDefaultBriefingBox("Tut3.BiggerWeap.4New")
        elseif kCounter == 12 then
            EndSpecialCamera()
        elseif kCounter == 13 then
			EndSpecialCamera()
        elseif kCounter == 14 then
            EndSpecialCamera()
            kCounter = 15
        elseif kCounter == 16 then
            EndSpecialCamera()
        elseif kCounter == 17 then
            -- EFMV here ClipT3E - showing location of AirStrike targets.
            DelayCall("Camera_ClipT3E",0.2)
        elseif kCounter == 19 then
            EndSpecialCamera()
        elseif kCounter == 20 then
            SetSpecialCamera("wfRef_T3TargetOld","wfRef_T3_OldLadyTarg")
            kCounter = 21
            MakeDefaultBriefingBox("Tut3.Animals.3")
            weaponStage = 12
            BeginNextStage()
        elseif kCounter == 21 then
            EndSpecialCamera()
		elseif kCounter == 22 then
			EndSpecialCamera()
        elseif kCounter == 23 then
            SetSpecialCamera("buildHere0013","wfRef_T3_EnemTowers")
            kCounter = 24
            MakeDefaultBriefingBox("Tut3.DirectFire.3")
            SetUpBallistaTowers()
        elseif kCounter == 24 then
            EndSpecialCamera()
        elseif kCounter == 25 then
            DelayCall("EndingSequence", 0.2)
        end
    end

    WormHasJustDied = false
end

function Camera_ClipT3E()
    StartEFMV("ClipT3E", bQuitable)
end

function SetUpBallistaTowers()
    RemoveBuilding( "buildHere0013" )
    RemoveBuilding( "buildHere008" )
    RemoveBuilding( "buildHere003" )
    RemoveBuilding( "buildHere0052" )
    
    CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0013" )
    CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere008" )
    CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere003" )
    CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0052" )
    FlushCommentaryText()
end

function RemoveLeftHandBuildings()
	kRemovingBuildings = true
    RemoveBuilding( "buildHere0013" )
    RemoveBuilding( "buildHere008" )
    RemoveBuilding( "buildHere003" )
    RemoveBuilding( "buildHere0052" )
	kRemovingBuildings = false
end

function SetNextPlayerToGo(player)
    return player
end

function CrateCollected( crateIndex, wormIndex )
    if weaponStage == 3 then
        -- fire grenade crate collected, move to shooting targets
        weaponStage = 4
        kCounter = 8
        MakeDefaultBriefingBox("Tut3.BiggerWeap.1")
    elseif weaponStage == 5 then
        -- collected castle crate move to building it
        weaponStage = 6
        BeginNextStage()
    elseif weaponStage == 7 then
        -- fridge/banana bomb collected
		SweepAndClearArea("wfRef_T3_SC1")
		SweepAndClearArea("wfRef_T3_SC2")
		SweepAndClearArea("wfRef_T3_SC3")
        kCounter = 14
        MakeDefaultBriefingBox("Tut3.BiggerWeap.6New")
        --kcamhere
        weaponStage = 8
        BeginNextStage()
    elseif weaponStage == 9 then
        -- air strike collected
        weaponStage = 10
        BeginNextStage()
    elseif weaponStage == 11 then
        --old lady collected        
        kCounter = 20
        MakeDefaultBriefingBox("Tut3.Animals.2New")
    elseif weaponStage == 13 then
        -- ballista  collected
        weaponStage = 14
        BeginNextStage()
    end
end

-- function that prepares everything for the next stage of the tutorial
-- the 'weaponStage' variable should be incremented BEFORE calling this function
function BeginNextStage()
    if weaponStage == 0 then
        -- intro, building initial towers
    elseif weaponStage == 1 then
        -- building tower, do nothing
    elseif weaponStage == 2 then
        -- tower successful
        -- building keep, do nothing
    elseif weaponStage == 3 then
        -- keep successful
        -- drop fire grenade crate
    elseif weaponStage == 4 then
        -- crate collected, spawn in target buildings
        -- and wait for them to run out of ammo
    elseif weaponStage == 5 then
		SweepAndClearArea("wfRef_T3Castle")
		MakeWeaponCrate(0,"wfRef_T3Castle",kWF_BUILDING_CASTLE,1,true)
		
		if ThisWasAGoodShot == true then
			ThisWasAGoodShot = false
			MakeDefaultBriefingBox("TutAll.GoodWork")
		elseif ThisWasAGoodShot == false then
			MakeDefaultBriefingBox("TutAll.Practice")
		end
		
		kCounter = 121
    elseif weaponStage == 6 then
        -- building castle, do nothing
    elseif weaponStage == 7 then
        -- castle successful,
		SweepAndClearArea("wfRef_T3_SC1")
		SweepAndClearArea("wfRef_T3_SC2")
		SweepAndClearArea("wfRef_T3_SC3")
		SweepAndClearArea("wfRef_T3_SC4")
		SweepAndClearArea("wfRef_T3_SC5")
		SweepAndClearArea("wfRef_T3_SC6")
		crate.IsCritical = false
		
		DelayCall("PauseAsCastleIsBeingBuilt", 2.0)
        -- spawn crate on toop of the castle
    elseif weaponStage == 8 then
        -- fridge/banana bomb crate collected, spawn in some buildings
        SpawnEnemyBuildingTargets()
    elseif weaponStage == 9 then
		if ThisWasAGoodShot == true then
			ThisWasAGoodShot = false
			MakeDefaultBriefingBox("Tut3.BiggerWeap.Good")
		elseif ThisWasAGoodShot == false then
			MakeDefaultBriefingBox("Tut3.BiggerWeap.Bad")
		end
	
        kCounter = 16
		SweepAndClearArea("wfRef_T3Castle")
		MakeWeaponCrate(2,"wfRef_T3Castle",kWF_WEAPON_AIR_STRIKE,kWF_INFINITE_AMOUNT,false)
        --DelayCall("Static_Cam_AirStrikeCrate", 0.2)
		Static_Cam_AirStrikeCrate()
    elseif weaponStage == 10 then
        -- crate collected, spawn target for the airstrike
        kCounter = 17
        MakeTarget( 0, "wfRefT3_Targ1" )
        MakeTarget( 1, "wfRefT3_Targ2" )
        MakeTarget( 2, "wfRefT3_Targ3" )
        MakeTarget( 3, "wfRefT3_Targ4" )
        MakeTarget( 4, "wfRefT3_Targ5" )
        MakeDefaultBriefingBox("Tut3.StrikeWeap.1")
    elseif weaponStage == 11 then
		-- this section has been moved elsewhere
    elseif weaponStage == 12 then
        -- spawn target for the old lady
        MakeTarget( 1, "wfRef_T3TargetOld" )
        MakeTarget( 2, "wfRef_T3TargetOld1" )
        MakeTarget( 3, "wfRef_T3TargetOld2" )
    elseif weaponStage == 13 then
        -- conclude old lady text and tell em to collect the next crate
        kCounter = 22
		
		if IsWormWithinPhantom( 0, "pCubeTowerPhantom" ) == true then
			SweepAndClearArea("wfRef_T3Ballista_Other")
			MakeWeaponCrate( 0 ,"wfRef_T3Ballista_Other", kWF_WEAPON_BALLISTA, 1,false )
			SetSpecialCamera("wfRef_T3Ballista2Crate_LookAt","wfRef_T3Ballista2Crate_Cam")
		else
			SweepAndClearArea("wfRef_T3Ballista")
			MakeWeaponCrate( 0 ,"wfRef_T3Ballista", kWF_WEAPON_BALLISTA, 1,false )
			SetSpecialCamera("wfRef_T3BallistaCrate_LookAt","wfRef_T3BallistaCrate_Cam")
		end
		
		MakeDefaultBriefingBox("Tut3.DirectFire.1")
    elseif weaponStage == 14 then
        -- ballista collected
        kCounter = 23
        MakeDefaultBriefingBox("Tut3.DirectFire.2New")
    elseif weaponStage == 15 then
        -- finished firing ballista
        kCounter = 25
        MakeDefaultBriefingBox("Tut3.Ending.1")
    end
end

function PauseAsCastleIsBeingBuilt()
	if IsWormWithinPhantom( 0, phantomLocationArray[castleBuildPoint] ) == true then
		SweepAndClearArea("wfRef_T3Castle")
		SpawnNewCrate( kWF_WEAPON_BANANA_BOMB_LAUNCHER, 3 , "wfRef_T3Castle", 20)
		SetSpecialCamera("wfRef_T3_CastleCrateLookAt","wfRef_T3_CastleCrateCam") -- khere this needs to be changed with arraylio
	else
		SweepAndClearArea(buildLocationArray[castleBuildPoint])
		SpawnNewCrate( kWF_WEAPON_BANANA_BOMB_LAUNCHER, 3 , buildLocationArray[castleBuildPoint], 20)
		SetSpecialCamera(lookArray[castleBuildPoint],camArray[castleBuildPoint])
	end			
	
	kCounter = 13
	MakeDefaultBriefingBox("Tut3.BiggerWeap.5")
end

function Static_Cam_AirStrikeCrate()
    SetSpecialCamera("wfRef_T3_CastleCrateLookAt","wfRef_T3_CastleCrateCam")
end

function BuildingHasBeenBuilt( PlayerId, BuildingType, buildingIndex )
    if weaponStage == 1 then
        -- we need the player to build on the resource point at buildHere0010
        towerHere = GetBuildPointInfo( "buildHere0010" )
        
        if towerHere.BuildingType == kWF_BUILDING_TOWER then
            -- success, they built in the right place
            MakeNewBuildingIndestructable( buildingIndex, "userTower" )
            weaponStage = 2
            BeginNextStage()
            
            kCounter = 4
            MakeDefaultBriefingBox("Tut3.Resource.5New")
        else
            -- no, wrong. tower in wrong place
            -- we can't remove it that quickly as buildings can't handle it
            DelayCall( "ResetBuildingsForInitialTower", 3 )
        end
    elseif weaponStage == 2 then
        -- building keep, like the tower it needs to be in the right place
        keepHere = GetBuildPointInfo( "buildHere000" )
        
        if keepHere.BuildingType == kWF_BUILDING_KEEP then
            -- they built a keep, drop crate
			if IsWormWithinPhantom( 0, "pCubeKeepPhantom" ) == true then
				SweepAndClearArea("wfRef_T3Castle")
				MakeWeaponCrate(0,"wfRef_T3Castle",kWF_WEAPON_FIRE_GRENADE_LAUNCHER,3,false)--kdebug
				DelayCall("ShowCrateOnTopOfKeep2", 0.5)
			else
				SweepAndClearArea("wfRef_T3FireGrenL")
				MakeWeaponCrate(0,"wfRef_T3FireGrenL",kWF_WEAPON_FIRE_GRENADE_LAUNCHER,3,false)--kdebug
				DelayCall("ShowCrateOnTopOfKeep", 0.5)
			end
			
            MakeNewBuildingIndestructable( buildingIndex, "userKeep" )
        else 
            -- wrong, reset, again there needs to be a Delay 
            DelayCall( "ResetBuildingsForInitialKeep", 3 )
        end
    elseif weaponStage == 6 then
        -- castle has been built, check where it is to set where
        -- the targets will be built
        for nBuildPoint = 1, 3 do
            castleHere = GetBuildPointInfo( buildLocationArray[nBuildPoint] )
            if castleHere.BuildingType == kWF_BUILDING_CASTLE then
                -- set the position of the castle targets to be the same as the keep
                castleTargetPosition = 1
                -- store the position of the castle
                castleBuildPoint = nBuildPoint
            end
        end
        -- check if we've not found the castle location yet
        if castleTargetPosition == 0 then
            -- no, find where the castle is so we can drop crates on it
            for nBuildPoint = 4, 6 do
                castleHere = GetBuildPointInfo( buildLocationArray[nBuildPoint] )
                if castleHere.BuildingType == kWF_BUILDING_CASTLE then
                    -- store the position of the castle
                    castleBuildPoint = nBuildPoint
                end			
            end
        end
        
        MakeNewBuildingIndestructable( buildingIndex, "userCastle" )
        -- castle up, drop a fridge crate
        weaponStage = 7
        BeginNextStage()
        
    end   --  if weapon stages
end

function ShowCrateOnTopOfKeep()
    SetSpecialCamera("wfRef_T3_KeepLookAt","wfRef_T3_Keep")
    kCounter = 6
    MakeDefaultBriefingBox("Tut3.Resource.7")
end

function ShowCrateOnTopOfKeep2()
    SetSpecialCamera("wfRef_T3_CastleCrateLookAt","wfRef_T3_CastleCrateCam")
    kCounter = 6
    MakeDefaultBriefingBox("Tut3.Resource.7")
end

function BuildingHasBeenDestroyed( PlayerId, BuildingType )
--~     if PlayerId == 0 then
--~         -- What? they're killing their own building
--~         -- This really, really shouldnt happen as they're indestructable		
--~         --DebugPrint( "Player should be unable to destroy own buildings" )
--~         
--~         return	
--~     end
	if kCounter == 11 and kRemovingBuildings == false then
		ThisWasAGoodShot = true
	elseif kCounter == 15 and kRemovingBuildings == false then
		ThisWasAGoodShot = true
	end
end

function ResetBuildingsForInitialTower()
    bResetingInitialTower = true

    SetSpecialCamera("wfRef_VL_LookAt","wfRef_VL")
    MakeDefaultBriefingBox( "Tut3.Resource.NegativeANew" )
    
    -- removebuilding will ignore us if it's not there
    -- and it's safest to fully reset
    -- TODO : this list is incomplete, the tower can be in a lot more
    -- 	places than this	
    RemoveBuilding( "buildHere0011" )
    RemoveBuilding( "buildHere0014" )
    RemoveBuilding( "buildHere009" )
    RemoveBuilding( "buildHere0016" )
    RemoveBuilding( "buildHere0026" )
    RemoveBuilding( "buildHere0019" )
    RemoveBuilding( "buildHere0018" )
    RemoveBuilding( "buildHere0028" )
    RemoveBuilding( "buildHere0049" )
    RemoveBuilding( "buildHere0050" )
    RemoveBuilding( "buildHere0023" )
    RemoveBuilding( "buildHere0017" )

    inventory = GetPlayerInventory( 0 )
    inventory.Tower = 1
    bResetingInitialTower = false
end

function ResetBuildingsForInitialKeep()
    bResetingInitialKeep = true

    kCounter = 51
    MakeDefaultBriefingBox( "Tut3.Resource.NegativeCNew" )
    SetSpecialCamera("wfRef_VL2_LookAt","wfRef_VL2")
    
    -- removebuilding will ignore us if it's not there
    -- and it's safest to fully reset
    -- TODO : this list is incomplete, the keep can be in a lot more
    -- 	places than this
    RemoveBuilding( "buildHere0011" )
    RemoveBuilding( "buildHere0014" )
    RemoveBuilding( "buildHere009" )
    RemoveBuilding( "buildHere0016" )
    RemoveBuilding( "buildHere0026" )
    RemoveBuilding( "buildHere0019" )
    RemoveBuilding( "buildHere0018" )
    RemoveBuilding( "buildHere0028" )
    RemoveBuilding( "buildHere0049" )
    RemoveBuilding( "buildHere0050" )
    RemoveBuilding( "buildHere0023" )
    RemoveBuilding( "buildHere0017" )
    RemoveBuilding( "buildHere004" )
    RemoveBuilding( "buildHere005" )
    
    inventory = GetPlayerInventory( 0 )
    inventory.Keep = 1
    bResetingInitialKeep = false
end

function MakeNewBuildingIndestructable( buildingIndex, buildingName )
    NewBuilding = GetBuildingData( buildingIndex )
    NewBuilding.BuildingName = buildingName

    SetBuildingIndestructible( buildingName, true, false )
end 

function SpawnEnemyBuildingTargets()
    if weaponStage == 4 then
        CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0013" )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere008" )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere003" )
        CreateBuilding( kWF_BUILDING_TOWER, 1, "buildHere0052" )
        FlushCommentaryText()
    elseif weaponStage == 8 then
        -- create target buildings based on where the castle was built
        if castleTargetPosition == 1 then
            -- should we remove the previous buildings first?
            SetSpecialCamera("buildHere0013","wfRef_T3_EnemTowers")
            CreateBuilding(  kWF_BUILDING_STRONGHOLD, 1, "buildHere0013" )
            CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere008" )
            CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere003" )
            CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0052" )
            FlushCommentaryText()            
        else 
            SetSpecialCamera("buildHere0030","wfRef_T3_EnemTowersDeuce")
            CreateBuilding( kWF_BUILDING_STRONGHOLD, 1, "buildHere0036" )
            CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0030" )
            CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0037" )
            CreateBuilding( kWF_BUILDING_KEEP, 1, "buildHere0040" )
            FlushCommentaryText()
        end
    end
end

function PlayerUsedItem( item, playerId, wormId )
	if weaponStage == 10 then
		if item == kWF_WEAPON_AIR_STRIKE then
			if IsWormWithinPhantom( 0, "pCubeStrikeAreaPhantom" ) == true then
				-- There is a chance the worm can be hit by their own Air Strike, so let's move them!
				DelayCall("MoveWormAfterStrikeDelay", 1.0)
			end
		end
	end
end

function MoveWormAfterStrikeDelay()
	MoveWorm(0,"wfRef_Tut4_3W1")
end

function WeaponExpired( weaponId, playerId, wormId )
    if weaponStage == 4 then
        if weaponId == kWF_WEAPON_FIRE_GRENADE_LAUNCHER then
			SweepAndClearArea("wfRef_T3FireGrenL")
            inventory = GetPlayerInventory( playerId )
            if inventory.FireGrenadeLauncher == 0 then
                weaponStage = 5
                -- no idea how long it will take for the shot to be resolved
                -- but eight seconds *should* be enough
                DelayCall( "BeginNextStage", 1 )
            end
        end
    elseif weaponStage == 8 then
        if weaponId == kWF_WEAPON_BANANA_BOMB_LAUNCHER then
            inventory = GetPlayerInventory( playerId )
            if inventory.BananaBombLauncher == 0 then
                weaponStage = 9
                -- no idea how long it will take for the shot to be resolved
                -- but eight seconds *should* be enough
                DelayCall( "BeginNextStage", 1 )
            end
        end
	elseif weaponStage == 12 then
		if weaponId == kWF_WEAPON_OLD_LADY then
			if kOldLadyTargetDestroyed == true then
				inventory = GetPlayerInventory(0)
				inventory.OldLady = 0
				
				weaponStage = 13
				DelayCall("BeginNextStage", 1.0)
			end
		end
    elseif weaponStage == 14 then
        if weaponId == kWF_WEAPON_BALLISTA then
            inventory = GetPlayerInventory( playerId )
            if inventory.Ballista == 0 then
                -- finished
                weaponStage = 15
                DelayCall( "BeginNextStage", 1 )
            end
        end
    end
end

-- create crate functions,
-- these are kev's functions, which I've slighty modded
-- to pass SpawnCrate the container and not an index
function MakeTarget( TargetId, TargetString)
    crate = CreateCrate()
    crate.Contents = kWF_TRIGGER_CRATE 
    crate.NumContents = 0
    crate.CrateId = TargetId
    crate.TeamDestructible = -1
    crate.WormCollectable = 10
    crate.TeamCollectable = 10
    crate.GroundSnap = true
    crate.FixedPosition = true
    crate.UXB = false
    crate.Destructible = true
    crate.Pushable = false
    crate.CollectableByPayload = false
    crate.Collectable = false
	crate.Model = "Crate.Target"
	crate.SpinBaby = true
	crate.ScaleFactor = 1.0
    SpawnCrate( crate, TargetString)
end

function MakeWeaponCrate(CrateId,CrateString,CrateContents,CrateAmmo,IsCrateCritical)
    crate = CreateCrate(CrateContents)
    crate.Contents = CrateContents
    crate.NumContents = CrateAmmo
    crate.TeamDestructible = -1
    crate.WormCollectable = -1
    crate.TeamCollectable = 0
    crate.GroundSnap = true
    crate.FixedPosition = false
    crate.UXB = false
    crate.Destructible = false
    crate.Pushable = false
    crate.CollectableByPayload = false
    crate.Collectable = true
    crate.CrateId = CrateId
	crate.ScaleFactor = 2.0
	crate.SpinBaby = false
	crate.IsCritical = IsCrateCritical    -- mmm, shiny graphical effect
    SpawnCrate( crate, CrateString)
end

function CrateDestroyed(CrateIndex,WormIndex)
    crate = GetCrateData(CrateIndex)

    -- air strike target
    if weaponStage == 10 then
        if crate.CrateId == 0 and StrikeTargets == false then
            StrikeTargets = true
            inventory = GetPlayerInventory(0)
            inventory.AirStrike = 0
        
            DelayCall("Delay_Starting_OldLady", 7.5)
        end
    elseif weaponStage == 12 then
        if crate.CrateId == 1 then
			-- old lady targets
            -- move to direct fire weapons
			kOldLadyTargetDestroyed = true
        end
    end
end

function Delay_Starting_OldLady()
    weaponStage = 11
    kCounter = 19
    MakeDefaultBriefingBox("Tut3.Animals.1")
    -- drop an old lady crate
    
	if IsWormWithinPhantom( 0, "pCubeKeepPhantom" ) == true then
		SweepAndClearArea("wfRef_T3Castle")
		MakeWeaponCrate( 0 ,"wfRef_T3Castle", kWF_WEAPON_OLD_LADY, kWF_INFINITE_AMOUNT,false )
		SetSpecialCamera("wfRef_T3_CastleCrateLookAt","wfRef_T3_CastleCrateCam")
	else
		SweepAndClearArea("wfRef_T3OldLady")
		MakeWeaponCrate( 0 ,"wfRef_T3OldLady", kWF_WEAPON_OLD_LADY, kWF_INFINITE_AMOUNT,false )
		SetSpecialCamera("wfRef_T3_OldLadyCrate_LookAt","wfRef_T3_OldLadyCrate")
	end
end

-- A CheckVictoryConditions function that always returns
-- false will cause the game only be ended explicitly by script
function CheckVictoryConditions()
    return false
end

--~ function WormDamaged( wormIndex, AssailantTaskId, damage )
--~     return damage
--~ end

function WormDied( wormIndex )
    if wormIndex == 0 then
		WormHasJustDied = true

        RespondToPlayerDeath()
    end
end

function WormDiedInNeverEndingTurn()
    -- deliberately empty 
end

-- function to display correct txt when the player worm dies
function RespondToPlayerDeath()
    if weaponStage == 0 then		
        -- intro, err dunno
		SpawnWorm( 0, "wfRef_Tut3_0W1" )
		OrientateWorm(0,50)
        MakeDefaultBriefingBox("Tut3.Resource.NegativeANew")
    elseif weaponStage == 1 then	
        -- build initial tower on resource point
		SpawnWorm( 0, "wfRef_Tut3_0W1" )
		OrientateWorm(0,50)
        MakeDefaultBriefingBox("Tut3.Resource.NegativeANew" )
    elseif weaponStage == 2 then
        -- building keep
		SpawnWorm( 0, "wfRef_Tut3_0W1" )
		OrientateWorm(0,50)
        MakeDefaultBriefingBox( "Tut3.Resource.NegativeCNew" )
    elseif weaponStage == 3 then	
        --collecting crate
		SpawnWorm( 0, "wfRef_Tut3_0W1" )
		OrientateWorm(0,50)
        MakeDefaultBriefingBox("TutAll.WeaponCrate.NegativeA")
    elseif weaponStage == 4 then 	
        --shooting targets
		SpawnWorm( 0, "wfRef_T3FireGrenL" )
		OrientateWorm(0,0)
        MakeDefaultBriefingBox( "Tut3.BiggerWeap.NegativeANew" )
    elseif weaponStage == 5 then
        -- collecting castle crate
		SpawnWorm( 0, "wfRef_Tut4_3W1" )
		OrientateWorm(0,-90)
        MakeDefaultBriefingBox( "Tut3.BiggerWeap.NegativeC" )
    elseif weaponStage == 6 then
		SpawnWorm( 0, "wfRef_Tut4_3W1" )
		OrientateWorm(0,-90)
        MakeDefaultBriefingBox( "Tut3.BiggerWeap.NegativeC" )
        -- building castle
    elseif weaponStage == 7 then
		SpawnWorm( 0, "wfRef_Tut4_3W1" )
		OrientateWorm(0,-90)
		MakeDefaultBriefingBox("TutAll.WeaponCrate.NegativeA")
        -- collect bananabomb/fridge
    elseif weaponStage == 8 then
		SpawnWorm( 0, buildLocationArray[castleBuildPoint] )
		OrientateWorm(0,-90)
        -- shooting buildings
        MakeDefaultBriefingBox( "Tut3.BiggerWeap.NegativeD" )
    elseif weaponStage == 9 then
		SpawnWorm( 0, "wfRef_Tut4_3W1" )
		OrientateWorm(0,-90)
        -- drop air strike crate
        MakeDefaultBriefingBox( "TutAll.WeaponCrate.NegativeA" )
    elseif weaponStage == 10 then
		SpawnWorm( 0, "wfRef_Tut4_3W1" )
		OrientateWorm(0,-90)
        -- air strike target
        MakeDefaultBriefingBox( "Tut3.StrikeWeap.NegativeA" )
    elseif weaponStage == 11 then
		SpawnWorm( 0, "wfRef_Tut4_3W1" )
		OrientateWorm(0,-90)
        -- drop old lady crate
        MakeDefaultBriefingBox( "TutAll.WeaponCrate.NegativeA" )
    elseif weaponStage == 12 then
		SpawnWorm(0, "wfRef_T3FireGrenL")
		OrientateWorm(0,70)
        -- old lady target
        MakeDefaultBriefingBox( "Tut3.Animals.NegativeANew" )
    elseif weaponStage == 13 then
		SpawnWorm( 0, "wfRef_Tut3_0W1" )
		OrientateWorm(0,50)
        -- drop ballista crate
        MakeDefaultBriefingBox( "TutAll.WeaponCrate.NegativeA" )
    elseif weaponStage == 14 then
		SpawnWorm( 0, "wfRef_T3Ballista" )
		OrientateWorm(0,0)
        -- firing ballista
        MakeDefaultBriefingBox( "Tut3.DirectFire.NegativeA" )
    end
	
--~ 	worm = GetWormData(0)
--~ 	if worm.Health <= 0 then
--~ 		EndRound(0)
--~ 	end
end

-- An empty CheckSuddenDeath function will cause
-- the game to never enter sudden death
function CheckSuddenDeath()
end

function MakeDefaultBriefingBox(String)
	if BriefingBoxIsOpen == false then
		SetBriefingBoxPosition(0,0) -- two variables set size and position of briefing box
		SetBriefingBoxSize(190,120)
		CreateBriefingBox(String)
		BriefingBoxIsOpen = true
	end
end

function EndingSequence()
	-- set up all the worms here
	SpawnWorm(1,"wfRef_Tut3_Outro3")
	SpawnWorm(2,"wfRef_Tut3_Outro1")
    SpawnWorm(3,"wfRef_Tut3_Outro2")
	OrientateWorm(1, -130)
	OrientateWorm(2, 90)
	OrientateWorm(3, 90)
	WormResetAnim(2)
	WormResetAnim(3)
	WormAllowIdleAnims(2,false)
	WormAllowIdleAnims(3,false)
	
	RemoveLeftHandBuildings()
	
	InGameCameras = false
	StartEFMV("OutroT3A",bQuitable)
	DelayCall("EndingSeq_T1", 1.5)
end

function EndingSeq_T1()
	SetCommentaryText("Tut3.Comment.1", 4000)
end

function EndingSeq_T2()
	SetCommentaryText("Tut3.Comment.2", 4000)
end

function EndingSeq_Anim_W1()
	WormResetAnim(1)
	WormQueueAnim(1,"worm_contemplates")
end

function EndingSeq_T3()
	SetCommentaryText("Tut3.Comment.3", 4000)
end

function EndingSeq_Anim_W2()
	WormResetAnim(2)
	WormQueueAnim(2,"worm_surveying")
end

function EndingSeq_Anim_W3()
	WormResetAnim(3)
	WormQueueAnim(3,"worm_grateful")
end

function EndMissionSuccess()
    Unlock("LOCK.Scheme.Crossbows")
    Unlock("LOCK.Tutorial.04")
    
    EndRound(0)
end
