
-- Tutorial 4
--
-- Gripes:
-- * When a worm dies and respawns, the briefing box pops up before the worm is placed back upon the landscape.
-- * Cameras galore still to add in.
-- * Worm taking fall damage at any point, either needs to be turned off or have dialogue box added.
-- * If Remus is killed currently nothing sorts this out, no dialogue box, etc.
-- * Would be nice to have a delay and a camera showing special buildings being built instead of dialogue box popping up almost instantly.
-- Bugs:

function InitialiseLevel()
    LoadLevel("landscapes/T/T2.xom",true)
    SetupDefaultScheme()

    PointInTutorial = 0         -- used to keep of track of the player's progression in the tutorials
    WhichCrate = 0              -- used to set the crate INDEX, not the crate ID
    WormHasJustDied = false     -- switch makes sure certain arguments don't occur when they shouldn't
    JetpackSectionRunning = false -- used as a switch to tell me when the Jetpack health crate collecting malarky is going on
    HealthCrateCounter = 0      -- used to count health crates
    SpecialsBuilt = 0           -- counts how many Special Buildings the player has built
    DeadEnemy = 0               -- counts how many of the three enemy worms die
	kJetpackRemoved = false		-- switch means two briefing boxes cannot open at once
    bQuitable = true
    InGameCameras = false       -- switch to see whether or not this is intro/outro or in-game
	
	BriefingBoxIsOpen = false	-- tells me whether or not we have a briefing box open
end

function CreatePlayers()
	SetupHumanPlayer(1,100)
    player.SpecialWeapon = "kNoSpecialWeapon"
    GetPlayerData(0).MaxJetpackFuel = 0
    GetWormData(player.PlayerIndex,0).SpawnPointName ="wfRef_Tut4_0W1"

	player = CreatePlayer("AI")
    player.NumberOfWorms = 1
    player.Name = "Remus"
    player.WormStartingHealth = 100
    player.VoiceBank = "Classic"
    player.SpecialWeapon = "kNoSpecialWeapon"
    player.Flag = 75
    CreatePlayersTeam(player.PlayerIndex)
    EmptyInventory(player.PlayerIndex);
	
	worm = GetWormData(1)
	worm.HatOverride = "Hat.Roman4"
	
    StandardWorm(GetWormData(1),"Remus","wfRef_Tut4_0W2")

    CreateStandardPlayer("AI",3,"Enemy Invaders","Classic")
    player.SpecialWeapon = "kNoSpecialWeapon"
	
	worm = GetWormData(2)
	worm.HatOverride = "Hat.Guinevere"
    StandardWorm(GetWormData(2),"Philly","wfRef_Tut4_Enemy1")
	
	worm = GetWormData(3)
	worm.HatOverride = "Hat.Roman1"
    StandardWorm(GetWormData(3),"Royce","wfRef_Tut4_Enemy2")
	
	worm = GetWormData(4)
	worm.HatOverride = "Hat.Helen"
    StandardWorm(GetWormData(4),"Heather","wfRef_Tut4_Enemy3")
    
    EmptyInventory(0)
	inventory.SkipGo = 0
	inventory.Surrender = 0

    EmptyInventory(1)

    scheme = GetCurrentSchemeData()
    scheme.TurnTime = 6000
    scheme.SuddenDeathTime = 0
    scheme.RetreatTime = 0
    scheme.HotSeatTime = 0
    scheme.HealthInCrates = 50
    scheme.CrateProbability = 0
    scheme.WeaponProbability = 0
    scheme.UtilityProbability = 0
    scheme.HealthProbability = 0

    StandardRefereeSettings()
    
    referee = GetRefereeData()
    referee.WindStrengthMinimum = 0.0
    referee.WindStrengthVariance = 0.0
	referee.ShowVictorySequence = false -- Turns the end of game worm celebrations off    

	SetVictorySequenceAllowed(false)
	
    SetupNeverEndingTurn(0,true)
	
	SetVictorySequenceAllowed(false)
	SetEFMVCameraShakeRatio(0.0)		-- command stops camera from shaking when buildings are created by the script
end

function HideWormsNow()
    HideWorm(2)
    HideWorm(3)
    HideWorm(4)

    TurnOffHudElement("Time", false)
    TurnOffHudElement("TeamStatus", false)
    TurnOffHudElement("GetReadyMsg", false)
    SetInstantReplaysOn(false)    -- no replays
    
	RemoveBuilding( "buildHere000" )
    CreateBuilding( kWF_BUILDING_STRONGHOLD, 0, "buildHere0021")
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere001")
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0020")
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0015")
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0022")
    CreateBuilding( kWF_BUILDING_TOWER, 0, "buildHere0010")
    CreateBuilding( kWF_BUILDING_KEEP, 0, "buildHere000")
    FlushCommentaryText()

    OrientateWorm(0,300)
    OrientateWorm(1,270)
    WormAllowIdleAnims(0,false)
    WormAllowIdleAnims(1,false)
	WormResetAnim(0)
	WormResetAnim(1)

	WormQueueAnim(1,"worm_puzzled")
	DelayCall("IntroT4A_Anim_W0", 2.5)
    StartEFMV("IntroT4A",bQuitable)
end

function OnEndEFMV(szSeqName, bUserQuit)
    if InGameCameras == false then
        if bUserQuit == 0 then
            if szSeqName == "IntroT4A" then
                StartEFMV("IntroT4C",bQuitable)
            elseif szSeqName == "IntroT4C" then
                StartEFMV("IntroT4D",bQuitable)
				DelayCall("IntroT4D_Text", 1.0)
            elseif szSeqName == "IntroT4D" then
                StartEFMV("IntroT4E",bQuitable)
				DelayCall("IntroT4E_Text", 0.5)
				DelayCall("Intro4E_Anims", 0.5)
            elseif szSeqName == "IntroT4E" then
                StartEFMV("IntroT4F",bQuitable)
				DelayCall("IntroT4F_Text", 0.8)
				DelayCall("IntroT4F_Anims", 1.7)
            elseif szSeqName == "IntroT4F" then
				BeginTutorial()
            elseif szSeqName == "OutroT4" then
                EndMissionSuccess()
            end
        elseif bUserQuit == 1 then
            if szSeqName == "IntroT4A" then
				CancelDelayCall("IntroT4A_Anim_W0")
				BeginTutorial()
			elseif szSeqName == "IntroT4C" then
				CancelDelayCall("IntroT4D_Text")
				BeginTutorial()
            elseif szSeqName == "IntroT4D" then
				CancelDelayCall("IntroT4E_Text")
				CancelDelayCall("Intro4E_Anims")
				BeginTutorial()
            elseif szSeqName == "IntroT4E" then
				CancelDelayCall("IntroT4F_Text")
				CancelDelayCall("IntroT4F_Anims")
				BeginTutorial()
            elseif szSeqName == "IntroT4F" then
                BeginTutorial()
            elseif szSeqName == "OutroT4" then
				CancelDelayCall("EndTut4Sequence")
				CancelDelayCall("EndSequenceText")
				CancelDelayCall("EndSequence_AnimateWorm2_1")
				CancelDelayCall("EndSequence_AnimateWorm2_2")
				CancelDelayCall("EndSequenceText_2")
                EndMissionSuccess()
            end
        end
    elseif InGameCameras == true then
        if bUserQuit == 0 then
            if szSeqName == "ClipT4D" then
                DelayCall("SectionAfterShowingLocationOfHealthCrates", 0.5)
            elseif szSeqName == "ClipT4A" then
                SectionAfterUtilityCrateSequenceEnds()
				kJetpackRemoved = false
            end
        elseif bUserQuit == 1 then
            if szSeqName == "ClipT4D" then
                DelayCall("SectionAfterShowingLocationOfHealthCrates", 0.5)
            elseif szSeqName == "ClipT4A" then
                SectionAfterUtilityCrateSequenceEnds()
				kJetpackRemoved = false
            end
        end
    end
end

function IntroT4A_Anim_W0()
	WormResetAnim(0)
	WormQueueAnim(0,"worm_wave1")
end

function IntroT4D_Text()
	SetCommentaryText("Tut4.Opening.Comment1", 4500)
end

function IntroT4E_Text()
	SetCommentaryText("Tut4.Opening.Comment2", 3500)
end

function Intro4E_Anims()
	WormResetAnim(0)
	WormQueueAnim(0,"worm_understandsfalse")
	WormResetAnim(1)
	WormQueueAnim(1,"worm_shakehead")
end

function IntroT4F_Text()
	SetCommentaryText("Tut4.Opening.Comment3", 3500)
end

function IntroT4F_Anims()
	WormResetAnim(1)
	WormQueueAnim(1,"worm_shakehead")
	WormResetAnim(0)
	WormQueueAnim(0,"worm_compose")
end

function SectionAfterShowingLocationOfHealthCrates()
    PointInTutorial = 3
    JetpackSectionRunning = true
    MakeDefaultBriefingBox("Tut4.Jetpack.3New")
end

function SectionAfterUtilityCrateSequenceEnds()
    PointInTutorial = 5
    DebugRun = true
    MakeDefaultBriefingBox("Tut4.Special.1New")
end

function BeginTutorial()
    WormResetAnim(0)
    WormResetAnim(1)
    WormAllowIdleAnims(0,false)
    WormAllowIdleAnims(1,false)
	OrientateWorm(0, 270)
	
	HideWorm(1)
	
    FlushCommentaryText()
    MakeDefaultBriefingBox("Tut4.Jetpack.1New")
    MakeWeaponCrate(1,"wfRef_T4UC1",kWF_UTILITY_JETPACK,kWF_INFINITE_AMOUNT,false,false)
    
    InGameCameras = true
end

function CrateCollected(CrateIndex,WormIndex)
    crate = GetCrateData(CrateIndex)
    
    if crate.CrateId == 1 then
        PointInTutorial = 2
        MakeDefaultBriefingBox("Tut4.Jetpack.2")
    end
    
    if PointInTutorial == 3 then
        HealthCrateCounter = HealthCrateCounter + 1
        
        if HealthCrateCounter == 5 then
            SetCommentaryText("Tut1.Firing.Comment2")
        elseif HealthCrateCounter == 6 then
            -- This where you want to remove the Jetpack
			RemoveJetpack()
			kJetpackRemoved = true
            DelayCall("ASmallDelay", 0.5)
        end
    end
end

function ASmallDelay()
    PointInTutorial = 4
    MakeDefaultBriefingBox("Tut4.Jetpack.4")
end

function OnExitBriefingBox()
	BriefingBoxIsOpen = false

    if WormHasJustDied == false then
        if PointInTutorial == 0 then
            PointInTutorial = 1
        elseif PointInTutorial == 2 then
            MakeHealthCratesForJetpackSection()
            DelayCall("Camera_ClipT4D", 0.2)
        elseif PointInTutorial == 4 then
            -- CAMERA: Show utility crates drop onto landscape
            MakeUtilityCratesForSpecialBuildingSection()
            FlushCommentaryText()
            DelayCall("Camera_ClipT4A", 0.2)
        elseif PointInTutorial == 5 and SpecialsBuilt == 4 then
            PointInTutorial = 6
            MakeDefaultBriefingBox("Tut4.Special.2")
        elseif PointInTutorial == 6 then
            PointInTutorial = 7
            MakeDefaultBriefingBox("Tut4.GodWeapon.1")
        elseif PointInTutorial == 7 then
			TurnOnArtilleryMode(0)
			
			EmptyInventory(0)
			inventory = GetPlayerInventory(0)
			inventory.SkipGo = 0
			inventory.Surrender = 0
			
            SpawnWorm(2,"wfRef_Tut4_Enemy1")
            SpawnWorm(3,"wfRef_Tut4_Enemy2")
            SpawnWorm(4,"wfRef_Tut4_Enemy3")
            OrientateWorm(2,180)
            OrientateWorm(3,220)
            OrientateWorm(4,225)
            WormAllowIdleAnims(2,false)
            WormAllowIdleAnims(3,false)
            WormAllowIdleAnims(4,false)
            
            FlushCommentaryText()
            
            DelayCall("Anims_ClipT4B_3", 0.5)
            DelayCall("Anims_ClipT4B_2", 1)
            DelayCall("Anims_ClipT4B_4", 1.5)
            DelayCall("Static_Camera_ClipT4B", 0.2)
        elseif PointInTutorial == 8 then
            EndSpecialCamera()
        elseif PointInTutorial == 9 then
            --EndSpecialCamera()
			EmptyInventory(0)
			inventory = GetPlayerInventory(0)
			inventory.SkipGo = 0
			inventory.Surrender = 0
			TurnOnArtilleryMode(0)
			FlushCommentaryText()
			OrientateWorm(1, 160)
			WormAllowIdleAnims(1, false)
			WormResetAnim(1)
			SpawnWorm(1,"wfRef_Tut4_OutroWorm")
			OrientateWorm(1, 160)
			DelayCall("EndTut4Sequence", 0.2)
			DelayCall("EndSequenceText", 1.0)
			DelayCall("EndSequence_AnimateWorm2_1", 1.5)
			DelayCall("EndSequence_AnimateWorm2_2", 5.5)
			DelayCall("EndSequenceText_2", 9.0)
        end
    end
    
    WormHasJustDied = false
end

function EndTut4Sequence()
    InGameCameras = false
    StartEFMV("OutroT4", bQuitable)
end

function EndSequenceText()    
    SetCommentaryText("Tut4.Ending.Comment1", 4000)
    SetCommentaryText("Tut4.Ending.Comment2", 4000)
end

function EndSequence_AnimateWorm2_1()
	WormResetAnim(1)
	WormQueueAnim(1,"worm_flutter")
end

function EndSequence_AnimateWorm2_2()
	WormResetAnim(1)
	WormQueueAnim(1,"worm_smug")
end

function EndSequenceText_2()
	SetCommentaryText("Tut4.Ending.Comment3", 4000)
end

function Camera_ClipT4A()
    StartEFMV("ClipT4A", bQuitable)
end

function Camera_ClipT4D()
    StartEFMV("ClipT4D",bQuitable)
end

function Static_Camera_ClipT4B()
    ShowBlackBorders()
    SetSpecialCamera("wfRef_Tut4_Enemy2", "wfRef_T4_EnemyCam")
    DelayCall("SectionAfterFloodIntroSequenceEnds", 4)
end

function SectionAfterFloodIntroSequenceEnds()
    EndSpecialCamera()
    RemoveBlackBorders()
    
    -- CAMERA: Shows weapon crate dropping in upon Keep
    PointInTutorial = 8

    WormAllowIdleAnims(2,true)
    WormAllowIdleAnims(3,true)
    WormAllowIdleAnims(4,true)
    WormResetAnim(2)
    WormResetAnim(3)
    WormResetAnim(4)
    
	TurnOffArtilleryMode(0)
	
	if IsWormWithinPhantom( 0, "pCubeKeepPhantom" ) == true then
		MakeWeaponCrate(12,"wfRef_T4WC2",kWF_WEAPON_FLOOD,1,false,false)
		MakeDefaultBriefingBox("Tut4.GodWeapon.2")
		SetSpecialCamera("wfRef_T4_FloodCrate2_LookAt", "wfRef_T4_FloodCrate2")
	else
		MakeWeaponCrate(12,"wfRef_T4WC1",kWF_WEAPON_FLOOD,1,false,false)
		MakeDefaultBriefingBox("Tut4.GodWeapon.2")
		SetSpecialCamera("wfRef_T4_FloodCrate_LookAt", "wfRef_T4_FloodCrate")
	end
end

function Anims_ClipT4B_2()
    WormResetAnim(2)
    WormQueueAnim(2,"Idle_surveying")
end

function Anims_ClipT4B_3()
    WormResetAnim(3)
    WormQueueAnim(3,"angry3")
end

function Anims_ClipT4B_4()
    WormResetAnim(4)
    WormQueueAnim(4,"worm_shakefist")
end

function MakeHealthCratesForJetpackSection()
    MakeHealthCrate(2,"wfRef_T4HC2")
    MakeHealthCrate(3,"wfRef_T4HC3")
    MakeHealthCrate(4,"wfRef_T4HC4")
    MakeHealthCrate(5,"wfRef_T4HC5")
    MakeHealthCrate(6,"wfRef_T4HC6")
    MakeHealthCrate(7,"wfRef_T4HC7")
end

function MakeUtilityCratesForSpecialBuildingSection()
    MakeWeaponCrate(8,"wfRef_T4UC2",kWF_BUILDING_HOSPITAL,1,true,true)
    MakeWeaponCrate(9,"wfRef_T4UC3",kWF_BUILDING_SCIENCE_LAB,1,true,true)
    MakeWeaponCrate(10,"wfRef_T4UC4",kWF_BUILDING_WONDER,1,true,true)
    MakeWeaponCrate(11,"wfRef_T4UC5",kWF_BUILDING_REFINERY,1,true,true)
end

function WormDiedInNeverEndingTurn()
end

function WormDied( WormIndex )
	if kJetpackRemoved == false then
		if WormIndex == 0 then      -- human worm dies
			WormHasJustDied = true
		
			if PointInTutorial == 1 then
				SpawnWorm(0,"wfRef_Tut4_0W1")
				MakeDefaultBriefingBox("TutAll.UtilityCrate.NegativeA")
			elseif PointInTutorial == 3 then
				SpawnWorm(0,"wfRef_Tut4_1W1")
				MakeDefaultBriefingBox("Tut4.Jetpack.NegativeANew")
			elseif PointInTutorial == 5 then
				SpawnWorm(0,"wfRef_Tut4_2W1")
				MakeDefaultBriefingBox("Tut4.Special.NegativeA")
			elseif PointInTutorial == 8 then
				SpawnWorm(0,"wfRef_Tut4_3W1")
				MakeDefaultBriefingBox("Tut4.GodWeapon.NegativeA")
			end
		end
	elseif kJetpackRemoved == true then
		kJetpackRemoved = false
		SpawnWorm(0,"wfRef_Tut4_2W1")
	end
end

function WeaponExpired( weaponId, playerId, wormId )
	if PointInTutorial == 8 then
	
		-- SPP Check if the flood has been used, not just selected and then cancelled
		inventory = GetPlayerInventory( 0)
		
		if inventory.Flood == 0 then	
			DelayCall("kDelay_WeaponExpired", 1.0)
		end
	end
end

function kDelay_WeaponExpired()
	PointInTutorial = 9
	MakeDefaultBriefingBox("Tut4.GodWeapon.3")
	SetSpecialCamera("wfRef_Tut4_Enemy2", "wfRef_T4_EnemyCam")
end

function BuildingHasBeenBuilt( PlayerId, BuildingType )
    if BuildingType == kWF_BUILDING_HOSPITAL then
        SpecialsBuilt = SpecialsBuilt + 1
        MakeDefaultBriefingBox("Tut4.Special.HospitalNew")
    elseif BuildingType == kWF_BUILDING_REFINERY then
        SpecialsBuilt = SpecialsBuilt + 1
        MakeDefaultBriefingBox("Tut4.Special.WeapFactNew")
    elseif BuildingType == kWF_BUILDING_SCIENCE_LAB then
        SpecialsBuilt = SpecialsBuilt + 1
        MakeDefaultBriefingBox("Tut4.Special.ScienceNew")
    elseif BuildingType == kWF_BUILDING_WONDER then
        SpecialsBuilt = SpecialsBuilt + 1
        MakeDefaultBriefingBox("Tut4.Special.WonderNew2")
    end
end


-- ********************************************************************************************************
-- *                                            ENGINE ROOM!!                                             *
-- ********************************************************************************************************

function CheckSuddenDeath()
end

function CheckVictoryConditions()
    return false
end

function SetNextPlayerToGo( playerIndex )
    if playerIndex > 0 then
        return 0
    end
    
    return playerIndex
end

function SetNextWormToGo( playerIndex, wormIndex )
    if wormIndex > 0 then
        return 0
    end

    return wormIndex
end

function EndMissionSuccess()
    Unlock("LOCK.Speech.Monarch")
    Unlock("LOCK.Tutorial.05")

    EndRound(0)
end

function EndMissionFail()
    EndRound(1)
end

function MakeHealthCrate(CrateId,CrateString)
    crate = CreateCrate(kWF_UTILITY_HEALTH)
    crate.Contents = kWF_UTILITY_HEALTH -- what is in the crate.
    crate.HealthInCrate = 5		-- amount of health in a health crate, if set to negative uses the current scheme's CrateHealth
    crate.TeamDestructible = -1		-- -1 for all teams, otherwise the index of the team
    crate.WormCollectable = -1		-- -1 for all worms otherwise the index of the worm
    crate.TeamCollectable = 0		-- -1 for all teams, otherwise the index of the team
    crate.GroundSnap = false		-- set to true for crate to be placed on the ground below spawn point.
    crate.FixedPosition = true		-- set to true, crate will not move i.e. stays at spawn point
    crate.UXB = false			-- whether crate is booby trapped
    crate.Destructible = false		-- whether crate can be destroyed.
    crate.Pushable = false		-- whether crate can be moved by weapons.
    crate.CollectableByPayload = false	-- whether crate can be collected by roaming rounds e.g. rhino
    crate.Collectable = true		-- whether crate can be collected
    crate.IsCritical = true             -- mmm, shiny graphical effect
    crate.CrateId = CrateId
    SpawnCrate(WhichCrate,CrateString)
    WhichCrate = WhichCrate + 1
end

function MakeWeaponCrate(CrateId,CrateString,CrateContents,CrateAmmo,CrateFixed,CrateCritical)
    crate = CreateCrate(CrateContents)
    crate.Contents = CrateContents
    crate.NumContents = CrateAmmo
    crate.TeamDestructible = -1
    crate.WormCollectable = -1
    crate.TeamCollectable = 0
    crate.GroundSnap = false
    crate.FixedPosition = CrateFixed
    crate.UXB = false
    crate.Destructible = false
    crate.Pushable = false
    crate.CollectableByPayload = false
    crate.Collectable = true
    crate.IsCritical = CrateCritical    -- mmm, shiny graphical effect
    crate.CrateId = CrateId
    SpawnCrate(WhichCrate,CrateString)
    WhichCrate = WhichCrate + 1
end

function MakeDefaultBriefingBox(String)
	if BriefingBoxIsOpen == false then
		SetBriefingBoxPosition(0,0) -- two variables set size and position of briefing box
		SetBriefingBoxSize(190,120)
		CreateBriefingBox(String)
		BriefingBoxIsOpen = true
	end
end

function MakeMine(IndexNo,String)
    mine = CreateMine()
    mine.Fuse = 5.0
    mine.RandomFuse = false
    mine.Dud = false
    mine.GroundSnap = true
    mine.Index = IndexNo
    SpawnMine(String,mine) 
end


function TurnOnArtilleryMode()
    PlayerWorm = GetWormData(0)
    PlayerWorm.ArtilleryMode = true
end

function TurnOffArtilleryMode()
    PlayerWorm = GetWormData(0)
    PlayerWorm.ArtilleryMode = false
end
